#define INTTMP 0x0300ff00
#define INTVAR 0x40ff0000
#define FLTTMP 0x000f0ff0
#define FLTVAR 0xfff00000

#define INTRET 0x00000004
#define FLTRET 0x00000003

#define readsreg(p) \
	(generic((p)->op)==INDIR && (p)->kids[0]->op==VREG+P)

#define relink(a, b) ((b)->x.prev = (a), (a)->x.next = (b))

#include "c.h"
#define NODEPTR_TYPE Node
#define OP_LABEL(p) ((p)->op)
#define LEFT_CHILD(p) ((p)->kids[0])
#define RIGHT_CHILD(p) ((p)->kids[1])
#define STATE_LABEL(p) ((p)->x.state)
static void address     ARGS((Symbol, Symbol, int));
static void blkfetch    ARGS((int, int, int, int));
static void blkloop     ARGS((int, int, int, int, int, int[]));
static void blkstore    ARGS((int, int, int, int));
static void defaddress  ARGS((Symbol));
static void defconst    ARGS((int, Value));
static void defstring   ARGS((int, char *));
static void defsymbol   ARGS((Symbol));
static void doarg       ARGS((Node));
static void emit2       ARGS((Node));
static void export      ARGS((Symbol));
static void clobber     ARGS((Node));
static void function    ARGS((Symbol, Symbol [], Symbol [], int));
static void global      ARGS((Symbol));
static void import      ARGS((Symbol));
static void local       ARGS((Symbol));
static void progbeg     ARGS((int, char **));
static void progend     ARGS((void));
static void segment     ARGS((int));
static void space       ARGS((int));
static void target      ARGS((Node));
extern int      atoi            ARGS((char *));
static int      bitcount        ARGS((unsigned));
static Symbol   argreg          ARGS((int, int, int, int));

static Symbol ireg[32], freg2[32], d6;
static int tmpregs[] = {3, 9, 10};
static Symbol blkreg;

static int gnum = 8;

static int cseg;
static char *_templates[] = {
/*   0 */  0,
/*   1 */  "# read register\n",  /* reg: INDIRC(VREGP) */
/*   2 */  "# read register\n",  /* reg: INDIRD(VREGP) */
/*   3 */  "# read register\n",  /* reg: INDIRF(VREGP) */
/*   4 */  "# read register\n",  /* reg: INDIRI(VREGP) */
/*   5 */  "# read register\n",  /* reg: INDIRP(VREGP) */
/*   6 */  "# read register\n",  /* reg: INDIRS(VREGP) */
/*   7 */  "# write register\n",  /* stmt: ASGNC(VREGP,reg) */
/*   8 */  "# write register\n",  /* stmt: ASGND(VREGP,reg) */
/*   9 */  "# write register\n",  /* stmt: ASGNF(VREGP,reg) */
/*  10 */  "# write register\n",  /* stmt: ASGNI(VREGP,reg) */
/*  11 */  "# write register\n",  /* stmt: ASGNP(VREGP,reg) */
/*  12 */  "# write register\n",  /* stmt: ASGNS(VREGP,reg) */
/*  13 */  "%a",  /* con: CNSTC */
/*  14 */  "%a",  /* con: CNSTI */
/*  15 */  "%a",  /* con: CNSTP */
/*  16 */  "%a",  /* con: CNSTS */
/*  17 */  "%a",  /* con: CNSTU */
/*  18 */  "",  /* stmt: reg */
/*  19 */  "%0",  /* reg: CVIU(reg) */
/*  20 */  "%0",  /* reg: CVPU(reg) */
/*  21 */  "%0",  /* reg: CVUI(reg) */
/*  22 */  "%0",  /* reg: CVUP(reg) */
/*  23 */  "%0",  /* acon: con */
/*  24 */  "%a",  /* acon: ADDRGP */
/*  25 */  "%1($%0)",  /* addr: ADDI(reg,acon) */
/*  26 */  "%1($%0)",  /* addr: ADDU(reg,acon) */
/*  27 */  "%1($%0)",  /* addr: ADDP(reg,acon) */
/*  28 */  "%0",  /* addr: acon */
/*  29 */  "($%0)",  /* addr: reg */
/*  30 */  "%a+%F($sp)",  /* addr: ADDRFP */
/*  31 */  "%a+%F($sp)",  /* addr: ADDRLP */
/*  32 */  "la $%c,%0\n",  /* reg: addr */
/*  33 */  "# reg\n",  /* reg: CNSTC */
/*  34 */  "# reg\n",  /* reg: CNSTS */
/*  35 */  "# reg\n",  /* reg: CNSTI */
/*  36 */  "# reg\n",  /* reg: CNSTU */
/*  37 */  "# reg\n",  /* reg: CNSTP */
/*  38 */  "sb $%1,%0\n",  /* stmt: ASGNC(addr,reg) */
/*  39 */  "sh $%1,%0\n",  /* stmt: ASGNS(addr,reg) */
/*  40 */  "sw $%1,%0\n",  /* stmt: ASGNI(addr,reg) */
/*  41 */  "sw $%1,%0\n",  /* stmt: ASGNP(addr,reg) */
/*  42 */  "lb $%c,%0\n",  /* reg: INDIRC(addr) */
/*  43 */  "lh $%c,%0\n",  /* reg: INDIRS(addr) */
/*  44 */  "lw $%c,%0\n",  /* reg: INDIRI(addr) */
/*  45 */  "lw $%c,%0\n",  /* reg: INDIRP(addr) */
/*  46 */  "lb $%c,%0\n",  /* reg: CVCI(INDIRC(addr)) */
/*  47 */  "lh $%c,%0\n",  /* reg: CVSI(INDIRS(addr)) */
/*  48 */  "lbu $%c,%0\n",  /* reg: CVCU(INDIRC(addr)) */
/*  49 */  "lhu $%c,%0\n",  /* reg: CVSU(INDIRS(addr)) */
/*  50 */  "l.d $f%c,%0\n",  /* reg: INDIRD(addr) */
/*  51 */  "l.s $f%c,%0\n",  /* reg: INDIRF(addr) */
/*  52 */  "s.d $f%1,%0\n",  /* stmt: ASGND(addr,reg) */
/*  53 */  "s.s $f%1,%0\n",  /* stmt: ASGNF(addr,reg) */
/*  54 */  "div $%c,$%0,$%1\n",  /* reg: DIVI(reg,reg) */
/*  55 */  "divu $%c,$%0,$%1\n",  /* reg: DIVU(reg,reg) */
/*  56 */  "rem $%c,$%0,$%1\n",  /* reg: MODI(reg,reg) */
/*  57 */  "remu $%c,$%0,$%1\n",  /* reg: MODU(reg,reg) */
/*  58 */  "mul $%c,$%0,$%1\n",  /* reg: MULI(reg,reg) */
/*  59 */  "mul $%c,$%0,$%1\n",  /* reg: MULU(reg,reg) */
/*  60 */  "%0",  /* rc: con */
/*  61 */  "$%0",  /* rc: reg */
/*  62 */  "addu $%c,$%0,%1\n",  /* reg: ADDI(reg,rc) */
/*  63 */  "addu $%c,$%0,%1\n",  /* reg: ADDP(reg,rc) */
/*  64 */  "addu $%c,$%0,%1\n",  /* reg: ADDU(reg,rc) */
/*  65 */  "and $%c,$%0,%1\n",  /* reg: BANDU(reg,rc) */
/*  66 */  "or $%c,$%0,%1\n",  /* reg: BORU(reg,rc) */
/*  67 */  "xor $%c,$%0,%1\n",  /* reg: BXORU(reg,rc) */
/*  68 */  "subu $%c,$%0,%1\n",  /* reg: SUBI(reg,rc) */
/*  69 */  "subu $%c,$%0,%1\n",  /* reg: SUBP(reg,rc) */
/*  70 */  "subu $%c,$%0,%1\n",  /* reg: SUBU(reg,rc) */
/*  71 */  "%a",  /* rc5: CNSTI */
/*  72 */  "$%0",  /* rc5: reg */
/*  73 */  "sll $%c,$%0,%1\n",  /* reg: LSHI(reg,rc5) */
/*  74 */  "sll $%c,$%0,%1\n",  /* reg: LSHU(reg,rc5) */
/*  75 */  "sra $%c,$%0,%1\n",  /* reg: RSHI(reg,rc5) */
/*  76 */  "srl $%c,$%0,%1\n",  /* reg: RSHU(reg,rc5) */
/*  77 */  "not $%c,$%0\n",  /* reg: BCOMU(reg) */
/*  78 */  "negu $%c,$%0\n",  /* reg: NEGI(reg) */
/*  79 */  "move $%c,$%0\n",  /* reg: LOADC(reg) */
/*  80 */  "move $%c,$%0\n",  /* reg: LOADS(reg) */
/*  81 */  "move $%c,$%0\n",  /* reg: LOADI(reg) */
/*  82 */  "move $%c,$%0\n",  /* reg: LOADP(reg) */
/*  83 */  "move $%c,$%0\n",  /* reg: LOADU(reg) */
/*  84 */  "add.d $f%c,$f%0,$f%1\n",  /* reg: ADDD(reg,reg) */
/*  85 */  "add.s $f%c,$f%0,$f%1\n",  /* reg: ADDF(reg,reg) */
/*  86 */  "div.d $f%c,$f%0,$f%1\n",  /* reg: DIVD(reg,reg) */
/*  87 */  "div.s $f%c,$f%0,$f%1\n",  /* reg: DIVF(reg,reg) */
/*  88 */  "mul.d $f%c,$f%0,$f%1\n",  /* reg: MULD(reg,reg) */
/*  89 */  "mul.s $f%c,$f%0,$f%1\n",  /* reg: MULF(reg,reg) */
/*  90 */  "sub.d $f%c,$f%0,$f%1\n",  /* reg: SUBD(reg,reg) */
/*  91 */  "sub.s $f%c,$f%0,$f%1\n",  /* reg: SUBF(reg,reg) */
/*  92 */  "mov.d $f%c,$f%0\n",  /* reg: LOADD(reg) */
/*  93 */  "mov.s $f%c,$f%0\n",  /* reg: LOADF(reg) */
/*  94 */  "neg.d $f%c,$f%0\n",  /* reg: NEGD(reg) */
/*  95 */  "neg.s $f%c,$f%0\n",  /* reg: NEGF(reg) */
/*  96 */  "sll $%c,$%0,24; sra $%c,$%c,24\n",  /* reg: CVCI(reg) */
/*  97 */  "sll $%c,$%0,16; sra $%c,$%c,16\n",  /* reg: CVSI(reg) */
/*  98 */  "and $%c,$%0,0xff\n",  /* reg: CVCU(reg) */
/*  99 */  "and $%c,$%0,0xffff\n",  /* reg: CVSU(reg) */
/* 100 */  "%0",  /* reg: CVIC(reg) */
/* 101 */  "%0",  /* reg: CVIS(reg) */
/* 102 */  "%0",  /* reg: CVUC(reg) */
/* 103 */  "%0",  /* reg: CVUS(reg) */
/* 104 */  "move $%c,$%0\n",  /* reg: CVIC(reg) */
/* 105 */  "move $%c,$%0\n",  /* reg: CVIS(reg) */
/* 106 */  "move $%c,$%0\n",  /* reg: CVIU(reg) */
/* 107 */  "move $%c,$%0\n",  /* reg: CVPU(reg) */
/* 108 */  "move $%c,$%0\n",  /* reg: CVUC(reg) */
/* 109 */  "move $%c,$%0\n",  /* reg: CVUI(reg) */
/* 110 */  "move $%c,$%0\n",  /* reg: CVUP(reg) */
/* 111 */  "move $%c,$%0\n",  /* reg: CVUS(reg) */
/* 112 */  "cvt.s.d $f%c,$f%0\n",  /* reg: CVDF(reg) */
/* 113 */  "cvt.d.s $f%c,$f%0\n",  /* reg: CVFD(reg) */
/* 114 */  "mtc1 $%0,$f%c; cvt.d.w $f%c,$f%c\n",  /* reg: CVID(reg) */
/* 115 */  "trunc.w.d $f2,$f%0,$%c; mfc1 $%c,$f2\n",  /* reg: CVDI(reg) */
/* 116 */  "%a:\n",  /* stmt: LABELV */
/* 117 */  "b %0\n",  /* stmt: JUMPV(acon) */
/* 118 */  "j $%0\n",  /* stmt: JUMPV(reg) */
/* 119 */  "beq $%0,$%1,%a\n",  /* stmt: EQI(reg,reg) */
/* 120 */  "bge $%0,$%1,%a\n",  /* stmt: GEI(reg,reg) */
/* 121 */  "bgeu $%0,$%1,%a\n",  /* stmt: GEU(reg,reg) */
/* 122 */  "bgt $%0,$%1,%a\n",  /* stmt: GTI(reg,reg) */
/* 123 */  "bgtu $%0,$%1,%a\n",  /* stmt: GTU(reg,reg) */
/* 124 */  "ble $%0,$%1,%a\n",  /* stmt: LEI(reg,reg) */
/* 125 */  "bleu $%0,$%1,%a\n",  /* stmt: LEU(reg,reg) */
/* 126 */  "blt $%0,$%1,%a\n",  /* stmt: LTI(reg,reg) */
/* 127 */  "bltu $%0,$%1,%a\n",  /* stmt: LTU(reg,reg) */
/* 128 */  "bne $%0,$%1,%a\n",  /* stmt: NEI(reg,reg) */
/* 129 */  "c.eq.d $f%0,$f%1; bc1t %a\n",  /* stmt: EQD(reg,reg) */
/* 130 */  "c.eq.s $f%0,$f%1; bc1t %a\n",  /* stmt: EQF(reg,reg) */
/* 131 */  "c.le.d $f%0,$f%1; bc1t %a\n",  /* stmt: LED(reg,reg) */
/* 132 */  "c.le.s $f%0,$f%1; bc1t %a\n",  /* stmt: LEF(reg,reg) */
/* 133 */  "c.lt.d $f%0,$f%1; bc1t %a\n",  /* stmt: LTD(reg,reg) */
/* 134 */  "c.lt.s $f%0,$f%1; bc1t %a\n",  /* stmt: LTF(reg,reg) */
/* 135 */  "c.lt.d $f%0,$f%1; bc1f %a\n",  /* stmt: GED(reg,reg) */
/* 136 */  "c.lt.s $f%0,$f%1; bc1f %a\n",  /* stmt: GEF(reg,reg) */
/* 137 */  "c.le.d $f%0,$f%1; bc1f %a\n",  /* stmt: GTD(reg,reg) */
/* 138 */  "c.le.s $f%0,$f%1; bc1f %a\n",  /* stmt: GTF(reg,reg) */
/* 139 */  "c.eq.d $f%0,$f%1; bc1f %a\n",  /* stmt: NED(reg,reg) */
/* 140 */  "c.eq.s $f%0,$f%1; bc1f %a\n",  /* stmt: NEF(reg,reg) */
/* 141 */  "%a",  /* ar: ADDRGP */
/* 142 */  "jal %0\n",  /* reg: CALLD(ar) */
/* 143 */  "jal %0\n",  /* reg: CALLF(ar) */
/* 144 */  "jal %0\n",  /* reg: CALLI(ar) */
/* 145 */  "jal %0\n",  /* stmt: CALLV(ar) */
/* 146 */  "$%0",  /* ar: reg */
/* 147 */  "%a",  /* ar: CNSTP */
/* 148 */  "# ret\n",  /* stmt: RETD(reg) */
/* 149 */  "# ret\n",  /* stmt: RETF(reg) */
/* 150 */  "# ret\n",  /* stmt: RETI(reg) */
/* 151 */  "# arg\n",  /* stmt: ARGD(reg) */
/* 152 */  "# arg\n",  /* stmt: ARGF(reg) */
/* 153 */  "# arg\n",  /* stmt: ARGI(reg) */
/* 154 */  "# arg\n",  /* stmt: ARGP(reg) */
/* 155 */  "# argb %0\n",  /* stmt: ARGB(INDIRB(reg)) */
/* 156 */  "# asgnb %0 %1\n",  /* stmt: ASGNB(reg,INDIRB(reg)) */
};

static char _isinstruction[] = {
/*   0 */  0,
/*   1 */  1,/* # read register\n */
/*   2 */  1,/* # read register\n */
/*   3 */  1,/* # read register\n */
/*   4 */  1,/* # read register\n */
/*   5 */  1,/* # read register\n */
/*   6 */  1,/* # read register\n */
/*   7 */  1,/* # write register\n */
/*   8 */  1,/* # write register\n */
/*   9 */  1,/* # write register\n */
/*  10 */  1,/* # write register\n */
/*  11 */  1,/* # write register\n */
/*  12 */  1,/* # write register\n */
/*  13 */  0,/* %a */
/*  14 */  0,/* %a */
/*  15 */  0,/* %a */
/*  16 */  0,/* %a */
/*  17 */  0,/* %a */
/*  18 */  0,/*  */
/*  19 */  0,/* %0 */
/*  20 */  0,/* %0 */
/*  21 */  0,/* %0 */
/*  22 */  0,/* %0 */
/*  23 */  0,/* %0 */
/*  24 */  0,/* %a */
/*  25 */  0,/* %1($%0) */
/*  26 */  0,/* %1($%0) */
/*  27 */  0,/* %1($%0) */
/*  28 */  0,/* %0 */
/*  29 */  0,/* ($%0) */
/*  30 */  0,/* %a+%F($sp) */
/*  31 */  0,/* %a+%F($sp) */
/*  32 */  1,/* la $%c,%0\n */
/*  33 */  1,/* # reg\n */
/*  34 */  1,/* # reg\n */
/*  35 */  1,/* # reg\n */
/*  36 */  1,/* # reg\n */
/*  37 */  1,/* # reg\n */
/*  38 */  1,/* sb $%1,%0\n */
/*  39 */  1,/* sh $%1,%0\n */
/*  40 */  1,/* sw $%1,%0\n */
/*  41 */  1,/* sw $%1,%0\n */
/*  42 */  1,/* lb $%c,%0\n */
/*  43 */  1,/* lh $%c,%0\n */
/*  44 */  1,/* lw $%c,%0\n */
/*  45 */  1,/* lw $%c,%0\n */
/*  46 */  1,/* lb $%c,%0\n */
/*  47 */  1,/* lh $%c,%0\n */
/*  48 */  1,/* lbu $%c,%0\n */
/*  49 */  1,/* lhu $%c,%0\n */
/*  50 */  1,/* l.d $f%c,%0\n */
/*  51 */  1,/* l.s $f%c,%0\n */
/*  52 */  1,/* s.d $f%1,%0\n */
/*  53 */  1,/* s.s $f%1,%0\n */
/*  54 */  1,/* div $%c,$%0,$%1\n */
/*  55 */  1,/* divu $%c,$%0,$%1\n */
/*  56 */  1,/* rem $%c,$%0,$%1\n */
/*  57 */  1,/* remu $%c,$%0,$%1\n */
/*  58 */  1,/* mul $%c,$%0,$%1\n */
/*  59 */  1,/* mul $%c,$%0,$%1\n */
/*  60 */  0,/* %0 */
/*  61 */  0,/* $%0 */
/*  62 */  1,/* addu $%c,$%0,%1\n */
/*  63 */  1,/* addu $%c,$%0,%1\n */
/*  64 */  1,/* addu $%c,$%0,%1\n */
/*  65 */  1,/* and $%c,$%0,%1\n */
/*  66 */  1,/* or $%c,$%0,%1\n */
/*  67 */  1,/* xor $%c,$%0,%1\n */
/*  68 */  1,/* subu $%c,$%0,%1\n */
/*  69 */  1,/* subu $%c,$%0,%1\n */
/*  70 */  1,/* subu $%c,$%0,%1\n */
/*  71 */  0,/* %a */
/*  72 */  0,/* $%0 */
/*  73 */  1,/* sll $%c,$%0,%1\n */
/*  74 */  1,/* sll $%c,$%0,%1\n */
/*  75 */  1,/* sra $%c,$%0,%1\n */
/*  76 */  1,/* srl $%c,$%0,%1\n */
/*  77 */  1,/* not $%c,$%0\n */
/*  78 */  1,/* negu $%c,$%0\n */
/*  79 */  1,/* move $%c,$%0\n */
/*  80 */  1,/* move $%c,$%0\n */
/*  81 */  1,/* move $%c,$%0\n */
/*  82 */  1,/* move $%c,$%0\n */
/*  83 */  1,/* move $%c,$%0\n */
/*  84 */  1,/* add.d $f%c,$f%0,$f%1\n */
/*  85 */  1,/* add.s $f%c,$f%0,$f%1\n */
/*  86 */  1,/* div.d $f%c,$f%0,$f%1\n */
/*  87 */  1,/* div.s $f%c,$f%0,$f%1\n */
/*  88 */  1,/* mul.d $f%c,$f%0,$f%1\n */
/*  89 */  1,/* mul.s $f%c,$f%0,$f%1\n */
/*  90 */  1,/* sub.d $f%c,$f%0,$f%1\n */
/*  91 */  1,/* sub.s $f%c,$f%0,$f%1\n */
/*  92 */  1,/* mov.d $f%c,$f%0\n */
/*  93 */  1,/* mov.s $f%c,$f%0\n */
/*  94 */  1,/* neg.d $f%c,$f%0\n */
/*  95 */  1,/* neg.s $f%c,$f%0\n */
/*  96 */  1,/* sll $%c,$%0,24; sra $%c,$%c,24\n */
/*  97 */  1,/* sll $%c,$%0,16; sra $%c,$%c,16\n */
/*  98 */  1,/* and $%c,$%0,0xff\n */
/*  99 */  1,/* and $%c,$%0,0xffff\n */
/* 100 */  0,/* %0 */
/* 101 */  0,/* %0 */
/* 102 */  0,/* %0 */
/* 103 */  0,/* %0 */
/* 104 */  1,/* move $%c,$%0\n */
/* 105 */  1,/* move $%c,$%0\n */
/* 106 */  1,/* move $%c,$%0\n */
/* 107 */  1,/* move $%c,$%0\n */
/* 108 */  1,/* move $%c,$%0\n */
/* 109 */  1,/* move $%c,$%0\n */
/* 110 */  1,/* move $%c,$%0\n */
/* 111 */  1,/* move $%c,$%0\n */
/* 112 */  1,/* cvt.s.d $f%c,$f%0\n */
/* 113 */  1,/* cvt.d.s $f%c,$f%0\n */
/* 114 */  1,/* mtc1 $%0,$f%c; cvt.d.w $f%c,$f%c\n */
/* 115 */  1,/* trunc.w.d $f2,$f%0,$%c; mfc1 $%c,$f2\n */
/* 116 */  1,/* %a:\n */
/* 117 */  1,/* b %0\n */
/* 118 */  1,/* j $%0\n */
/* 119 */  1,/* beq $%0,$%1,%a\n */
/* 120 */  1,/* bge $%0,$%1,%a\n */
/* 121 */  1,/* bgeu $%0,$%1,%a\n */
/* 122 */  1,/* bgt $%0,$%1,%a\n */
/* 123 */  1,/* bgtu $%0,$%1,%a\n */
/* 124 */  1,/* ble $%0,$%1,%a\n */
/* 125 */  1,/* bleu $%0,$%1,%a\n */
/* 126 */  1,/* blt $%0,$%1,%a\n */
/* 127 */  1,/* bltu $%0,$%1,%a\n */
/* 128 */  1,/* bne $%0,$%1,%a\n */
/* 129 */  1,/* c.eq.d $f%0,$f%1; bc1t %a\n */
/* 130 */  1,/* c.eq.s $f%0,$f%1; bc1t %a\n */
/* 131 */  1,/* c.le.d $f%0,$f%1; bc1t %a\n */
/* 132 */  1,/* c.le.s $f%0,$f%1; bc1t %a\n */
/* 133 */  1,/* c.lt.d $f%0,$f%1; bc1t %a\n */
/* 134 */  1,/* c.lt.s $f%0,$f%1; bc1t %a\n */
/* 135 */  1,/* c.lt.d $f%0,$f%1; bc1f %a\n */
/* 136 */  1,/* c.lt.s $f%0,$f%1; bc1f %a\n */
/* 137 */  1,/* c.le.d $f%0,$f%1; bc1f %a\n */
/* 138 */  1,/* c.le.s $f%0,$f%1; bc1f %a\n */
/* 139 */  1,/* c.eq.d $f%0,$f%1; bc1f %a\n */
/* 140 */  1,/* c.eq.s $f%0,$f%1; bc1f %a\n */
/* 141 */  0,/* %a */
/* 142 */  1,/* jal %0\n */
/* 143 */  1,/* jal %0\n */
/* 144 */  1,/* jal %0\n */
/* 145 */  1,/* jal %0\n */
/* 146 */  0,/* $%0 */
/* 147 */  0,/* %a */
/* 148 */  1,/* # ret\n */
/* 149 */  1,/* # ret\n */
/* 150 */  1,/* # ret\n */
/* 151 */  1,/* # arg\n */
/* 152 */  1,/* # arg\n */
/* 153 */  1,/* # arg\n */
/* 154 */  1,/* # arg\n */
/* 155 */  1,/* # argb %0\n */
/* 156 */  1,/* # asgnb %0 %1\n */
};

static void _kids ARGS((NODEPTR_TYPE, int, NODEPTR_TYPE[]));
static void _label ARGS((NODEPTR_TYPE));
static int _rule ARGS((void*, int));
#define _stmt_NT 1
#define _acon_NT 2
#define _addr_NT 3
#define _ar_NT 4
#define _con_NT 5
#define _rc_NT 6
#define _rc5_NT 7
#define _reg_NT 8

static char *_ntname[] = {
	0,
	"stmt",
	"acon",
	"addr",
	"ar",
	"con",
	"rc",
	"rc5",
	"reg",
	0
};

static char _arity[] = {
	0,
	0,  /* 1 */
	0,  /* 2 */
	0,  /* 3 */
	0,  /* 4 */
	0,  /* 5 */
	0,  /* 6 */
	0,  /* 7 */
	0,  /* 8 */
	0,  /* 9 */
	0,  /* 10 */
	0,  /* 11 */
	0,  /* 12 */
	0,  /* 13 */
	0,  /* 14 */
	0,  /* 15 */
	0,  /* 16 */
	0,  /* 17=CNSTF */
	0,  /* 18=CNSTD */
	0,  /* 19=CNSTC */
	0,  /* 20=CNSTS */
	0,  /* 21=CNSTI */
	0,  /* 22=CNSTU */
	0,  /* 23=CNSTP */
	0,  /* 24 */
	0,  /* 25 */
	0,  /* 26 */
	0,  /* 27 */
	0,  /* 28 */
	0,  /* 29 */
	0,  /* 30 */
	0,  /* 31 */
	0,  /* 32 */
	1,  /* 33=ARGF */
	1,  /* 34=ARGD */
	0,  /* 35 */
	0,  /* 36 */
	1,  /* 37=ARGI */
	0,  /* 38 */
	1,  /* 39=ARGP */
	0,  /* 40 */
	1,  /* 41=ARGB */
	0,  /* 42 */
	0,  /* 43 */
	0,  /* 44 */
	0,  /* 45 */
	0,  /* 46 */
	0,  /* 47 */
	0,  /* 48 */
	2,  /* 49=ASGNF */
	2,  /* 50=ASGND */
	2,  /* 51=ASGNC */
	2,  /* 52=ASGNS */
	2,  /* 53=ASGNI */
	0,  /* 54 */
	2,  /* 55=ASGNP */
	0,  /* 56 */
	2,  /* 57=ASGNB */
	0,  /* 58 */
	0,  /* 59 */
	0,  /* 60 */
	0,  /* 61 */
	0,  /* 62 */
	0,  /* 63 */
	0,  /* 64 */
	1,  /* 65=INDIRF */
	1,  /* 66=INDIRD */
	1,  /* 67=INDIRC */
	1,  /* 68=INDIRS */
	1,  /* 69=INDIRI */
	0,  /* 70 */
	1,  /* 71=INDIRP */
	0,  /* 72 */
	1,  /* 73=INDIRB */
	0,  /* 74 */
	0,  /* 75 */
	0,  /* 76 */
	0,  /* 77 */
	0,  /* 78 */
	0,  /* 79 */
	0,  /* 80 */
	0,  /* 81 */
	0,  /* 82 */
	0,  /* 83 */
	0,  /* 84 */
	1,  /* 85=CVCI */
	1,  /* 86=CVCU */
	0,  /* 87 */
	0,  /* 88 */
	0,  /* 89 */
	0,  /* 90 */
	0,  /* 91 */
	0,  /* 92 */
	0,  /* 93 */
	0,  /* 94 */
	0,  /* 95 */
	0,  /* 96 */
	1,  /* 97=CVDF */
	0,  /* 98 */
	0,  /* 99 */
	0,  /* 100 */
	1,  /* 101=CVDI */
	0,  /* 102 */
	0,  /* 103 */
	0,  /* 104 */
	0,  /* 105 */
	0,  /* 106 */
	0,  /* 107 */
	0,  /* 108 */
	0,  /* 109 */
	0,  /* 110 */
	0,  /* 111 */
	0,  /* 112 */
	0,  /* 113 */
	1,  /* 114=CVFD */
	0,  /* 115 */
	0,  /* 116 */
	0,  /* 117 */
	0,  /* 118 */
	0,  /* 119 */
	0,  /* 120 */
	0,  /* 121 */
	0,  /* 122 */
	0,  /* 123 */
	0,  /* 124 */
	0,  /* 125 */
	0,  /* 126 */
	0,  /* 127 */
	0,  /* 128 */
	0,  /* 129 */
	1,  /* 130=CVID */
	1,  /* 131=CVIC */
	1,  /* 132=CVIS */
	0,  /* 133 */
	1,  /* 134=CVIU */
	0,  /* 135 */
	0,  /* 136 */
	0,  /* 137 */
	0,  /* 138 */
	0,  /* 139 */
	0,  /* 140 */
	0,  /* 141 */
	0,  /* 142 */
	0,  /* 143 */
	0,  /* 144 */
	0,  /* 145 */
	0,  /* 146 */
	0,  /* 147 */
	0,  /* 148 */
	0,  /* 149 */
	1,  /* 150=CVPU */
	0,  /* 151 */
	0,  /* 152 */
	0,  /* 153 */
	0,  /* 154 */
	0,  /* 155 */
	0,  /* 156 */
	0,  /* 157 */
	0,  /* 158 */
	0,  /* 159 */
	0,  /* 160 */
	0,  /* 161 */
	0,  /* 162 */
	0,  /* 163 */
	0,  /* 164 */
	1,  /* 165=CVSI */
	1,  /* 166=CVSU */
	0,  /* 167 */
	0,  /* 168 */
	0,  /* 169 */
	0,  /* 170 */
	0,  /* 171 */
	0,  /* 172 */
	0,  /* 173 */
	0,  /* 174 */
	0,  /* 175 */
	0,  /* 176 */
	0,  /* 177 */
	0,  /* 178 */
	1,  /* 179=CVUC */
	1,  /* 180=CVUS */
	1,  /* 181=CVUI */
	0,  /* 182 */
	1,  /* 183=CVUP */
	0,  /* 184 */
	0,  /* 185 */
	0,  /* 186 */
	0,  /* 187 */
	0,  /* 188 */
	0,  /* 189 */
	0,  /* 190 */
	0,  /* 191 */
	0,  /* 192 */
	1,  /* 193=NEGF */
	1,  /* 194=NEGD */
	0,  /* 195 */
	0,  /* 196 */
	1,  /* 197=NEGI */
	0,  /* 198 */
	0,  /* 199 */
	0,  /* 200 */
	0,  /* 201 */
	0,  /* 202 */
	0,  /* 203 */
	0,  /* 204 */
	0,  /* 205 */
	0,  /* 206 */
	0,  /* 207 */
	0,  /* 208 */
	1,  /* 209=CALLF */
	1,  /* 210=CALLD */
	0,  /* 211 */
	0,  /* 212 */
	1,  /* 213=CALLI */
	0,  /* 214 */
	0,  /* 215 */
	1,  /* 216=CALLV */
	0,  /* 217=CALLB */
	0,  /* 218 */
	0,  /* 219 */
	0,  /* 220 */
	0,  /* 221 */
	0,  /* 222 */
	0,  /* 223 */
	0,  /* 224 */
	1,  /* 225=LOADF */
	1,  /* 226=LOADD */
	1,  /* 227=LOADC */
	1,  /* 228=LOADS */
	1,  /* 229=LOADI */
	1,  /* 230=LOADU */
	1,  /* 231=LOADP */
	0,  /* 232 */
	0,  /* 233=LOADB */
	0,  /* 234 */
	0,  /* 235 */
	0,  /* 236 */
	0,  /* 237 */
	0,  /* 238 */
	0,  /* 239 */
	0,  /* 240 */
	1,  /* 241=RETF */
	1,  /* 242=RETD */
	0,  /* 243 */
	0,  /* 244 */
	1,  /* 245=RETI */
	0,  /* 246 */
	0,  /* 247 */
	0,  /* 248 */
	0,  /* 249 */
	0,  /* 250 */
	0,  /* 251 */
	0,  /* 252 */
	0,  /* 253 */
	0,  /* 254 */
	0,  /* 255 */
	0,  /* 256 */
	0,  /* 257 */
	0,  /* 258 */
	0,  /* 259 */
	0,  /* 260 */
	0,  /* 261 */
	0,  /* 262 */
	0,  /* 263=ADDRGP */
	0,  /* 264 */
	0,  /* 265 */
	0,  /* 266 */
	0,  /* 267 */
	0,  /* 268 */
	0,  /* 269 */
	0,  /* 270 */
	0,  /* 271 */
	0,  /* 272 */
	0,  /* 273 */
	0,  /* 274 */
	0,  /* 275 */
	0,  /* 276 */
	0,  /* 277 */
	0,  /* 278 */
	0,  /* 279=ADDRFP */
	0,  /* 280 */
	0,  /* 281 */
	0,  /* 282 */
	0,  /* 283 */
	0,  /* 284 */
	0,  /* 285 */
	0,  /* 286 */
	0,  /* 287 */
	0,  /* 288 */
	0,  /* 289 */
	0,  /* 290 */
	0,  /* 291 */
	0,  /* 292 */
	0,  /* 293 */
	0,  /* 294 */
	0,  /* 295=ADDRLP */
	0,  /* 296 */
	0,  /* 297 */
	0,  /* 298 */
	0,  /* 299 */
	0,  /* 300 */
	0,  /* 301 */
	0,  /* 302 */
	0,  /* 303 */
	0,  /* 304 */
	2,  /* 305=ADDF */
	2,  /* 306=ADDD */
	0,  /* 307 */
	0,  /* 308 */
	2,  /* 309=ADDI */
	2,  /* 310=ADDU */
	2,  /* 311=ADDP */
	0,  /* 312 */
	0,  /* 313 */
	0,  /* 314 */
	0,  /* 315 */
	0,  /* 316 */
	0,  /* 317 */
	0,  /* 318 */
	0,  /* 319 */
	0,  /* 320 */
	2,  /* 321=SUBF */
	2,  /* 322=SUBD */
	0,  /* 323 */
	0,  /* 324 */
	2,  /* 325=SUBI */
	2,  /* 326=SUBU */
	2,  /* 327=SUBP */
	0,  /* 328 */
	0,  /* 329 */
	0,  /* 330 */
	0,  /* 331 */
	0,  /* 332 */
	0,  /* 333 */
	0,  /* 334 */
	0,  /* 335 */
	0,  /* 336 */
	0,  /* 337 */
	0,  /* 338 */
	0,  /* 339 */
	0,  /* 340 */
	2,  /* 341=LSHI */
	2,  /* 342=LSHU */
	0,  /* 343 */
	0,  /* 344 */
	0,  /* 345 */
	0,  /* 346 */
	0,  /* 347 */
	0,  /* 348 */
	0,  /* 349 */
	0,  /* 350 */
	0,  /* 351 */
	0,  /* 352 */
	0,  /* 353 */
	0,  /* 354 */
	0,  /* 355 */
	0,  /* 356 */
	2,  /* 357=MODI */
	2,  /* 358=MODU */
	0,  /* 359 */
	0,  /* 360 */
	0,  /* 361 */
	0,  /* 362 */
	0,  /* 363 */
	0,  /* 364 */
	0,  /* 365 */
	0,  /* 366 */
	0,  /* 367 */
	0,  /* 368 */
	0,  /* 369 */
	0,  /* 370 */
	0,  /* 371 */
	0,  /* 372 */
	2,  /* 373=RSHI */
	2,  /* 374=RSHU */
	0,  /* 375 */
	0,  /* 376 */
	0,  /* 377 */
	0,  /* 378 */
	0,  /* 379 */
	0,  /* 380 */
	0,  /* 381 */
	0,  /* 382 */
	0,  /* 383 */
	0,  /* 384 */
	0,  /* 385 */
	0,  /* 386 */
	0,  /* 387 */
	0,  /* 388 */
	0,  /* 389 */
	2,  /* 390=BANDU */
	0,  /* 391 */
	0,  /* 392 */
	0,  /* 393 */
	0,  /* 394 */
	0,  /* 395 */
	0,  /* 396 */
	0,  /* 397 */
	0,  /* 398 */
	0,  /* 399 */
	0,  /* 400 */
	0,  /* 401 */
	0,  /* 402 */
	0,  /* 403 */
	0,  /* 404 */
	0,  /* 405 */
	1,  /* 406=BCOMU */
	0,  /* 407 */
	0,  /* 408 */
	0,  /* 409 */
	0,  /* 410 */
	0,  /* 411 */
	0,  /* 412 */
	0,  /* 413 */
	0,  /* 414 */
	0,  /* 415 */
	0,  /* 416 */
	0,  /* 417 */
	0,  /* 418 */
	0,  /* 419 */
	0,  /* 420 */
	0,  /* 421 */
	2,  /* 422=BORU */
	0,  /* 423 */
	0,  /* 424 */
	0,  /* 425 */
	0,  /* 426 */
	0,  /* 427 */
	0,  /* 428 */
	0,  /* 429 */
	0,  /* 430 */
	0,  /* 431 */
	0,  /* 432 */
	0,  /* 433 */
	0,  /* 434 */
	0,  /* 435 */
	0,  /* 436 */
	0,  /* 437 */
	2,  /* 438=BXORU */
	0,  /* 439 */
	0,  /* 440 */
	0,  /* 441 */
	0,  /* 442 */
	0,  /* 443 */
	0,  /* 444 */
	0,  /* 445 */
	0,  /* 446 */
	0,  /* 447 */
	0,  /* 448 */
	2,  /* 449=DIVF */
	2,  /* 450=DIVD */
	0,  /* 451 */
	0,  /* 452 */
	2,  /* 453=DIVI */
	2,  /* 454=DIVU */
	0,  /* 455 */
	0,  /* 456 */
	0,  /* 457 */
	0,  /* 458 */
	0,  /* 459 */
	0,  /* 460 */
	0,  /* 461 */
	0,  /* 462 */
	0,  /* 463 */
	0,  /* 464 */
	2,  /* 465=MULF */
	2,  /* 466=MULD */
	0,  /* 467 */
	0,  /* 468 */
	2,  /* 469=MULI */
	2,  /* 470=MULU */
	0,  /* 471 */
	0,  /* 472 */
	0,  /* 473 */
	0,  /* 474 */
	0,  /* 475 */
	0,  /* 476 */
	0,  /* 477 */
	0,  /* 478 */
	0,  /* 479 */
	0,  /* 480 */
	2,  /* 481=EQF */
	2,  /* 482=EQD */
	0,  /* 483 */
	0,  /* 484 */
	2,  /* 485=EQI */
	0,  /* 486 */
	0,  /* 487 */
	0,  /* 488 */
	0,  /* 489 */
	0,  /* 490 */
	0,  /* 491 */
	0,  /* 492 */
	0,  /* 493 */
	0,  /* 494 */
	0,  /* 495 */
	0,  /* 496 */
	2,  /* 497=GEF */
	2,  /* 498=GED */
	0,  /* 499 */
	0,  /* 500 */
	2,  /* 501=GEI */
	2,  /* 502=GEU */
	0,  /* 503 */
	0,  /* 504 */
	0,  /* 505 */
	0,  /* 506 */
	0,  /* 507 */
	0,  /* 508 */
	0,  /* 509 */
	0,  /* 510 */
	0,  /* 511 */
	0,  /* 512 */
	2,  /* 513=GTF */
	2,  /* 514=GTD */
	0,  /* 515 */
	0,  /* 516 */
	2,  /* 517=GTI */
	2,  /* 518=GTU */
	0,  /* 519 */
	0,  /* 520 */
	0,  /* 521 */
	0,  /* 522 */
	0,  /* 523 */
	0,  /* 524 */
	0,  /* 525 */
	0,  /* 526 */
	0,  /* 527 */
	0,  /* 528 */
	2,  /* 529=LEF */
	2,  /* 530=LED */
	0,  /* 531 */
	0,  /* 532 */
	2,  /* 533=LEI */
	2,  /* 534=LEU */
	0,  /* 535 */
	0,  /* 536 */
	0,  /* 537 */
	0,  /* 538 */
	0,  /* 539 */
	0,  /* 540 */
	0,  /* 541 */
	0,  /* 542 */
	0,  /* 543 */
	0,  /* 544 */
	2,  /* 545=LTF */
	2,  /* 546=LTD */
	0,  /* 547 */
	0,  /* 548 */
	2,  /* 549=LTI */
	2,  /* 550=LTU */
	0,  /* 551 */
	0,  /* 552 */
	0,  /* 553 */
	0,  /* 554 */
	0,  /* 555 */
	0,  /* 556 */
	0,  /* 557 */
	0,  /* 558 */
	0,  /* 559 */
	0,  /* 560 */
	2,  /* 561=NEF */
	2,  /* 562=NED */
	0,  /* 563 */
	0,  /* 564 */
	2,  /* 565=NEI */
	0,  /* 566 */
	0,  /* 567 */
	0,  /* 568 */
	0,  /* 569 */
	0,  /* 570 */
	0,  /* 571 */
	0,  /* 572 */
	0,  /* 573 */
	0,  /* 574 */
	0,  /* 575 */
	0,  /* 576 */
	0,  /* 577 */
	0,  /* 578 */
	0,  /* 579 */
	0,  /* 580 */
	0,  /* 581 */
	0,  /* 582 */
	0,  /* 583 */
	1,  /* 584=JUMPV */
	0,  /* 585 */
	0,  /* 586 */
	0,  /* 587 */
	0,  /* 588 */
	0,  /* 589 */
	0,  /* 590 */
	0,  /* 591 */
	0,  /* 592 */
	0,  /* 593 */
	0,  /* 594 */
	0,  /* 595 */
	0,  /* 596 */
	0,  /* 597 */
	0,  /* 598 */
	0,  /* 599 */
	0,  /* 600=LABELV */
	0,  /* 601 */
	0,  /* 602 */
	0,  /* 603 */
	0,  /* 604 */
	0,  /* 605 */
	0,  /* 606 */
	0,  /* 607 */
	0,  /* 608 */
	0,  /* 609 */
	0,  /* 610 */
	0,  /* 611 */
	0,  /* 612 */
	0,  /* 613 */
	0,  /* 614 */
	0,  /* 615=VREGP */
};

static char *_opname[] = {
	0,
	0,  /* 1 */
	0,  /* 2 */
	0,  /* 3 */
	0,  /* 4 */
	0,  /* 5 */
	0,  /* 6 */
	0,  /* 7 */
	0,  /* 8 */
	0,  /* 9 */
	0,  /* 10 */
	0,  /* 11 */
	0,  /* 12 */
	0,  /* 13 */
	0,  /* 14 */
	0,  /* 15 */
	0,  /* 16 */
	"CNSTF",  /* 17 */
	"CNSTD",  /* 18 */
	"CNSTC",  /* 19 */
	"CNSTS",  /* 20 */
	"CNSTI",  /* 21 */
	"CNSTU",  /* 22 */
	"CNSTP",  /* 23 */
	0,  /* 24 */
	0,  /* 25 */
	0,  /* 26 */
	0,  /* 27 */
	0,  /* 28 */
	0,  /* 29 */
	0,  /* 30 */
	0,  /* 31 */
	0,  /* 32 */
	"ARGF",  /* 33 */
	"ARGD",  /* 34 */
	0,  /* 35 */
	0,  /* 36 */
	"ARGI",  /* 37 */
	0,  /* 38 */
	"ARGP",  /* 39 */
	0,  /* 40 */
	"ARGB",  /* 41 */
	0,  /* 42 */
	0,  /* 43 */
	0,  /* 44 */
	0,  /* 45 */
	0,  /* 46 */
	0,  /* 47 */
	0,  /* 48 */
	"ASGNF",  /* 49 */
	"ASGND",  /* 50 */
	"ASGNC",  /* 51 */
	"ASGNS",  /* 52 */
	"ASGNI",  /* 53 */
	0,  /* 54 */
	"ASGNP",  /* 55 */
	0,  /* 56 */
	"ASGNB",  /* 57 */
	0,  /* 58 */
	0,  /* 59 */
	0,  /* 60 */
	0,  /* 61 */
	0,  /* 62 */
	0,  /* 63 */
	0,  /* 64 */
	"INDIRF",  /* 65 */
	"INDIRD",  /* 66 */
	"INDIRC",  /* 67 */
	"INDIRS",  /* 68 */
	"INDIRI",  /* 69 */
	0,  /* 70 */
	"INDIRP",  /* 71 */
	0,  /* 72 */
	"INDIRB",  /* 73 */
	0,  /* 74 */
	0,  /* 75 */
	0,  /* 76 */
	0,  /* 77 */
	0,  /* 78 */
	0,  /* 79 */
	0,  /* 80 */
	0,  /* 81 */
	0,  /* 82 */
	0,  /* 83 */
	0,  /* 84 */
	"CVCI",  /* 85 */
	"CVCU",  /* 86 */
	0,  /* 87 */
	0,  /* 88 */
	0,  /* 89 */
	0,  /* 90 */
	0,  /* 91 */
	0,  /* 92 */
	0,  /* 93 */
	0,  /* 94 */
	0,  /* 95 */
	0,  /* 96 */
	"CVDF",  /* 97 */
	0,  /* 98 */
	0,  /* 99 */
	0,  /* 100 */
	"CVDI",  /* 101 */
	0,  /* 102 */
	0,  /* 103 */
	0,  /* 104 */
	0,  /* 105 */
	0,  /* 106 */
	0,  /* 107 */
	0,  /* 108 */
	0,  /* 109 */
	0,  /* 110 */
	0,  /* 111 */
	0,  /* 112 */
	0,  /* 113 */
	"CVFD",  /* 114 */
	0,  /* 115 */
	0,  /* 116 */
	0,  /* 117 */
	0,  /* 118 */
	0,  /* 119 */
	0,  /* 120 */
	0,  /* 121 */
	0,  /* 122 */
	0,  /* 123 */
	0,  /* 124 */
	0,  /* 125 */
	0,  /* 126 */
	0,  /* 127 */
	0,  /* 128 */
	0,  /* 129 */
	"CVID",  /* 130 */
	"CVIC",  /* 131 */
	"CVIS",  /* 132 */
	0,  /* 133 */
	"CVIU",  /* 134 */
	0,  /* 135 */
	0,  /* 136 */
	0,  /* 137 */
	0,  /* 138 */
	0,  /* 139 */
	0,  /* 140 */
	0,  /* 141 */
	0,  /* 142 */
	0,  /* 143 */
	0,  /* 144 */
	0,  /* 145 */
	0,  /* 146 */
	0,  /* 147 */
	0,  /* 148 */
	0,  /* 149 */
	"CVPU",  /* 150 */
	0,  /* 151 */
	0,  /* 152 */
	0,  /* 153 */
	0,  /* 154 */
	0,  /* 155 */
	0,  /* 156 */
	0,  /* 157 */
	0,  /* 158 */
	0,  /* 159 */
	0,  /* 160 */
	0,  /* 161 */
	0,  /* 162 */
	0,  /* 163 */
	0,  /* 164 */
	"CVSI",  /* 165 */
	"CVSU",  /* 166 */
	0,  /* 167 */
	0,  /* 168 */
	0,  /* 169 */
	0,  /* 170 */
	0,  /* 171 */
	0,  /* 172 */
	0,  /* 173 */
	0,  /* 174 */
	0,  /* 175 */
	0,  /* 176 */
	0,  /* 177 */
	0,  /* 178 */
	"CVUC",  /* 179 */
	"CVUS",  /* 180 */
	"CVUI",  /* 181 */
	0,  /* 182 */
	"CVUP",  /* 183 */
	0,  /* 184 */
	0,  /* 185 */
	0,  /* 186 */
	0,  /* 187 */
	0,  /* 188 */
	0,  /* 189 */
	0,  /* 190 */
	0,  /* 191 */
	0,  /* 192 */
	"NEGF",  /* 193 */
	"NEGD",  /* 194 */
	0,  /* 195 */
	0,  /* 196 */
	"NEGI",  /* 197 */
	0,  /* 198 */
	0,  /* 199 */
	0,  /* 200 */
	0,  /* 201 */
	0,  /* 202 */
	0,  /* 203 */
	0,  /* 204 */
	0,  /* 205 */
	0,  /* 206 */
	0,  /* 207 */
	0,  /* 208 */
	"CALLF",  /* 209 */
	"CALLD",  /* 210 */
	0,  /* 211 */
	0,  /* 212 */
	"CALLI",  /* 213 */
	0,  /* 214 */
	0,  /* 215 */
	"CALLV",  /* 216 */
	"CALLB",  /* 217 */
	0,  /* 218 */
	0,  /* 219 */
	0,  /* 220 */
	0,  /* 221 */
	0,  /* 222 */
	0,  /* 223 */
	0,  /* 224 */
	"LOADF",  /* 225 */
	"LOADD",  /* 226 */
	"LOADC",  /* 227 */
	"LOADS",  /* 228 */
	"LOADI",  /* 229 */
	"LOADU",  /* 230 */
	"LOADP",  /* 231 */
	0,  /* 232 */
	"LOADB",  /* 233 */
	0,  /* 234 */
	0,  /* 235 */
	0,  /* 236 */
	0,  /* 237 */
	0,  /* 238 */
	0,  /* 239 */
	0,  /* 240 */
	"RETF",  /* 241 */
	"RETD",  /* 242 */
	0,  /* 243 */
	0,  /* 244 */
	"RETI",  /* 245 */
	0,  /* 246 */
	0,  /* 247 */
	0,  /* 248 */
	0,  /* 249 */
	0,  /* 250 */
	0,  /* 251 */
	0,  /* 252 */
	0,  /* 253 */
	0,  /* 254 */
	0,  /* 255 */
	0,  /* 256 */
	0,  /* 257 */
	0,  /* 258 */
	0,  /* 259 */
	0,  /* 260 */
	0,  /* 261 */
	0,  /* 262 */
	"ADDRGP",  /* 263 */
	0,  /* 264 */
	0,  /* 265 */
	0,  /* 266 */
	0,  /* 267 */
	0,  /* 268 */
	0,  /* 269 */
	0,  /* 270 */
	0,  /* 271 */
	0,  /* 272 */
	0,  /* 273 */
	0,  /* 274 */
	0,  /* 275 */
	0,  /* 276 */
	0,  /* 277 */
	0,  /* 278 */
	"ADDRFP",  /* 279 */
	0,  /* 280 */
	0,  /* 281 */
	0,  /* 282 */
	0,  /* 283 */
	0,  /* 284 */
	0,  /* 285 */
	0,  /* 286 */
	0,  /* 287 */
	0,  /* 288 */
	0,  /* 289 */
	0,  /* 290 */
	0,  /* 291 */
	0,  /* 292 */
	0,  /* 293 */
	0,  /* 294 */
	"ADDRLP",  /* 295 */
	0,  /* 296 */
	0,  /* 297 */
	0,  /* 298 */
	0,  /* 299 */
	0,  /* 300 */
	0,  /* 301 */
	0,  /* 302 */
	0,  /* 303 */
	0,  /* 304 */
	"ADDF",  /* 305 */
	"ADDD",  /* 306 */
	0,  /* 307 */
	0,  /* 308 */
	"ADDI",  /* 309 */
	"ADDU",  /* 310 */
	"ADDP",  /* 311 */
	0,  /* 312 */
	0,  /* 313 */
	0,  /* 314 */
	0,  /* 315 */
	0,  /* 316 */
	0,  /* 317 */
	0,  /* 318 */
	0,  /* 319 */
	0,  /* 320 */
	"SUBF",  /* 321 */
	"SUBD",  /* 322 */
	0,  /* 323 */
	0,  /* 324 */
	"SUBI",  /* 325 */
	"SUBU",  /* 326 */
	"SUBP",  /* 327 */
	0,  /* 328 */
	0,  /* 329 */
	0,  /* 330 */
	0,  /* 331 */
	0,  /* 332 */
	0,  /* 333 */
	0,  /* 334 */
	0,  /* 335 */
	0,  /* 336 */
	0,  /* 337 */
	0,  /* 338 */
	0,  /* 339 */
	0,  /* 340 */
	"LSHI",  /* 341 */
	"LSHU",  /* 342 */
	0,  /* 343 */
	0,  /* 344 */
	0,  /* 345 */
	0,  /* 346 */
	0,  /* 347 */
	0,  /* 348 */
	0,  /* 349 */
	0,  /* 350 */
	0,  /* 351 */
	0,  /* 352 */
	0,  /* 353 */
	0,  /* 354 */
	0,  /* 355 */
	0,  /* 356 */
	"MODI",  /* 357 */
	"MODU",  /* 358 */
	0,  /* 359 */
	0,  /* 360 */
	0,  /* 361 */
	0,  /* 362 */
	0,  /* 363 */
	0,  /* 364 */
	0,  /* 365 */
	0,  /* 366 */
	0,  /* 367 */
	0,  /* 368 */
	0,  /* 369 */
	0,  /* 370 */
	0,  /* 371 */
	0,  /* 372 */
	"RSHI",  /* 373 */
	"RSHU",  /* 374 */
	0,  /* 375 */
	0,  /* 376 */
	0,  /* 377 */
	0,  /* 378 */
	0,  /* 379 */
	0,  /* 380 */
	0,  /* 381 */
	0,  /* 382 */
	0,  /* 383 */
	0,  /* 384 */
	0,  /* 385 */
	0,  /* 386 */
	0,  /* 387 */
	0,  /* 388 */
	0,  /* 389 */
	"BANDU",  /* 390 */
	0,  /* 391 */
	0,  /* 392 */
	0,  /* 393 */
	0,  /* 394 */
	0,  /* 395 */
	0,  /* 396 */
	0,  /* 397 */
	0,  /* 398 */
	0,  /* 399 */
	0,  /* 400 */
	0,  /* 401 */
	0,  /* 402 */
	0,  /* 403 */
	0,  /* 404 */
	0,  /* 405 */
	"BCOMU",  /* 406 */
	0,  /* 407 */
	0,  /* 408 */
	0,  /* 409 */
	0,  /* 410 */
	0,  /* 411 */
	0,  /* 412 */
	0,  /* 413 */
	0,  /* 414 */
	0,  /* 415 */
	0,  /* 416 */
	0,  /* 417 */
	0,  /* 418 */
	0,  /* 419 */
	0,  /* 420 */
	0,  /* 421 */
	"BORU",  /* 422 */
	0,  /* 423 */
	0,  /* 424 */
	0,  /* 425 */
	0,  /* 426 */
	0,  /* 427 */
	0,  /* 428 */
	0,  /* 429 */
	0,  /* 430 */
	0,  /* 431 */
	0,  /* 432 */
	0,  /* 433 */
	0,  /* 434 */
	0,  /* 435 */
	0,  /* 436 */
	0,  /* 437 */
	"BXORU",  /* 438 */
	0,  /* 439 */
	0,  /* 440 */
	0,  /* 441 */
	0,  /* 442 */
	0,  /* 443 */
	0,  /* 444 */
	0,  /* 445 */
	0,  /* 446 */
	0,  /* 447 */
	0,  /* 448 */
	"DIVF",  /* 449 */
	"DIVD",  /* 450 */
	0,  /* 451 */
	0,  /* 452 */
	"DIVI",  /* 453 */
	"DIVU",  /* 454 */
	0,  /* 455 */
	0,  /* 456 */
	0,  /* 457 */
	0,  /* 458 */
	0,  /* 459 */
	0,  /* 460 */
	0,  /* 461 */
	0,  /* 462 */
	0,  /* 463 */
	0,  /* 464 */
	"MULF",  /* 465 */
	"MULD",  /* 466 */
	0,  /* 467 */
	0,  /* 468 */
	"MULI",  /* 469 */
	"MULU",  /* 470 */
	0,  /* 471 */
	0,  /* 472 */
	0,  /* 473 */
	0,  /* 474 */
	0,  /* 475 */
	0,  /* 476 */
	0,  /* 477 */
	0,  /* 478 */
	0,  /* 479 */
	0,  /* 480 */
	"EQF",  /* 481 */
	"EQD",  /* 482 */
	0,  /* 483 */
	0,  /* 484 */
	"EQI",  /* 485 */
	0,  /* 486 */
	0,  /* 487 */
	0,  /* 488 */
	0,  /* 489 */
	0,  /* 490 */
	0,  /* 491 */
	0,  /* 492 */
	0,  /* 493 */
	0,  /* 494 */
	0,  /* 495 */
	0,  /* 496 */
	"GEF",  /* 497 */
	"GED",  /* 498 */
	0,  /* 499 */
	0,  /* 500 */
	"GEI",  /* 501 */
	"GEU",  /* 502 */
	0,  /* 503 */
	0,  /* 504 */
	0,  /* 505 */
	0,  /* 506 */
	0,  /* 507 */
	0,  /* 508 */
	0,  /* 509 */
	0,  /* 510 */
	0,  /* 511 */
	0,  /* 512 */
	"GTF",  /* 513 */
	"GTD",  /* 514 */
	0,  /* 515 */
	0,  /* 516 */
	"GTI",  /* 517 */
	"GTU",  /* 518 */
	0,  /* 519 */
	0,  /* 520 */
	0,  /* 521 */
	0,  /* 522 */
	0,  /* 523 */
	0,  /* 524 */
	0,  /* 525 */
	0,  /* 526 */
	0,  /* 527 */
	0,  /* 528 */
	"LEF",  /* 529 */
	"LED",  /* 530 */
	0,  /* 531 */
	0,  /* 532 */
	"LEI",  /* 533 */
	"LEU",  /* 534 */
	0,  /* 535 */
	0,  /* 536 */
	0,  /* 537 */
	0,  /* 538 */
	0,  /* 539 */
	0,  /* 540 */
	0,  /* 541 */
	0,  /* 542 */
	0,  /* 543 */
	0,  /* 544 */
	"LTF",  /* 545 */
	"LTD",  /* 546 */
	0,  /* 547 */
	0,  /* 548 */
	"LTI",  /* 549 */
	"LTU",  /* 550 */
	0,  /* 551 */
	0,  /* 552 */
	0,  /* 553 */
	0,  /* 554 */
	0,  /* 555 */
	0,  /* 556 */
	0,  /* 557 */
	0,  /* 558 */
	0,  /* 559 */
	0,  /* 560 */
	"NEF",  /* 561 */
	"NED",  /* 562 */
	0,  /* 563 */
	0,  /* 564 */
	"NEI",  /* 565 */
	0,  /* 566 */
	0,  /* 567 */
	0,  /* 568 */
	0,  /* 569 */
	0,  /* 570 */
	0,  /* 571 */
	0,  /* 572 */
	0,  /* 573 */
	0,  /* 574 */
	0,  /* 575 */
	0,  /* 576 */
	0,  /* 577 */
	0,  /* 578 */
	0,  /* 579 */
	0,  /* 580 */
	0,  /* 581 */
	0,  /* 582 */
	0,  /* 583 */
	"JUMPV",  /* 584 */
	0,  /* 585 */
	0,  /* 586 */
	0,  /* 587 */
	0,  /* 588 */
	0,  /* 589 */
	0,  /* 590 */
	0,  /* 591 */
	0,  /* 592 */
	0,  /* 593 */
	0,  /* 594 */
	0,  /* 595 */
	0,  /* 596 */
	0,  /* 597 */
	0,  /* 598 */
	0,  /* 599 */
	"LABELV",  /* 600 */
	0,  /* 601 */
	0,  /* 602 */
	0,  /* 603 */
	0,  /* 604 */
	0,  /* 605 */
	0,  /* 606 */
	0,  /* 607 */
	0,  /* 608 */
	0,  /* 609 */
	0,  /* 610 */
	0,  /* 611 */
	0,  /* 612 */
	0,  /* 613 */
	0,  /* 614 */
	"VREGP",  /* 615 */
};

static char *_string[] = {
	0,
	"reg: INDIRC(VREGP)",  /* 1 */
	"reg: INDIRD(VREGP)",  /* 2 */
	"reg: INDIRF(VREGP)",  /* 3 */
	"reg: INDIRI(VREGP)",  /* 4 */
	"reg: INDIRP(VREGP)",  /* 5 */
	"reg: INDIRS(VREGP)",  /* 6 */
	"stmt: ASGNC(VREGP,reg)",  /* 7 */
	"stmt: ASGND(VREGP,reg)",  /* 8 */
	"stmt: ASGNF(VREGP,reg)",  /* 9 */
	"stmt: ASGNI(VREGP,reg)",  /* 10 */
	"stmt: ASGNP(VREGP,reg)",  /* 11 */
	"stmt: ASGNS(VREGP,reg)",  /* 12 */
	"con: CNSTC",  /* 13 */
	"con: CNSTI",  /* 14 */
	"con: CNSTP",  /* 15 */
	"con: CNSTS",  /* 16 */
	"con: CNSTU",  /* 17 */
	"stmt: reg",  /* 18 */
	"reg: CVIU(reg)",  /* 19 */
	"reg: CVPU(reg)",  /* 20 */
	"reg: CVUI(reg)",  /* 21 */
	"reg: CVUP(reg)",  /* 22 */
	"acon: con",  /* 23 */
	"acon: ADDRGP",  /* 24 */
	"addr: ADDI(reg,acon)",  /* 25 */
	"addr: ADDU(reg,acon)",  /* 26 */
	"addr: ADDP(reg,acon)",  /* 27 */
	"addr: acon",  /* 28 */
	"addr: reg",  /* 29 */
	"addr: ADDRFP",  /* 30 */
	"addr: ADDRLP",  /* 31 */
	"reg: addr",  /* 32 */
	"reg: CNSTC",  /* 33 */
	"reg: CNSTS",  /* 34 */
	"reg: CNSTI",  /* 35 */
	"reg: CNSTU",  /* 36 */
	"reg: CNSTP",  /* 37 */
	"stmt: ASGNC(addr,reg)",  /* 38 */
	"stmt: ASGNS(addr,reg)",  /* 39 */
	"stmt: ASGNI(addr,reg)",  /* 40 */
	"stmt: ASGNP(addr,reg)",  /* 41 */
	"reg: INDIRC(addr)",  /* 42 */
	"reg: INDIRS(addr)",  /* 43 */
	"reg: INDIRI(addr)",  /* 44 */
	"reg: INDIRP(addr)",  /* 45 */
	"reg: CVCI(INDIRC(addr))",  /* 46 */
	"reg: CVSI(INDIRS(addr))",  /* 47 */
	"reg: CVCU(INDIRC(addr))",  /* 48 */
	"reg: CVSU(INDIRS(addr))",  /* 49 */
	"reg: INDIRD(addr)",  /* 50 */
	"reg: INDIRF(addr)",  /* 51 */
	"stmt: ASGND(addr,reg)",  /* 52 */
	"stmt: ASGNF(addr,reg)",  /* 53 */
	"reg: DIVI(reg,reg)",  /* 54 */
	"reg: DIVU(reg,reg)",  /* 55 */
	"reg: MODI(reg,reg)",  /* 56 */
	"reg: MODU(reg,reg)",  /* 57 */
	"reg: MULI(reg,reg)",  /* 58 */
	"reg: MULU(reg,reg)",  /* 59 */
	"rc: con",  /* 60 */
	"rc: reg",  /* 61 */
	"reg: ADDI(reg,rc)",  /* 62 */
	"reg: ADDP(reg,rc)",  /* 63 */
	"reg: ADDU(reg,rc)",  /* 64 */
	"reg: BANDU(reg,rc)",  /* 65 */
	"reg: BORU(reg,rc)",  /* 66 */
	"reg: BXORU(reg,rc)",  /* 67 */
	"reg: SUBI(reg,rc)",  /* 68 */
	"reg: SUBP(reg,rc)",  /* 69 */
	"reg: SUBU(reg,rc)",  /* 70 */
	"rc5: CNSTI",  /* 71 */
	"rc5: reg",  /* 72 */
	"reg: LSHI(reg,rc5)",  /* 73 */
	"reg: LSHU(reg,rc5)",  /* 74 */
	"reg: RSHI(reg,rc5)",  /* 75 */
	"reg: RSHU(reg,rc5)",  /* 76 */
	"reg: BCOMU(reg)",  /* 77 */
	"reg: NEGI(reg)",  /* 78 */
	"reg: LOADC(reg)",  /* 79 */
	"reg: LOADS(reg)",  /* 80 */
	"reg: LOADI(reg)",  /* 81 */
	"reg: LOADP(reg)",  /* 82 */
	"reg: LOADU(reg)",  /* 83 */
	"reg: ADDD(reg,reg)",  /* 84 */
	"reg: ADDF(reg,reg)",  /* 85 */
	"reg: DIVD(reg,reg)",  /* 86 */
	"reg: DIVF(reg,reg)",  /* 87 */
	"reg: MULD(reg,reg)",  /* 88 */
	"reg: MULF(reg,reg)",  /* 89 */
	"reg: SUBD(reg,reg)",  /* 90 */
	"reg: SUBF(reg,reg)",  /* 91 */
	"reg: LOADD(reg)",  /* 92 */
	"reg: LOADF(reg)",  /* 93 */
	"reg: NEGD(reg)",  /* 94 */
	"reg: NEGF(reg)",  /* 95 */
	"reg: CVCI(reg)",  /* 96 */
	"reg: CVSI(reg)",  /* 97 */
	"reg: CVCU(reg)",  /* 98 */
	"reg: CVSU(reg)",  /* 99 */
	"reg: CVIC(reg)",  /* 100 */
	"reg: CVIS(reg)",  /* 101 */
	"reg: CVUC(reg)",  /* 102 */
	"reg: CVUS(reg)",  /* 103 */
	"reg: CVIC(reg)",  /* 104 */
	"reg: CVIS(reg)",  /* 105 */
	"reg: CVIU(reg)",  /* 106 */
	"reg: CVPU(reg)",  /* 107 */
	"reg: CVUC(reg)",  /* 108 */
	"reg: CVUI(reg)",  /* 109 */
	"reg: CVUP(reg)",  /* 110 */
	"reg: CVUS(reg)",  /* 111 */
	"reg: CVDF(reg)",  /* 112 */
	"reg: CVFD(reg)",  /* 113 */
	"reg: CVID(reg)",  /* 114 */
	"reg: CVDI(reg)",  /* 115 */
	"stmt: LABELV",  /* 116 */
	"stmt: JUMPV(acon)",  /* 117 */
	"stmt: JUMPV(reg)",  /* 118 */
	"stmt: EQI(reg,reg)",  /* 119 */
	"stmt: GEI(reg,reg)",  /* 120 */
	"stmt: GEU(reg,reg)",  /* 121 */
	"stmt: GTI(reg,reg)",  /* 122 */
	"stmt: GTU(reg,reg)",  /* 123 */
	"stmt: LEI(reg,reg)",  /* 124 */
	"stmt: LEU(reg,reg)",  /* 125 */
	"stmt: LTI(reg,reg)",  /* 126 */
	"stmt: LTU(reg,reg)",  /* 127 */
	"stmt: NEI(reg,reg)",  /* 128 */
	"stmt: EQD(reg,reg)",  /* 129 */
	"stmt: EQF(reg,reg)",  /* 130 */
	"stmt: LED(reg,reg)",  /* 131 */
	"stmt: LEF(reg,reg)",  /* 132 */
	"stmt: LTD(reg,reg)",  /* 133 */
	"stmt: LTF(reg,reg)",  /* 134 */
	"stmt: GED(reg,reg)",  /* 135 */
	"stmt: GEF(reg,reg)",  /* 136 */
	"stmt: GTD(reg,reg)",  /* 137 */
	"stmt: GTF(reg,reg)",  /* 138 */
	"stmt: NED(reg,reg)",  /* 139 */
	"stmt: NEF(reg,reg)",  /* 140 */
	"ar: ADDRGP",  /* 141 */
	"reg: CALLD(ar)",  /* 142 */
	"reg: CALLF(ar)",  /* 143 */
	"reg: CALLI(ar)",  /* 144 */
	"stmt: CALLV(ar)",  /* 145 */
	"ar: reg",  /* 146 */
	"ar: CNSTP",  /* 147 */
	"stmt: RETD(reg)",  /* 148 */
	"stmt: RETF(reg)",  /* 149 */
	"stmt: RETI(reg)",  /* 150 */
	"stmt: ARGD(reg)",  /* 151 */
	"stmt: ARGF(reg)",  /* 152 */
	"stmt: ARGI(reg)",  /* 153 */
	"stmt: ARGP(reg)",  /* 154 */
	"stmt: ARGB(INDIRB(reg))",  /* 155 */
	"stmt: ASGNB(reg,INDIRB(reg))",  /* 156 */
};

static short _nts_1[] = { 0 };
static short _nts_7[] = { _reg_NT, 0 };
static short _nts_23[] = { _con_NT, 0 };
static short _nts_25[] = { _reg_NT, _acon_NT, 0 };
static short _nts_28[] = { _acon_NT, 0 };
static short _nts_32[] = { _addr_NT, 0 };
static short _nts_38[] = { _addr_NT, _reg_NT, 0 };
static short _nts_54[] = { _reg_NT, _reg_NT, 0 };
static short _nts_62[] = { _reg_NT, _rc_NT, 0 };
static short _nts_73[] = { _reg_NT, _rc5_NT, 0 };
static short _nts_142[] = { _ar_NT, 0 };

static short *_nts[] = {
	0,
	_nts_1,	/* 1 */
	_nts_1,	/* 2 */
	_nts_1,	/* 3 */
	_nts_1,	/* 4 */
	_nts_1,	/* 5 */
	_nts_1,	/* 6 */
	_nts_7,	/* 7 */
	_nts_7,	/* 8 */
	_nts_7,	/* 9 */
	_nts_7,	/* 10 */
	_nts_7,	/* 11 */
	_nts_7,	/* 12 */
	_nts_1,	/* 13 */
	_nts_1,	/* 14 */
	_nts_1,	/* 15 */
	_nts_1,	/* 16 */
	_nts_1,	/* 17 */
	_nts_7,	/* 18 */
	_nts_7,	/* 19 */
	_nts_7,	/* 20 */
	_nts_7,	/* 21 */
	_nts_7,	/* 22 */
	_nts_23,	/* 23 */
	_nts_1,	/* 24 */
	_nts_25,	/* 25 */
	_nts_25,	/* 26 */
	_nts_25,	/* 27 */
	_nts_28,	/* 28 */
	_nts_7,	/* 29 */
	_nts_1,	/* 30 */
	_nts_1,	/* 31 */
	_nts_32,	/* 32 */
	_nts_1,	/* 33 */
	_nts_1,	/* 34 */
	_nts_1,	/* 35 */
	_nts_1,	/* 36 */
	_nts_1,	/* 37 */
	_nts_38,	/* 38 */
	_nts_38,	/* 39 */
	_nts_38,	/* 40 */
	_nts_38,	/* 41 */
	_nts_32,	/* 42 */
	_nts_32,	/* 43 */
	_nts_32,	/* 44 */
	_nts_32,	/* 45 */
	_nts_32,	/* 46 */
	_nts_32,	/* 47 */
	_nts_32,	/* 48 */
	_nts_32,	/* 49 */
	_nts_32,	/* 50 */
	_nts_32,	/* 51 */
	_nts_38,	/* 52 */
	_nts_38,	/* 53 */
	_nts_54,	/* 54 */
	_nts_54,	/* 55 */
	_nts_54,	/* 56 */
	_nts_54,	/* 57 */
	_nts_54,	/* 58 */
	_nts_54,	/* 59 */
	_nts_23,	/* 60 */
	_nts_7,	/* 61 */
	_nts_62,	/* 62 */
	_nts_62,	/* 63 */
	_nts_62,	/* 64 */
	_nts_62,	/* 65 */
	_nts_62,	/* 66 */
	_nts_62,	/* 67 */
	_nts_62,	/* 68 */
	_nts_62,	/* 69 */
	_nts_62,	/* 70 */
	_nts_1,	/* 71 */
	_nts_7,	/* 72 */
	_nts_73,	/* 73 */
	_nts_73,	/* 74 */
	_nts_73,	/* 75 */
	_nts_73,	/* 76 */
	_nts_7,	/* 77 */
	_nts_7,	/* 78 */
	_nts_7,	/* 79 */
	_nts_7,	/* 80 */
	_nts_7,	/* 81 */
	_nts_7,	/* 82 */
	_nts_7,	/* 83 */
	_nts_54,	/* 84 */
	_nts_54,	/* 85 */
	_nts_54,	/* 86 */
	_nts_54,	/* 87 */
	_nts_54,	/* 88 */
	_nts_54,	/* 89 */
	_nts_54,	/* 90 */
	_nts_54,	/* 91 */
	_nts_7,	/* 92 */
	_nts_7,	/* 93 */
	_nts_7,	/* 94 */
	_nts_7,	/* 95 */
	_nts_7,	/* 96 */
	_nts_7,	/* 97 */
	_nts_7,	/* 98 */
	_nts_7,	/* 99 */
	_nts_7,	/* 100 */
	_nts_7,	/* 101 */
	_nts_7,	/* 102 */
	_nts_7,	/* 103 */
	_nts_7,	/* 104 */
	_nts_7,	/* 105 */
	_nts_7,	/* 106 */
	_nts_7,	/* 107 */
	_nts_7,	/* 108 */
	_nts_7,	/* 109 */
	_nts_7,	/* 110 */
	_nts_7,	/* 111 */
	_nts_7,	/* 112 */
	_nts_7,	/* 113 */
	_nts_7,	/* 114 */
	_nts_7,	/* 115 */
	_nts_1,	/* 116 */
	_nts_28,	/* 117 */
	_nts_7,	/* 118 */
	_nts_54,	/* 119 */
	_nts_54,	/* 120 */
	_nts_54,	/* 121 */
	_nts_54,	/* 122 */
	_nts_54,	/* 123 */
	_nts_54,	/* 124 */
	_nts_54,	/* 125 */
	_nts_54,	/* 126 */
	_nts_54,	/* 127 */
	_nts_54,	/* 128 */
	_nts_54,	/* 129 */
	_nts_54,	/* 130 */
	_nts_54,	/* 131 */
	_nts_54,	/* 132 */
	_nts_54,	/* 133 */
	_nts_54,	/* 134 */
	_nts_54,	/* 135 */
	_nts_54,	/* 136 */
	_nts_54,	/* 137 */
	_nts_54,	/* 138 */
	_nts_54,	/* 139 */
	_nts_54,	/* 140 */
	_nts_1,	/* 141 */
	_nts_142,	/* 142 */
	_nts_142,	/* 143 */
	_nts_142,	/* 144 */
	_nts_142,	/* 145 */
	_nts_7,	/* 146 */
	_nts_1,	/* 147 */
	_nts_7,	/* 148 */
	_nts_7,	/* 149 */
	_nts_7,	/* 150 */
	_nts_7,	/* 151 */
	_nts_7,	/* 152 */
	_nts_7,	/* 153 */
	_nts_7,	/* 154 */
	_nts_7,	/* 155 */
	_nts_54,	/* 156 */
};

struct _state {
	short cost[9];
	struct {
		unsigned int _stmt:6;
		unsigned int _acon:2;
		unsigned int _addr:3;
		unsigned int _ar:2;
		unsigned int _con:3;
		unsigned int _rc:2;
		unsigned int _rc5:2;
		unsigned int _reg:7;
	} rule;
};

static short _decode_rc5[] = {
	0,
	71,
	72,
};

static short _decode_acon[] = {
	0,
	23,
	24,
};

static short _decode_rc[] = {
	0,
	60,
	61,
};

static short _decode_stmt[] = {
	0,
	7,
	8,
	9,
	10,
	11,
	12,
	18,
	38,
	39,
	40,
	41,
	52,
	53,
	116,
	117,
	118,
	119,
	120,
	121,
	122,
	123,
	124,
	125,
	126,
	127,
	128,
	129,
	130,
	131,
	132,
	133,
	134,
	135,
	136,
	137,
	138,
	139,
	140,
	145,
	148,
	149,
	150,
	151,
	152,
	153,
	154,
	155,
	156,
};

static short _decode_ar[] = {
	0,
	141,
	146,
	147,
};

static short _decode_reg[] = {
	0,
	1,
	2,
	3,
	4,
	5,
	6,
	19,
	20,
	21,
	22,
	32,
	33,
	34,
	35,
	36,
	37,
	42,
	43,
	44,
	45,
	46,
	47,
	48,
	49,
	50,
	51,
	54,
	55,
	56,
	57,
	58,
	59,
	62,
	63,
	64,
	65,
	66,
	67,
	68,
	69,
	70,
	73,
	74,
	75,
	76,
	77,
	78,
	79,
	80,
	81,
	82,
	83,
	84,
	85,
	86,
	87,
	88,
	89,
	90,
	91,
	92,
	93,
	94,
	95,
	96,
	97,
	98,
	99,
	100,
	101,
	102,
	103,
	104,
	105,
	106,
	107,
	108,
	109,
	110,
	111,
	112,
	113,
	114,
	115,
	142,
	143,
	144,
};

static short _decode_con[] = {
	0,
	13,
	14,
	15,
	16,
	17,
};

static short _decode_addr[] = {
	0,
	25,
	26,
	27,
	28,
	29,
	30,
	31,
};

#define _rc5_rule(a)	_decode_rc5[((struct _state *)a)->rule._rc5]
#define _acon_rule(a)	_decode_acon[((struct _state *)a)->rule._acon]
#define _rc_rule(a)	_decode_rc[((struct _state *)a)->rule._rc]
#define _stmt_rule(a)	_decode_stmt[((struct _state *)a)->rule._stmt]
#define _ar_rule(a)	_decode_ar[((struct _state *)a)->rule._ar]
#define _reg_rule(a)	_decode_reg[((struct _state *)a)->rule._reg]
#define _con_rule(a)	_decode_con[((struct _state *)a)->rule._con]
#define _addr_rule(a)	_decode_addr[((struct _state *)a)->rule._addr]
static int _rule(state, goalnt) void *state; {
	if (goalnt < 1 || goalnt > 8)
		fatal("_rule", "Bad goal nonterminal %d\n", goalnt);
	if (!state)
		return 0;
	switch (goalnt) {
	case _rc5_NT:	return _rc5_rule(state);
	case _acon_NT:	return _acon_rule(state);
	case _rc_NT:	return _rc_rule(state);
	case _stmt_NT:	return _stmt_rule(state);
	case _ar_NT:	return _ar_rule(state);
	case _reg_NT:	return _reg_rule(state);
	case _con_NT:	return _con_rule(state);
	case _addr_NT:	return _addr_rule(state);
	default:
		fatal("_rule", "Bad goalnt %d\n", goalnt);
		return 0;
	}
}

static void _closure_acon ARGS((NODEPTR_TYPE, int));
static void _closure_reg ARGS((NODEPTR_TYPE, int));
static void _closure_con ARGS((NODEPTR_TYPE, int));
static void _closure_addr ARGS((NODEPTR_TYPE, int));
static void _closure_acon(a, c) NODEPTR_TYPE a; {
	struct _state *p = STATE_LABEL(a);
	if (c + 0 < p->cost[_addr_NT]) {  /* addr : acon */
		p->cost[_addr_NT] = c + 0;
		p->rule._addr = 4;
		_closure_addr(a, c + 0);
	}
}

static void _closure_reg(a, c) NODEPTR_TYPE a; {
	struct _state *p = STATE_LABEL(a);
	if (c + 0 < p->cost[_rc5_NT]) {  /* rc5 : reg */
		p->cost[_rc5_NT] = c + 0;
		p->rule._rc5 = 2;
	}
	if (c + 0 < p->cost[_rc_NT]) {  /* rc : reg */
		p->cost[_rc_NT] = c + 0;
		p->rule._rc = 2;
	}
	if (c + 0 < p->cost[_stmt_NT]) {  /* stmt : reg */
		p->cost[_stmt_NT] = c + 0;
		p->rule._stmt = 7;
	}
	if (c + 0 < p->cost[_ar_NT]) {  /* ar : reg */
		p->cost[_ar_NT] = c + 0;
		p->rule._ar = 2;
	}
	if (c + 0 < p->cost[_addr_NT]) {  /* addr : reg */
		p->cost[_addr_NT] = c + 0;
		p->rule._addr = 5;
		_closure_addr(a, c + 0);
	}
}

static void _closure_con(a, c) NODEPTR_TYPE a; {
	struct _state *p = STATE_LABEL(a);
	if (c + 0 < p->cost[_acon_NT]) {  /* acon : con */
		p->cost[_acon_NT] = c + 0;
		p->rule._acon = 1;
		_closure_acon(a, c + 0);
	}
	if (c + 0 < p->cost[_rc_NT]) {  /* rc : con */
		p->cost[_rc_NT] = c + 0;
		p->rule._rc = 1;
	}
}

static void _closure_addr(a, c) NODEPTR_TYPE a; {
	struct _state *p = STATE_LABEL(a);
	if (c + 1 < p->cost[_reg_NT]) {  /* reg : addr */
		p->cost[_reg_NT] = c + 1;
		p->rule._reg = 11;
		_closure_reg(a, c + 1);
	}
}

static void _label(a) NODEPTR_TYPE a; {
	int c;
	struct _state *p;

	if (!a)
		fatal("_label", "Null tree\n", 0);
	STATE_LABEL(a) = p = allocate(sizeof (*p), FUNC);
	p->rule._stmt = 0;
	p->cost[1] = 
	p->cost[2] = 
	p->cost[3] = 
	p->cost[4] = 
	p->cost[5] = 
	p->cost[6] = 
	p->cost[7] = 
	p->cost[8] = 
		0x7fff;
	switch (OP_LABEL(a)) {
	case 306:  /* ADDD */
		_label(LEFT_CHILD(a));
		_label(RIGHT_CHILD(a));
		c = ((struct _state*)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + ((struct _state*)(RIGHT_CHILD(a)->x.state))->cost[_reg_NT] + 1;
		if (c + 0 < p->cost[_reg_NT]) {  /* reg : ADDD(reg,reg) */
			p->cost[_reg_NT] = c + 0;
			p->rule._reg = 53;
			_closure_reg(a, c + 0);
		}
		break;
	case 305:  /* ADDF */
		_label(LEFT_CHILD(a));
		_label(RIGHT_CHILD(a));
		c = ((struct _state*)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + ((struct _state*)(RIGHT_CHILD(a)->x.state))->cost[_reg_NT] + 1;
		if (c + 0 < p->cost[_reg_NT]) {  /* reg : ADDF(reg,reg) */
			p->cost[_reg_NT] = c + 0;
			p->rule._reg = 54;
			_closure_reg(a, c + 0);
		}
		break;
	case 309:  /* ADDI */
		_label(LEFT_CHILD(a));
		_label(RIGHT_CHILD(a));
		c = ((struct _state*)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + ((struct _state*)(RIGHT_CHILD(a)->x.state))->cost[_acon_NT] + 0;
		if (c + 0 < p->cost[_addr_NT]) {  /* addr : ADDI(reg,acon) */
			p->cost[_addr_NT] = c + 0;
			p->rule._addr = 1;
			_closure_addr(a, c + 0);
		}
		c = ((struct _state*)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + ((struct _state*)(RIGHT_CHILD(a)->x.state))->cost[_rc_NT] + 1;
		if (c + 0 < p->cost[_reg_NT]) {  /* reg : ADDI(reg,rc) */
			p->cost[_reg_NT] = c + 0;
			p->rule._reg = 33;
			_closure_reg(a, c + 0);
		}
		break;
	case 311:  /* ADDP */
		_label(LEFT_CHILD(a));
		_label(RIGHT_CHILD(a));
		c = ((struct _state*)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + ((struct _state*)(RIGHT_CHILD(a)->x.state))->cost[_acon_NT] + 0;
		if (c + 0 < p->cost[_addr_NT]) {  /* addr : ADDP(reg,acon) */
			p->cost[_addr_NT] = c + 0;
			p->rule._addr = 3;
			_closure_addr(a, c + 0);
		}
		c = ((struct _state*)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + ((struct _state*)(RIGHT_CHILD(a)->x.state))->cost[_rc_NT] + 1;
		if (c + 0 < p->cost[_reg_NT]) {  /* reg : ADDP(reg,rc) */
			p->cost[_reg_NT] = c + 0;
			p->rule._reg = 34;
			_closure_reg(a, c + 0);
		}
		break;
	case 279:  /* ADDRFP */
		c = 0;
		if (c + 0 < p->cost[_addr_NT]) {  /* addr : ADDRFP */
			p->cost[_addr_NT] = c + 0;
			p->rule._addr = 6;
			_closure_addr(a, c + 0);
		}
		break;
	case 263:  /* ADDRGP */
		c = 0;
		if (c + 0 < p->cost[_acon_NT]) {  /* acon : ADDRGP */
			p->cost[_acon_NT] = c + 0;
			p->rule._acon = 2;
			_closure_acon(a, c + 0);
		}
		c = 0;
		if (c + 0 < p->cost[_ar_NT]) {  /* ar : ADDRGP */
			p->cost[_ar_NT] = c + 0;
			p->rule._ar = 1;
		}
		break;
	case 295:  /* ADDRLP */
		c = 0;
		if (c + 0 < p->cost[_addr_NT]) {  /* addr : ADDRLP */
			p->cost[_addr_NT] = c + 0;
			p->rule._addr = 7;
			_closure_addr(a, c + 0);
		}
		break;
	case 310:  /* ADDU */
		_label(LEFT_CHILD(a));
		_label(RIGHT_CHILD(a));
		c = ((struct _state*)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + ((struct _state*)(RIGHT_CHILD(a)->x.state))->cost[_acon_NT] + 0;
		if (c + 0 < p->cost[_addr_NT]) {  /* addr : ADDU(reg,acon) */
			p->cost[_addr_NT] = c + 0;
			p->rule._addr = 2;
			_closure_addr(a, c + 0);
		}
		c = ((struct _state*)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + ((struct _state*)(RIGHT_CHILD(a)->x.state))->cost[_rc_NT] + 1;
		if (c + 0 < p->cost[_reg_NT]) {  /* reg : ADDU(reg,rc) */
			p->cost[_reg_NT] = c + 0;
			p->rule._reg = 35;
			_closure_reg(a, c + 0);
		}
		break;
	case 41:  /* ARGB */
		_label(LEFT_CHILD(a));
		if (
			LEFT_CHILD(a)->op == 73 /* INDIRB */
		) {
			c = ((struct _state*)(LEFT_CHILD(LEFT_CHILD(a))->x.state))->cost[_reg_NT] + 1;
			if (c + 0 < p->cost[_stmt_NT]) {  /* stmt : ARGB(INDIRB(reg)) */
				p->cost[_stmt_NT] = c + 0;
				p->rule._stmt = 47;
			}
		}
		break;
	case 34:  /* ARGD */
		_label(LEFT_CHILD(a));
		c = ((struct _state*)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + 1;
		if (c + 0 < p->cost[_stmt_NT]) {  /* stmt : ARGD(reg) */
			p->cost[_stmt_NT] = c + 0;
			p->rule._stmt = 43;
		}
		break;
	case 33:  /* ARGF */
		_label(LEFT_CHILD(a));
		c = ((struct _state*)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + 1;
		if (c + 0 < p->cost[_stmt_NT]) {  /* stmt : ARGF(reg) */
			p->cost[_stmt_NT] = c + 0;
			p->rule._stmt = 44;
		}
		break;
	case 37:  /* ARGI */
		_label(LEFT_CHILD(a));
		c = ((struct _state*)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + 1;
		if (c + 0 < p->cost[_stmt_NT]) {  /* stmt : ARGI(reg) */
			p->cost[_stmt_NT] = c + 0;
			p->rule._stmt = 45;
		}
		break;
	case 39:  /* ARGP */
		_label(LEFT_CHILD(a));
		c = ((struct _state*)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + 1;
		if (c + 0 < p->cost[_stmt_NT]) {  /* stmt : ARGP(reg) */
			p->cost[_stmt_NT] = c + 0;
			p->rule._stmt = 46;
		}
		break;
	case 57:  /* ASGNB */
		_label(LEFT_CHILD(a));
		_label(RIGHT_CHILD(a));
		if (
			RIGHT_CHILD(a)->op == 73 /* INDIRB */
		) {
			c = ((struct _state*)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + ((struct _state*)(LEFT_CHILD(RIGHT_CHILD(a))->x.state))->cost[_reg_NT] + 1;
			if (c + 0 < p->cost[_stmt_NT]) {  /* stmt : ASGNB(reg,INDIRB(reg)) */
				p->cost[_stmt_NT] = c + 0;
				p->rule._stmt = 48;
			}
		}
		break;
	case 51:  /* ASGNC */
		_label(LEFT_CHILD(a));
		_label(RIGHT_CHILD(a));
		if (
			LEFT_CHILD(a)->op == 615 /* VREGP */
		) {
			c = ((struct _state*)(RIGHT_CHILD(a)->x.state))->cost[_reg_NT] + 0;
			if (c + 0 < p->cost[_stmt_NT]) {  /* stmt : ASGNC(VREGP,reg) */
				p->cost[_stmt_NT] = c + 0;
				p->rule._stmt = 1;
			}
		}
		c = ((struct _state*)(LEFT_CHILD(a)->x.state))->cost[_addr_NT] + ((struct _state*)(RIGHT_CHILD(a)->x.state))->cost[_reg_NT] + 1;
		if (c + 0 < p->cost[_stmt_NT]) {  /* stmt : ASGNC(addr,reg) */
			p->cost[_stmt_NT] = c + 0;
			p->rule._stmt = 8;
		}
		break;
	case 50:  /* ASGND */
		_label(LEFT_CHILD(a));
		_label(RIGHT_CHILD(a));
		if (
			LEFT_CHILD(a)->op == 615 /* VREGP */
		) {
			c = ((struct _state*)(RIGHT_CHILD(a)->x.state))->cost[_reg_NT] + 0;
			if (c + 0 < p->cost[_stmt_NT]) {  /* stmt : ASGND(VREGP,reg) */
				p->cost[_stmt_NT] = c + 0;
				p->rule._stmt = 2;
			}
		}
		c = ((struct _state*)(LEFT_CHILD(a)->x.state))->cost[_addr_NT] + ((struct _state*)(RIGHT_CHILD(a)->x.state))->cost[_reg_NT] + 1;
		if (c + 0 < p->cost[_stmt_NT]) {  /* stmt : ASGND(addr,reg) */
			p->cost[_stmt_NT] = c + 0;
			p->rule._stmt = 12;
		}
		break;
	case 49:  /* ASGNF */
		_label(LEFT_CHILD(a));
		_label(RIGHT_CHILD(a));
		if (
			LEFT_CHILD(a)->op == 615 /* VREGP */
		) {
			c = ((struct _state*)(RIGHT_CHILD(a)->x.state))->cost[_reg_NT] + 0;
			if (c + 0 < p->cost[_stmt_NT]) {  /* stmt : ASGNF(VREGP,reg) */
				p->cost[_stmt_NT] = c + 0;
				p->rule._stmt = 3;
			}
		}
		c = ((struct _state*)(LEFT_CHILD(a)->x.state))->cost[_addr_NT] + ((struct _state*)(RIGHT_CHILD(a)->x.state))->cost[_reg_NT] + 1;
		if (c + 0 < p->cost[_stmt_NT]) {  /* stmt : ASGNF(addr,reg) */
			p->cost[_stmt_NT] = c + 0;
			p->rule._stmt = 13;
		}
		break;
	case 53:  /* ASGNI */
		_label(LEFT_CHILD(a));
		_label(RIGHT_CHILD(a));
		if (
			LEFT_CHILD(a)->op == 615 /* VREGP */
		) {
			c = ((struct _state*)(RIGHT_CHILD(a)->x.state))->cost[_reg_NT] + 0;
			if (c + 0 < p->cost[_stmt_NT]) {  /* stmt : ASGNI(VREGP,reg) */
				p->cost[_stmt_NT] = c + 0;
				p->rule._stmt = 4;
			}
		}
		c = ((struct _state*)(LEFT_CHILD(a)->x.state))->cost[_addr_NT] + ((struct _state*)(RIGHT_CHILD(a)->x.state))->cost[_reg_NT] + 1;
		if (c + 0 < p->cost[_stmt_NT]) {  /* stmt : ASGNI(addr,reg) */
			p->cost[_stmt_NT] = c + 0;
			p->rule._stmt = 10;
		}
		break;
	case 55:  /* ASGNP */
		_label(LEFT_CHILD(a));
		_label(RIGHT_CHILD(a));
		if (
			LEFT_CHILD(a)->op == 615 /* VREGP */
		) {
			c = ((struct _state*)(RIGHT_CHILD(a)->x.state))->cost[_reg_NT] + 0;
			if (c + 0 < p->cost[_stmt_NT]) {  /* stmt : ASGNP(VREGP,reg) */
				p->cost[_stmt_NT] = c + 0;
				p->rule._stmt = 5;
			}
		}
		c = ((struct _state*)(LEFT_CHILD(a)->x.state))->cost[_addr_NT] + ((struct _state*)(RIGHT_CHILD(a)->x.state))->cost[_reg_NT] + 1;
		if (c + 0 < p->cost[_stmt_NT]) {  /* stmt : ASGNP(addr,reg) */
			p->cost[_stmt_NT] = c + 0;
			p->rule._stmt = 11;
		}
		break;
	case 52:  /* ASGNS */
		_label(LEFT_CHILD(a));
		_label(RIGHT_CHILD(a));
		if (
			LEFT_CHILD(a)->op == 615 /* VREGP */
		) {
			c = ((struct _state*)(RIGHT_CHILD(a)->x.state))->cost[_reg_NT] + 0;
			if (c + 0 < p->cost[_stmt_NT]) {  /* stmt : ASGNS(VREGP,reg) */
				p->cost[_stmt_NT] = c + 0;
				p->rule._stmt = 6;
			}
		}
		c = ((struct _state*)(LEFT_CHILD(a)->x.state))->cost[_addr_NT] + ((struct _state*)(RIGHT_CHILD(a)->x.state))->cost[_reg_NT] + 1;
		if (c + 0 < p->cost[_stmt_NT]) {  /* stmt : ASGNS(addr,reg) */
			p->cost[_stmt_NT] = c + 0;
			p->rule._stmt = 9;
		}
		break;
	case 390:  /* BANDU */
		_label(LEFT_CHILD(a));
		_label(RIGHT_CHILD(a));
		c = ((struct _state*)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + ((struct _state*)(RIGHT_CHILD(a)->x.state))->cost[_rc_NT] + 1;
		if (c + 0 < p->cost[_reg_NT]) {  /* reg : BANDU(reg,rc) */
			p->cost[_reg_NT] = c + 0;
			p->rule._reg = 36;
			_closure_reg(a, c + 0);
		}
		break;
	case 406:  /* BCOMU */
		_label(LEFT_CHILD(a));
		c = ((struct _state*)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + 1;
		if (c + 0 < p->cost[_reg_NT]) {  /* reg : BCOMU(reg) */
			p->cost[_reg_NT] = c + 0;
			p->rule._reg = 46;
			_closure_reg(a, c + 0);
		}
		break;
	case 422:  /* BORU */
		_label(LEFT_CHILD(a));
		_label(RIGHT_CHILD(a));
		c = ((struct _state*)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + ((struct _state*)(RIGHT_CHILD(a)->x.state))->cost[_rc_NT] + 1;
		if (c + 0 < p->cost[_reg_NT]) {  /* reg : BORU(reg,rc) */
			p->cost[_reg_NT] = c + 0;
			p->rule._reg = 37;
			_closure_reg(a, c + 0);
		}
		break;
	case 438:  /* BXORU */
		_label(LEFT_CHILD(a));
		_label(RIGHT_CHILD(a));
		c = ((struct _state*)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + ((struct _state*)(RIGHT_CHILD(a)->x.state))->cost[_rc_NT] + 1;
		if (c + 0 < p->cost[_reg_NT]) {  /* reg : BXORU(reg,rc) */
			p->cost[_reg_NT] = c + 0;
			p->rule._reg = 38;
			_closure_reg(a, c + 0);
		}
		break;
	case 217:  /* CALLB */
		break;
	case 210:  /* CALLD */
		_label(LEFT_CHILD(a));
		c = ((struct _state*)(LEFT_CHILD(a)->x.state))->cost[_ar_NT] + 1;
		if (c + 0 < p->cost[_reg_NT]) {  /* reg : CALLD(ar) */
			p->cost[_reg_NT] = c + 0;
			p->rule._reg = 85;
			_closure_reg(a, c + 0);
		}
		break;
	case 209:  /* CALLF */
		_label(LEFT_CHILD(a));
		c = ((struct _state*)(LEFT_CHILD(a)->x.state))->cost[_ar_NT] + 1;
		if (c + 0 < p->cost[_reg_NT]) {  /* reg : CALLF(ar) */
			p->cost[_reg_NT] = c + 0;
			p->rule._reg = 86;
			_closure_reg(a, c + 0);
		}
		break;
	case 213:  /* CALLI */
		_label(LEFT_CHILD(a));
		c = ((struct _state*)(LEFT_CHILD(a)->x.state))->cost[_ar_NT] + 1;
		if (c + 0 < p->cost[_reg_NT]) {  /* reg : CALLI(ar) */
			p->cost[_reg_NT] = c + 0;
			p->rule._reg = 87;
			_closure_reg(a, c + 0);
		}
		break;
	case 216:  /* CALLV */
		_label(LEFT_CHILD(a));
		c = ((struct _state*)(LEFT_CHILD(a)->x.state))->cost[_ar_NT] + 1;
		if (c + 0 < p->cost[_stmt_NT]) {  /* stmt : CALLV(ar) */
			p->cost[_stmt_NT] = c + 0;
			p->rule._stmt = 39;
		}
		break;
	case 19:  /* CNSTC */
		c = 0;
		if (c + 0 < p->cost[_con_NT]) {  /* con : CNSTC */
			p->cost[_con_NT] = c + 0;
			p->rule._con = 1;
			_closure_con(a, c + 0);
		}
		c = range(a, 0, 0);
		if (c + 0 < p->cost[_reg_NT]) {  /* reg : CNSTC */
			p->cost[_reg_NT] = c + 0;
			p->rule._reg = 12;
			_closure_reg(a, c + 0);
		}
		break;
	case 18:  /* CNSTD */
		break;
	case 17:  /* CNSTF */
		break;
	case 21:  /* CNSTI */
		c = 0;
		if (c + 0 < p->cost[_con_NT]) {  /* con : CNSTI */
			p->cost[_con_NT] = c + 0;
			p->rule._con = 2;
			_closure_con(a, c + 0);
		}
		c = range(a, 0, 0);
		if (c + 0 < p->cost[_reg_NT]) {  /* reg : CNSTI */
			p->cost[_reg_NT] = c + 0;
			p->rule._reg = 14;
			_closure_reg(a, c + 0);
		}
		c = range(a,0,31);
		if (c + 0 < p->cost[_rc5_NT]) {  /* rc5 : CNSTI */
			p->cost[_rc5_NT] = c + 0;
			p->rule._rc5 = 1;
		}
		break;
	case 23:  /* CNSTP */
		c = 0;
		if (c + 0 < p->cost[_con_NT]) {  /* con : CNSTP */
			p->cost[_con_NT] = c + 0;
			p->rule._con = 3;
			_closure_con(a, c + 0);
		}
		c = range(a, 0, 0);
		if (c + 0 < p->cost[_reg_NT]) {  /* reg : CNSTP */
			p->cost[_reg_NT] = c + 0;
			p->rule._reg = 16;
			_closure_reg(a, c + 0);
		}
		c = range(a, 0, 0x0fffffff);
		if (c + 0 < p->cost[_ar_NT]) {  /* ar : CNSTP */
			p->cost[_ar_NT] = c + 0;
			p->rule._ar = 3;
		}
		break;
	case 20:  /* CNSTS */
		c = 0;
		if (c + 0 < p->cost[_con_NT]) {  /* con : CNSTS */
			p->cost[_con_NT] = c + 0;
			p->rule._con = 4;
			_closure_con(a, c + 0);
		}
		c = range(a, 0, 0);
		if (c + 0 < p->cost[_reg_NT]) {  /* reg : CNSTS */
			p->cost[_reg_NT] = c + 0;
			p->rule._reg = 13;
			_closure_reg(a, c + 0);
		}
		break;
	case 22:  /* CNSTU */
		c = 0;
		if (c + 0 < p->cost[_con_NT]) {  /* con : CNSTU */
			p->cost[_con_NT] = c + 0;
			p->rule._con = 5;
			_closure_con(a, c + 0);
		}
		c = range(a, 0, 0);
		if (c + 0 < p->cost[_reg_NT]) {  /* reg : CNSTU */
			p->cost[_reg_NT] = c + 0;
			p->rule._reg = 15;
			_closure_reg(a, c + 0);
		}
		break;
	case 85:  /* CVCI */
		_label(LEFT_CHILD(a));
		if (
			LEFT_CHILD(a)->op == 67 /* INDIRC */
		) {
			c = ((struct _state*)(LEFT_CHILD(LEFT_CHILD(a))->x.state))->cost[_addr_NT] + 1;
			if (c + 0 < p->cost[_reg_NT]) {  /* reg : CVCI(INDIRC(addr)) */
				p->cost[_reg_NT] = c + 0;
				p->rule._reg = 21;
				_closure_reg(a, c + 0);
			}
		}
		c = ((struct _state*)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + 2;
		if (c + 0 < p->cost[_reg_NT]) {  /* reg : CVCI(reg) */
			p->cost[_reg_NT] = c + 0;
			p->rule._reg = 65;
			_closure_reg(a, c + 0);
		}
		break;
	case 86:  /* CVCU */
		_label(LEFT_CHILD(a));
		if (
			LEFT_CHILD(a)->op == 67 /* INDIRC */
		) {
			c = ((struct _state*)(LEFT_CHILD(LEFT_CHILD(a))->x.state))->cost[_addr_NT] + 1;
			if (c + 0 < p->cost[_reg_NT]) {  /* reg : CVCU(INDIRC(addr)) */
				p->cost[_reg_NT] = c + 0;
				p->rule._reg = 23;
				_closure_reg(a, c + 0);
			}
		}
		c = ((struct _state*)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + 1;
		if (c + 0 < p->cost[_reg_NT]) {  /* reg : CVCU(reg) */
			p->cost[_reg_NT] = c + 0;
			p->rule._reg = 67;
			_closure_reg(a, c + 0);
		}
		break;
	case 97:  /* CVDF */
		_label(LEFT_CHILD(a));
		c = ((struct _state*)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + 1;
		if (c + 0 < p->cost[_reg_NT]) {  /* reg : CVDF(reg) */
			p->cost[_reg_NT] = c + 0;
			p->rule._reg = 81;
			_closure_reg(a, c + 0);
		}
		break;
	case 101:  /* CVDI */
		_label(LEFT_CHILD(a));
		c = ((struct _state*)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + 2;
		if (c + 0 < p->cost[_reg_NT]) {  /* reg : CVDI(reg) */
			p->cost[_reg_NT] = c + 0;
			p->rule._reg = 84;
			_closure_reg(a, c + 0);
		}
		break;
	case 114:  /* CVFD */
		_label(LEFT_CHILD(a));
		c = ((struct _state*)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + 1;
		if (c + 0 < p->cost[_reg_NT]) {  /* reg : CVFD(reg) */
			p->cost[_reg_NT] = c + 0;
			p->rule._reg = 82;
			_closure_reg(a, c + 0);
		}
		break;
	case 131:  /* CVIC */
		_label(LEFT_CHILD(a));
		c = ((struct _state*)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + notarget(a);
		if (c + 0 < p->cost[_reg_NT]) {  /* reg : CVIC(reg) */
			p->cost[_reg_NT] = c + 0;
			p->rule._reg = 69;
			_closure_reg(a, c + 0);
		}
		c = ((struct _state*)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + move(a);
		if (c + 0 < p->cost[_reg_NT]) {  /* reg : CVIC(reg) */
			p->cost[_reg_NT] = c + 0;
			p->rule._reg = 73;
			_closure_reg(a, c + 0);
		}
		break;
	case 130:  /* CVID */
		_label(LEFT_CHILD(a));
		c = ((struct _state*)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + 2;
		if (c + 0 < p->cost[_reg_NT]) {  /* reg : CVID(reg) */
			p->cost[_reg_NT] = c + 0;
			p->rule._reg = 83;
			_closure_reg(a, c + 0);
		}
		break;
	case 132:  /* CVIS */
		_label(LEFT_CHILD(a));
		c = ((struct _state*)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + notarget(a);
		if (c + 0 < p->cost[_reg_NT]) {  /* reg : CVIS(reg) */
			p->cost[_reg_NT] = c + 0;
			p->rule._reg = 70;
			_closure_reg(a, c + 0);
		}
		c = ((struct _state*)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + move(a);
		if (c + 0 < p->cost[_reg_NT]) {  /* reg : CVIS(reg) */
			p->cost[_reg_NT] = c + 0;
			p->rule._reg = 74;
			_closure_reg(a, c + 0);
		}
		break;
	case 134:  /* CVIU */
		_label(LEFT_CHILD(a));
		c = ((struct _state*)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + notarget(a);
		if (c + 0 < p->cost[_reg_NT]) {  /* reg : CVIU(reg) */
			p->cost[_reg_NT] = c + 0;
			p->rule._reg = 7;
			_closure_reg(a, c + 0);
		}
		c = ((struct _state*)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + move(a);
		if (c + 0 < p->cost[_reg_NT]) {  /* reg : CVIU(reg) */
			p->cost[_reg_NT] = c + 0;
			p->rule._reg = 75;
			_closure_reg(a, c + 0);
		}
		break;
	case 150:  /* CVPU */
		_label(LEFT_CHILD(a));
		c = ((struct _state*)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + notarget(a);
		if (c + 0 < p->cost[_reg_NT]) {  /* reg : CVPU(reg) */
			p->cost[_reg_NT] = c + 0;
			p->rule._reg = 8;
			_closure_reg(a, c + 0);
		}
		c = ((struct _state*)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + move(a);
		if (c + 0 < p->cost[_reg_NT]) {  /* reg : CVPU(reg) */
			p->cost[_reg_NT] = c + 0;
			p->rule._reg = 76;
			_closure_reg(a, c + 0);
		}
		break;
	case 165:  /* CVSI */
		_label(LEFT_CHILD(a));
		if (
			LEFT_CHILD(a)->op == 68 /* INDIRS */
		) {
			c = ((struct _state*)(LEFT_CHILD(LEFT_CHILD(a))->x.state))->cost[_addr_NT] + 1;
			if (c + 0 < p->cost[_reg_NT]) {  /* reg : CVSI(INDIRS(addr)) */
				p->cost[_reg_NT] = c + 0;
				p->rule._reg = 22;
				_closure_reg(a, c + 0);
			}
		}
		c = ((struct _state*)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + 2;
		if (c + 0 < p->cost[_reg_NT]) {  /* reg : CVSI(reg) */
			p->cost[_reg_NT] = c + 0;
			p->rule._reg = 66;
			_closure_reg(a, c + 0);
		}
		break;
	case 166:  /* CVSU */
		_label(LEFT_CHILD(a));
		if (
			LEFT_CHILD(a)->op == 68 /* INDIRS */
		) {
			c = ((struct _state*)(LEFT_CHILD(LEFT_CHILD(a))->x.state))->cost[_addr_NT] + 1;
			if (c + 0 < p->cost[_reg_NT]) {  /* reg : CVSU(INDIRS(addr)) */
				p->cost[_reg_NT] = c + 0;
				p->rule._reg = 24;
				_closure_reg(a, c + 0);
			}
		}
		c = ((struct _state*)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + 1;
		if (c + 0 < p->cost[_reg_NT]) {  /* reg : CVSU(reg) */
			p->cost[_reg_NT] = c + 0;
			p->rule._reg = 68;
			_closure_reg(a, c + 0);
		}
		break;
	case 179:  /* CVUC */
		_label(LEFT_CHILD(a));
		c = ((struct _state*)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + notarget(a);
		if (c + 0 < p->cost[_reg_NT]) {  /* reg : CVUC(reg) */
			p->cost[_reg_NT] = c + 0;
			p->rule._reg = 71;
			_closure_reg(a, c + 0);
		}
		c = ((struct _state*)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + move(a);
		if (c + 0 < p->cost[_reg_NT]) {  /* reg : CVUC(reg) */
			p->cost[_reg_NT] = c + 0;
			p->rule._reg = 77;
			_closure_reg(a, c + 0);
		}
		break;
	case 181:  /* CVUI */
		_label(LEFT_CHILD(a));
		c = ((struct _state*)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + notarget(a);
		if (c + 0 < p->cost[_reg_NT]) {  /* reg : CVUI(reg) */
			p->cost[_reg_NT] = c + 0;
			p->rule._reg = 9;
			_closure_reg(a, c + 0);
		}
		c = ((struct _state*)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + move(a);
		if (c + 0 < p->cost[_reg_NT]) {  /* reg : CVUI(reg) */
			p->cost[_reg_NT] = c + 0;
			p->rule._reg = 78;
			_closure_reg(a, c + 0);
		}
		break;
	case 183:  /* CVUP */
		_label(LEFT_CHILD(a));
		c = ((struct _state*)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + notarget(a);
		if (c + 0 < p->cost[_reg_NT]) {  /* reg : CVUP(reg) */
			p->cost[_reg_NT] = c + 0;
			p->rule._reg = 10;
			_closure_reg(a, c + 0);
		}
		c = ((struct _state*)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + move(a);
		if (c + 0 < p->cost[_reg_NT]) {  /* reg : CVUP(reg) */
			p->cost[_reg_NT] = c + 0;
			p->rule._reg = 79;
			_closure_reg(a, c + 0);
		}
		break;
	case 180:  /* CVUS */
		_label(LEFT_CHILD(a));
		c = ((struct _state*)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + notarget(a);
		if (c + 0 < p->cost[_reg_NT]) {  /* reg : CVUS(reg) */
			p->cost[_reg_NT] = c + 0;
			p->rule._reg = 72;
			_closure_reg(a, c + 0);
		}
		c = ((struct _state*)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + move(a);
		if (c + 0 < p->cost[_reg_NT]) {  /* reg : CVUS(reg) */
			p->cost[_reg_NT] = c + 0;
			p->rule._reg = 80;
			_closure_reg(a, c + 0);
		}
		break;
	case 450:  /* DIVD */
		_label(LEFT_CHILD(a));
		_label(RIGHT_CHILD(a));
		c = ((struct _state*)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + ((struct _state*)(RIGHT_CHILD(a)->x.state))->cost[_reg_NT] + 1;
		if (c + 0 < p->cost[_reg_NT]) {  /* reg : DIVD(reg,reg) */
			p->cost[_reg_NT] = c + 0;
			p->rule._reg = 55;
			_closure_reg(a, c + 0);
		}
		break;
	case 449:  /* DIVF */
		_label(LEFT_CHILD(a));
		_label(RIGHT_CHILD(a));
		c = ((struct _state*)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + ((struct _state*)(RIGHT_CHILD(a)->x.state))->cost[_reg_NT] + 1;
		if (c + 0 < p->cost[_reg_NT]) {  /* reg : DIVF(reg,reg) */
			p->cost[_reg_NT] = c + 0;
			p->rule._reg = 56;
			_closure_reg(a, c + 0);
		}
		break;
	case 453:  /* DIVI */
		_label(LEFT_CHILD(a));
		_label(RIGHT_CHILD(a));
		c = ((struct _state*)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + ((struct _state*)(RIGHT_CHILD(a)->x.state))->cost[_reg_NT] + 1;
		if (c + 0 < p->cost[_reg_NT]) {  /* reg : DIVI(reg,reg) */
			p->cost[_reg_NT] = c + 0;
			p->rule._reg = 27;
			_closure_reg(a, c + 0);
		}
		break;
	case 454:  /* DIVU */
		_label(LEFT_CHILD(a));
		_label(RIGHT_CHILD(a));
		c = ((struct _state*)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + ((struct _state*)(RIGHT_CHILD(a)->x.state))->cost[_reg_NT] + 1;
		if (c + 0 < p->cost[_reg_NT]) {  /* reg : DIVU(reg,reg) */
			p->cost[_reg_NT] = c + 0;
			p->rule._reg = 28;
			_closure_reg(a, c + 0);
		}
		break;
	case 482:  /* EQD */
		_label(LEFT_CHILD(a));
		_label(RIGHT_CHILD(a));
		c = ((struct _state*)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + ((struct _state*)(RIGHT_CHILD(a)->x.state))->cost[_reg_NT] + 2;
		if (c + 0 < p->cost[_stmt_NT]) {  /* stmt : EQD(reg,reg) */
			p->cost[_stmt_NT] = c + 0;
			p->rule._stmt = 27;
		}
		break;
	case 481:  /* EQF */
		_label(LEFT_CHILD(a));
		_label(RIGHT_CHILD(a));
		c = ((struct _state*)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + ((struct _state*)(RIGHT_CHILD(a)->x.state))->cost[_reg_NT] + 2;
		if (c + 0 < p->cost[_stmt_NT]) {  /* stmt : EQF(reg,reg) */
			p->cost[_stmt_NT] = c + 0;
			p->rule._stmt = 28;
		}
		break;
	case 485:  /* EQI */
		_label(LEFT_CHILD(a));
		_label(RIGHT_CHILD(a));
		c = ((struct _state*)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + ((struct _state*)(RIGHT_CHILD(a)->x.state))->cost[_reg_NT] + 1;
		if (c + 0 < p->cost[_stmt_NT]) {  /* stmt : EQI(reg,reg) */
			p->cost[_stmt_NT] = c + 0;
			p->rule._stmt = 17;
		}
		break;
	case 498:  /* GED */
		_label(LEFT_CHILD(a));
		_label(RIGHT_CHILD(a));
		c = ((struct _state*)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + ((struct _state*)(RIGHT_CHILD(a)->x.state))->cost[_reg_NT] + 2;
		if (c + 0 < p->cost[_stmt_NT]) {  /* stmt : GED(reg,reg) */
			p->cost[_stmt_NT] = c + 0;
			p->rule._stmt = 33;
		}
		break;
	case 497:  /* GEF */
		_label(LEFT_CHILD(a));
		_label(RIGHT_CHILD(a));
		c = ((struct _state*)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + ((struct _state*)(RIGHT_CHILD(a)->x.state))->cost[_reg_NT] + 2;
		if (c + 0 < p->cost[_stmt_NT]) {  /* stmt : GEF(reg,reg) */
			p->cost[_stmt_NT] = c + 0;
			p->rule._stmt = 34;
		}
		break;
	case 501:  /* GEI */
		_label(LEFT_CHILD(a));
		_label(RIGHT_CHILD(a));
		c = ((struct _state*)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + ((struct _state*)(RIGHT_CHILD(a)->x.state))->cost[_reg_NT] + 1;
		if (c + 0 < p->cost[_stmt_NT]) {  /* stmt : GEI(reg,reg) */
			p->cost[_stmt_NT] = c + 0;
			p->rule._stmt = 18;
		}
		break;
	case 502:  /* GEU */
		_label(LEFT_CHILD(a));
		_label(RIGHT_CHILD(a));
		c = ((struct _state*)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + ((struct _state*)(RIGHT_CHILD(a)->x.state))->cost[_reg_NT] + 1;
		if (c + 0 < p->cost[_stmt_NT]) {  /* stmt : GEU(reg,reg) */
			p->cost[_stmt_NT] = c + 0;
			p->rule._stmt = 19;
		}
		break;
	case 514:  /* GTD */
		_label(LEFT_CHILD(a));
		_label(RIGHT_CHILD(a));
		c = ((struct _state*)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + ((struct _state*)(RIGHT_CHILD(a)->x.state))->cost[_reg_NT] + 2;
		if (c + 0 < p->cost[_stmt_NT]) {  /* stmt : GTD(reg,reg) */
			p->cost[_stmt_NT] = c + 0;
			p->rule._stmt = 35;
		}
		break;
	case 513:  /* GTF */
		_label(LEFT_CHILD(a));
		_label(RIGHT_CHILD(a));
		c = ((struct _state*)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + ((struct _state*)(RIGHT_CHILD(a)->x.state))->cost[_reg_NT] + 2;
		if (c + 0 < p->cost[_stmt_NT]) {  /* stmt : GTF(reg,reg) */
			p->cost[_stmt_NT] = c + 0;
			p->rule._stmt = 36;
		}
		break;
	case 517:  /* GTI */
		_label(LEFT_CHILD(a));
		_label(RIGHT_CHILD(a));
		c = ((struct _state*)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + ((struct _state*)(RIGHT_CHILD(a)->x.state))->cost[_reg_NT] + 1;
		if (c + 0 < p->cost[_stmt_NT]) {  /* stmt : GTI(reg,reg) */
			p->cost[_stmt_NT] = c + 0;
			p->rule._stmt = 20;
		}
		break;
	case 518:  /* GTU */
		_label(LEFT_CHILD(a));
		_label(RIGHT_CHILD(a));
		c = ((struct _state*)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + ((struct _state*)(RIGHT_CHILD(a)->x.state))->cost[_reg_NT] + 1;
		if (c + 0 < p->cost[_stmt_NT]) {  /* stmt : GTU(reg,reg) */
			p->cost[_stmt_NT] = c + 0;
			p->rule._stmt = 21;
		}
		break;
	case 73:  /* INDIRB */
		_label(LEFT_CHILD(a));
		break;
	case 67:  /* INDIRC */
		_label(LEFT_CHILD(a));
		if (
			LEFT_CHILD(a)->op == 615 /* VREGP */
		) {
			assert(a);
			if (mayrecalc(a)) {
				struct _state *q = a->syms[RX]->u.t.cse->x.state;
				if(q->cost[_rc5_NT] == 0) {
					p->cost[_rc5_NT] = 0;
					p->rule._rc5 = q->rule._rc5;
				}
				if(q->cost[_acon_NT] == 0) {
					p->cost[_acon_NT] = 0;
					p->rule._acon = q->rule._acon;
				}
				if(q->cost[_rc_NT] == 0) {
					p->cost[_rc_NT] = 0;
					p->rule._rc = q->rule._rc;
				}
				if(q->cost[_stmt_NT] == 0) {
					p->cost[_stmt_NT] = 0;
					p->rule._stmt = q->rule._stmt;
				}
				if(q->cost[_ar_NT] == 0) {
					p->cost[_ar_NT] = 0;
					p->rule._ar = q->rule._ar;
				}
				if(q->cost[_reg_NT] == 0) {
					p->cost[_reg_NT] = 0;
					p->rule._reg = q->rule._reg;
				}
				if(q->cost[_con_NT] == 0) {
					p->cost[_con_NT] = 0;
					p->rule._con = q->rule._con;
				}
				if(q->cost[_addr_NT] == 0) {
					p->cost[_addr_NT] = 0;
					p->rule._addr = q->rule._addr;
				}
			}
			c = 0;
			if (c + 0 < p->cost[_reg_NT]) {  /* reg : INDIRC(VREGP) */
				p->cost[_reg_NT] = c + 0;
				p->rule._reg = 1;
				_closure_reg(a, c + 0);
			}
		}
		c = ((struct _state*)(LEFT_CHILD(a)->x.state))->cost[_addr_NT] + 1;
		if (c + 0 < p->cost[_reg_NT]) {  /* reg : INDIRC(addr) */
			p->cost[_reg_NT] = c + 0;
			p->rule._reg = 17;
			_closure_reg(a, c + 0);
		}
		break;
	case 66:  /* INDIRD */
		_label(LEFT_CHILD(a));
		if (
			LEFT_CHILD(a)->op == 615 /* VREGP */
		) {
			assert(a);
			if (mayrecalc(a)) {
				struct _state *q = a->syms[RX]->u.t.cse->x.state;
				if(q->cost[_rc5_NT] == 0) {
					p->cost[_rc5_NT] = 0;
					p->rule._rc5 = q->rule._rc5;
				}
				if(q->cost[_acon_NT] == 0) {
					p->cost[_acon_NT] = 0;
					p->rule._acon = q->rule._acon;
				}
				if(q->cost[_rc_NT] == 0) {
					p->cost[_rc_NT] = 0;
					p->rule._rc = q->rule._rc;
				}
				if(q->cost[_stmt_NT] == 0) {
					p->cost[_stmt_NT] = 0;
					p->rule._stmt = q->rule._stmt;
				}
				if(q->cost[_ar_NT] == 0) {
					p->cost[_ar_NT] = 0;
					p->rule._ar = q->rule._ar;
				}
				if(q->cost[_reg_NT] == 0) {
					p->cost[_reg_NT] = 0;
					p->rule._reg = q->rule._reg;
				}
				if(q->cost[_con_NT] == 0) {
					p->cost[_con_NT] = 0;
					p->rule._con = q->rule._con;
				}
				if(q->cost[_addr_NT] == 0) {
					p->cost[_addr_NT] = 0;
					p->rule._addr = q->rule._addr;
				}
			}
			c = 0;
			if (c + 0 < p->cost[_reg_NT]) {  /* reg : INDIRD(VREGP) */
				p->cost[_reg_NT] = c + 0;
				p->rule._reg = 2;
				_closure_reg(a, c + 0);
			}
		}
		c = ((struct _state*)(LEFT_CHILD(a)->x.state))->cost[_addr_NT] + 1;
		if (c + 0 < p->cost[_reg_NT]) {  /* reg : INDIRD(addr) */
			p->cost[_reg_NT] = c + 0;
			p->rule._reg = 25;
			_closure_reg(a, c + 0);
		}
		break;
	case 65:  /* INDIRF */
		_label(LEFT_CHILD(a));
		if (
			LEFT_CHILD(a)->op == 615 /* VREGP */
		) {
			assert(a);
			if (mayrecalc(a)) {
				struct _state *q = a->syms[RX]->u.t.cse->x.state;
				if(q->cost[_rc5_NT] == 0) {
					p->cost[_rc5_NT] = 0;
					p->rule._rc5 = q->rule._rc5;
				}
				if(q->cost[_acon_NT] == 0) {
					p->cost[_acon_NT] = 0;
					p->rule._acon = q->rule._acon;
				}
				if(q->cost[_rc_NT] == 0) {
					p->cost[_rc_NT] = 0;
					p->rule._rc = q->rule._rc;
				}
				if(q->cost[_stmt_NT] == 0) {
					p->cost[_stmt_NT] = 0;
					p->rule._stmt = q->rule._stmt;
				}
				if(q->cost[_ar_NT] == 0) {
					p->cost[_ar_NT] = 0;
					p->rule._ar = q->rule._ar;
				}
				if(q->cost[_reg_NT] == 0) {
					p->cost[_reg_NT] = 0;
					p->rule._reg = q->rule._reg;
				}
				if(q->cost[_con_NT] == 0) {
					p->cost[_con_NT] = 0;
					p->rule._con = q->rule._con;
				}
				if(q->cost[_addr_NT] == 0) {
					p->cost[_addr_NT] = 0;
					p->rule._addr = q->rule._addr;
				}
			}
			c = 0;
			if (c + 0 < p->cost[_reg_NT]) {  /* reg : INDIRF(VREGP) */
				p->cost[_reg_NT] = c + 0;
				p->rule._reg = 3;
				_closure_reg(a, c + 0);
			}
		}
		c = ((struct _state*)(LEFT_CHILD(a)->x.state))->cost[_addr_NT] + 1;
		if (c + 0 < p->cost[_reg_NT]) {  /* reg : INDIRF(addr) */
			p->cost[_reg_NT] = c + 0;
			p->rule._reg = 26;
			_closure_reg(a, c + 0);
		}
		break;
	case 69:  /* INDIRI */
		_label(LEFT_CHILD(a));
		if (
			LEFT_CHILD(a)->op == 615 /* VREGP */
		) {
			assert(a);
			if (mayrecalc(a)) {
				struct _state *q = a->syms[RX]->u.t.cse->x.state;
				if(q->cost[_rc5_NT] == 0) {
					p->cost[_rc5_NT] = 0;
					p->rule._rc5 = q->rule._rc5;
				}
				if(q->cost[_acon_NT] == 0) {
					p->cost[_acon_NT] = 0;
					p->rule._acon = q->rule._acon;
				}
				if(q->cost[_rc_NT] == 0) {
					p->cost[_rc_NT] = 0;
					p->rule._rc = q->rule._rc;
				}
				if(q->cost[_stmt_NT] == 0) {
					p->cost[_stmt_NT] = 0;
					p->rule._stmt = q->rule._stmt;
				}
				if(q->cost[_ar_NT] == 0) {
					p->cost[_ar_NT] = 0;
					p->rule._ar = q->rule._ar;
				}
				if(q->cost[_reg_NT] == 0) {
					p->cost[_reg_NT] = 0;
					p->rule._reg = q->rule._reg;
				}
				if(q->cost[_con_NT] == 0) {
					p->cost[_con_NT] = 0;
					p->rule._con = q->rule._con;
				}
				if(q->cost[_addr_NT] == 0) {
					p->cost[_addr_NT] = 0;
					p->rule._addr = q->rule._addr;
				}
			}
			c = 0;
			if (c + 0 < p->cost[_reg_NT]) {  /* reg : INDIRI(VREGP) */
				p->cost[_reg_NT] = c + 0;
				p->rule._reg = 4;
				_closure_reg(a, c + 0);
			}
		}
		c = ((struct _state*)(LEFT_CHILD(a)->x.state))->cost[_addr_NT] + 1;
		if (c + 0 < p->cost[_reg_NT]) {  /* reg : INDIRI(addr) */
			p->cost[_reg_NT] = c + 0;
			p->rule._reg = 19;
			_closure_reg(a, c + 0);
		}
		break;
	case 71:  /* INDIRP */
		_label(LEFT_CHILD(a));
		if (
			LEFT_CHILD(a)->op == 615 /* VREGP */
		) {
			assert(a);
			if (mayrecalc(a)) {
				struct _state *q = a->syms[RX]->u.t.cse->x.state;
				if(q->cost[_rc5_NT] == 0) {
					p->cost[_rc5_NT] = 0;
					p->rule._rc5 = q->rule._rc5;
				}
				if(q->cost[_acon_NT] == 0) {
					p->cost[_acon_NT] = 0;
					p->rule._acon = q->rule._acon;
				}
				if(q->cost[_rc_NT] == 0) {
					p->cost[_rc_NT] = 0;
					p->rule._rc = q->rule._rc;
				}
				if(q->cost[_stmt_NT] == 0) {
					p->cost[_stmt_NT] = 0;
					p->rule._stmt = q->rule._stmt;
				}
				if(q->cost[_ar_NT] == 0) {
					p->cost[_ar_NT] = 0;
					p->rule._ar = q->rule._ar;
				}
				if(q->cost[_reg_NT] == 0) {
					p->cost[_reg_NT] = 0;
					p->rule._reg = q->rule._reg;
				}
				if(q->cost[_con_NT] == 0) {
					p->cost[_con_NT] = 0;
					p->rule._con = q->rule._con;
				}
				if(q->cost[_addr_NT] == 0) {
					p->cost[_addr_NT] = 0;
					p->rule._addr = q->rule._addr;
				}
			}
			c = 0;
			if (c + 0 < p->cost[_reg_NT]) {  /* reg : INDIRP(VREGP) */
				p->cost[_reg_NT] = c + 0;
				p->rule._reg = 5;
				_closure_reg(a, c + 0);
			}
		}
		c = ((struct _state*)(LEFT_CHILD(a)->x.state))->cost[_addr_NT] + 1;
		if (c + 0 < p->cost[_reg_NT]) {  /* reg : INDIRP(addr) */
			p->cost[_reg_NT] = c + 0;
			p->rule._reg = 20;
			_closure_reg(a, c + 0);
		}
		break;
	case 68:  /* INDIRS */
		_label(LEFT_CHILD(a));
		if (
			LEFT_CHILD(a)->op == 615 /* VREGP */
		) {
			assert(a);
			if (mayrecalc(a)) {
				struct _state *q = a->syms[RX]->u.t.cse->x.state;
				if(q->cost[_rc5_NT] == 0) {
					p->cost[_rc5_NT] = 0;
					p->rule._rc5 = q->rule._rc5;
				}
				if(q->cost[_acon_NT] == 0) {
					p->cost[_acon_NT] = 0;
					p->rule._acon = q->rule._acon;
				}
				if(q->cost[_rc_NT] == 0) {
					p->cost[_rc_NT] = 0;
					p->rule._rc = q->rule._rc;
				}
				if(q->cost[_stmt_NT] == 0) {
					p->cost[_stmt_NT] = 0;
					p->rule._stmt = q->rule._stmt;
				}
				if(q->cost[_ar_NT] == 0) {
					p->cost[_ar_NT] = 0;
					p->rule._ar = q->rule._ar;
				}
				if(q->cost[_reg_NT] == 0) {
					p->cost[_reg_NT] = 0;
					p->rule._reg = q->rule._reg;
				}
				if(q->cost[_con_NT] == 0) {
					p->cost[_con_NT] = 0;
					p->rule._con = q->rule._con;
				}
				if(q->cost[_addr_NT] == 0) {
					p->cost[_addr_NT] = 0;
					p->rule._addr = q->rule._addr;
				}
			}
			c = 0;
			if (c + 0 < p->cost[_reg_NT]) {  /* reg : INDIRS(VREGP) */
				p->cost[_reg_NT] = c + 0;
				p->rule._reg = 6;
				_closure_reg(a, c + 0);
			}
		}
		c = ((struct _state*)(LEFT_CHILD(a)->x.state))->cost[_addr_NT] + 1;
		if (c + 0 < p->cost[_reg_NT]) {  /* reg : INDIRS(addr) */
			p->cost[_reg_NT] = c + 0;
			p->rule._reg = 18;
			_closure_reg(a, c + 0);
		}
		break;
	case 584:  /* JUMPV */
		_label(LEFT_CHILD(a));
		c = ((struct _state*)(LEFT_CHILD(a)->x.state))->cost[_acon_NT] + 1;
		if (c + 0 < p->cost[_stmt_NT]) {  /* stmt : JUMPV(acon) */
			p->cost[_stmt_NT] = c + 0;
			p->rule._stmt = 15;
		}
		c = ((struct _state*)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + 1;
		if (c + 0 < p->cost[_stmt_NT]) {  /* stmt : JUMPV(reg) */
			p->cost[_stmt_NT] = c + 0;
			p->rule._stmt = 16;
		}
		break;
	case 600:  /* LABELV */
		c = 0;
		if (c + 0 < p->cost[_stmt_NT]) {  /* stmt : LABELV */
			p->cost[_stmt_NT] = c + 0;
			p->rule._stmt = 14;
		}
		break;
	case 530:  /* LED */
		_label(LEFT_CHILD(a));
		_label(RIGHT_CHILD(a));
		c = ((struct _state*)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + ((struct _state*)(RIGHT_CHILD(a)->x.state))->cost[_reg_NT] + 2;
		if (c + 0 < p->cost[_stmt_NT]) {  /* stmt : LED(reg,reg) */
			p->cost[_stmt_NT] = c + 0;
			p->rule._stmt = 29;
		}
		break;
	case 529:  /* LEF */
		_label(LEFT_CHILD(a));
		_label(RIGHT_CHILD(a));
		c = ((struct _state*)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + ((struct _state*)(RIGHT_CHILD(a)->x.state))->cost[_reg_NT] + 2;
		if (c + 0 < p->cost[_stmt_NT]) {  /* stmt : LEF(reg,reg) */
			p->cost[_stmt_NT] = c + 0;
			p->rule._stmt = 30;
		}
		break;
	case 533:  /* LEI */
		_label(LEFT_CHILD(a));
		_label(RIGHT_CHILD(a));
		c = ((struct _state*)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + ((struct _state*)(RIGHT_CHILD(a)->x.state))->cost[_reg_NT] + 1;
		if (c + 0 < p->cost[_stmt_NT]) {  /* stmt : LEI(reg,reg) */
			p->cost[_stmt_NT] = c + 0;
			p->rule._stmt = 22;
		}
		break;
	case 534:  /* LEU */
		_label(LEFT_CHILD(a));
		_label(RIGHT_CHILD(a));
		c = ((struct _state*)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + ((struct _state*)(RIGHT_CHILD(a)->x.state))->cost[_reg_NT] + 1;
		if (c + 0 < p->cost[_stmt_NT]) {  /* stmt : LEU(reg,reg) */
			p->cost[_stmt_NT] = c + 0;
			p->rule._stmt = 23;
		}
		break;
	case 233:  /* LOADB */
		break;
	case 227:  /* LOADC */
		_label(LEFT_CHILD(a));
		c = ((struct _state*)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + move(a);
		if (c + 0 < p->cost[_reg_NT]) {  /* reg : LOADC(reg) */
			p->cost[_reg_NT] = c + 0;
			p->rule._reg = 48;
			_closure_reg(a, c + 0);
		}
		break;
	case 226:  /* LOADD */
		_label(LEFT_CHILD(a));
		c = ((struct _state*)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + move(a);
		if (c + 0 < p->cost[_reg_NT]) {  /* reg : LOADD(reg) */
			p->cost[_reg_NT] = c + 0;
			p->rule._reg = 61;
			_closure_reg(a, c + 0);
		}
		break;
	case 225:  /* LOADF */
		_label(LEFT_CHILD(a));
		c = ((struct _state*)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + move(a);
		if (c + 0 < p->cost[_reg_NT]) {  /* reg : LOADF(reg) */
			p->cost[_reg_NT] = c + 0;
			p->rule._reg = 62;
			_closure_reg(a, c + 0);
		}
		break;
	case 229:  /* LOADI */
		_label(LEFT_CHILD(a));
		c = ((struct _state*)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + move(a);
		if (c + 0 < p->cost[_reg_NT]) {  /* reg : LOADI(reg) */
			p->cost[_reg_NT] = c + 0;
			p->rule._reg = 50;
			_closure_reg(a, c + 0);
		}
		break;
	case 231:  /* LOADP */
		_label(LEFT_CHILD(a));
		c = ((struct _state*)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + move(a);
		if (c + 0 < p->cost[_reg_NT]) {  /* reg : LOADP(reg) */
			p->cost[_reg_NT] = c + 0;
			p->rule._reg = 51;
			_closure_reg(a, c + 0);
		}
		break;
	case 228:  /* LOADS */
		_label(LEFT_CHILD(a));
		c = ((struct _state*)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + move(a);
		if (c + 0 < p->cost[_reg_NT]) {  /* reg : LOADS(reg) */
			p->cost[_reg_NT] = c + 0;
			p->rule._reg = 49;
			_closure_reg(a, c + 0);
		}
		break;
	case 230:  /* LOADU */
		_label(LEFT_CHILD(a));
		c = ((struct _state*)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + move(a);
		if (c + 0 < p->cost[_reg_NT]) {  /* reg : LOADU(reg) */
			p->cost[_reg_NT] = c + 0;
			p->rule._reg = 52;
			_closure_reg(a, c + 0);
		}
		break;
	case 341:  /* LSHI */
		_label(LEFT_CHILD(a));
		_label(RIGHT_CHILD(a));
		c = ((struct _state*)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + ((struct _state*)(RIGHT_CHILD(a)->x.state))->cost[_rc5_NT] + 1;
		if (c + 0 < p->cost[_reg_NT]) {  /* reg : LSHI(reg,rc5) */
			p->cost[_reg_NT] = c + 0;
			p->rule._reg = 42;
			_closure_reg(a, c + 0);
		}
		break;
	case 342:  /* LSHU */
		_label(LEFT_CHILD(a));
		_label(RIGHT_CHILD(a));
		c = ((struct _state*)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + ((struct _state*)(RIGHT_CHILD(a)->x.state))->cost[_rc5_NT] + 1;
		if (c + 0 < p->cost[_reg_NT]) {  /* reg : LSHU(reg,rc5) */
			p->cost[_reg_NT] = c + 0;
			p->rule._reg = 43;
			_closure_reg(a, c + 0);
		}
		break;
	case 546:  /* LTD */
		_label(LEFT_CHILD(a));
		_label(RIGHT_CHILD(a));
		c = ((struct _state*)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + ((struct _state*)(RIGHT_CHILD(a)->x.state))->cost[_reg_NT] + 2;
		if (c + 0 < p->cost[_stmt_NT]) {  /* stmt : LTD(reg,reg) */
			p->cost[_stmt_NT] = c + 0;
			p->rule._stmt = 31;
		}
		break;
	case 545:  /* LTF */
		_label(LEFT_CHILD(a));
		_label(RIGHT_CHILD(a));
		c = ((struct _state*)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + ((struct _state*)(RIGHT_CHILD(a)->x.state))->cost[_reg_NT] + 2;
		if (c + 0 < p->cost[_stmt_NT]) {  /* stmt : LTF(reg,reg) */
			p->cost[_stmt_NT] = c + 0;
			p->rule._stmt = 32;
		}
		break;
	case 549:  /* LTI */
		_label(LEFT_CHILD(a));
		_label(RIGHT_CHILD(a));
		c = ((struct _state*)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + ((struct _state*)(RIGHT_CHILD(a)->x.state))->cost[_reg_NT] + 1;
		if (c + 0 < p->cost[_stmt_NT]) {  /* stmt : LTI(reg,reg) */
			p->cost[_stmt_NT] = c + 0;
			p->rule._stmt = 24;
		}
		break;
	case 550:  /* LTU */
		_label(LEFT_CHILD(a));
		_label(RIGHT_CHILD(a));
		c = ((struct _state*)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + ((struct _state*)(RIGHT_CHILD(a)->x.state))->cost[_reg_NT] + 1;
		if (c + 0 < p->cost[_stmt_NT]) {  /* stmt : LTU(reg,reg) */
			p->cost[_stmt_NT] = c + 0;
			p->rule._stmt = 25;
		}
		break;
	case 357:  /* MODI */
		_label(LEFT_CHILD(a));
		_label(RIGHT_CHILD(a));
		c = ((struct _state*)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + ((struct _state*)(RIGHT_CHILD(a)->x.state))->cost[_reg_NT] + 1;
		if (c + 0 < p->cost[_reg_NT]) {  /* reg : MODI(reg,reg) */
			p->cost[_reg_NT] = c + 0;
			p->rule._reg = 29;
			_closure_reg(a, c + 0);
		}
		break;
	case 358:  /* MODU */
		_label(LEFT_CHILD(a));
		_label(RIGHT_CHILD(a));
		c = ((struct _state*)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + ((struct _state*)(RIGHT_CHILD(a)->x.state))->cost[_reg_NT] + 1;
		if (c + 0 < p->cost[_reg_NT]) {  /* reg : MODU(reg,reg) */
			p->cost[_reg_NT] = c + 0;
			p->rule._reg = 30;
			_closure_reg(a, c + 0);
		}
		break;
	case 466:  /* MULD */
		_label(LEFT_CHILD(a));
		_label(RIGHT_CHILD(a));
		c = ((struct _state*)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + ((struct _state*)(RIGHT_CHILD(a)->x.state))->cost[_reg_NT] + 1;
		if (c + 0 < p->cost[_reg_NT]) {  /* reg : MULD(reg,reg) */
			p->cost[_reg_NT] = c + 0;
			p->rule._reg = 57;
			_closure_reg(a, c + 0);
		}
		break;
	case 465:  /* MULF */
		_label(LEFT_CHILD(a));
		_label(RIGHT_CHILD(a));
		c = ((struct _state*)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + ((struct _state*)(RIGHT_CHILD(a)->x.state))->cost[_reg_NT] + 1;
		if (c + 0 < p->cost[_reg_NT]) {  /* reg : MULF(reg,reg) */
			p->cost[_reg_NT] = c + 0;
			p->rule._reg = 58;
			_closure_reg(a, c + 0);
		}
		break;
	case 469:  /* MULI */
		_label(LEFT_CHILD(a));
		_label(RIGHT_CHILD(a));
		c = ((struct _state*)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + ((struct _state*)(RIGHT_CHILD(a)->x.state))->cost[_reg_NT] + 1;
		if (c + 0 < p->cost[_reg_NT]) {  /* reg : MULI(reg,reg) */
			p->cost[_reg_NT] = c + 0;
			p->rule._reg = 31;
			_closure_reg(a, c + 0);
		}
		break;
	case 470:  /* MULU */
		_label(LEFT_CHILD(a));
		_label(RIGHT_CHILD(a));
		c = ((struct _state*)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + ((struct _state*)(RIGHT_CHILD(a)->x.state))->cost[_reg_NT] + 1;
		if (c + 0 < p->cost[_reg_NT]) {  /* reg : MULU(reg,reg) */
			p->cost[_reg_NT] = c + 0;
			p->rule._reg = 32;
			_closure_reg(a, c + 0);
		}
		break;
	case 562:  /* NED */
		_label(LEFT_CHILD(a));
		_label(RIGHT_CHILD(a));
		c = ((struct _state*)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + ((struct _state*)(RIGHT_CHILD(a)->x.state))->cost[_reg_NT] + 2;
		if (c + 0 < p->cost[_stmt_NT]) {  /* stmt : NED(reg,reg) */
			p->cost[_stmt_NT] = c + 0;
			p->rule._stmt = 37;
		}
		break;
	case 561:  /* NEF */
		_label(LEFT_CHILD(a));
		_label(RIGHT_CHILD(a));
		c = ((struct _state*)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + ((struct _state*)(RIGHT_CHILD(a)->x.state))->cost[_reg_NT] + 2;
		if (c + 0 < p->cost[_stmt_NT]) {  /* stmt : NEF(reg,reg) */
			p->cost[_stmt_NT] = c + 0;
			p->rule._stmt = 38;
		}
		break;
	case 194:  /* NEGD */
		_label(LEFT_CHILD(a));
		c = ((struct _state*)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + 1;
		if (c + 0 < p->cost[_reg_NT]) {  /* reg : NEGD(reg) */
			p->cost[_reg_NT] = c + 0;
			p->rule._reg = 63;
			_closure_reg(a, c + 0);
		}
		break;
	case 193:  /* NEGF */
		_label(LEFT_CHILD(a));
		c = ((struct _state*)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + 1;
		if (c + 0 < p->cost[_reg_NT]) {  /* reg : NEGF(reg) */
			p->cost[_reg_NT] = c + 0;
			p->rule._reg = 64;
			_closure_reg(a, c + 0);
		}
		break;
	case 197:  /* NEGI */
		_label(LEFT_CHILD(a));
		c = ((struct _state*)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + 1;
		if (c + 0 < p->cost[_reg_NT]) {  /* reg : NEGI(reg) */
			p->cost[_reg_NT] = c + 0;
			p->rule._reg = 47;
			_closure_reg(a, c + 0);
		}
		break;
	case 565:  /* NEI */
		_label(LEFT_CHILD(a));
		_label(RIGHT_CHILD(a));
		c = ((struct _state*)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + ((struct _state*)(RIGHT_CHILD(a)->x.state))->cost[_reg_NT] + 1;
		if (c + 0 < p->cost[_stmt_NT]) {  /* stmt : NEI(reg,reg) */
			p->cost[_stmt_NT] = c + 0;
			p->rule._stmt = 26;
		}
		break;
	case 242:  /* RETD */
		_label(LEFT_CHILD(a));
		c = ((struct _state*)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + 1;
		if (c + 0 < p->cost[_stmt_NT]) {  /* stmt : RETD(reg) */
			p->cost[_stmt_NT] = c + 0;
			p->rule._stmt = 40;
		}
		break;
	case 241:  /* RETF */
		_label(LEFT_CHILD(a));
		c = ((struct _state*)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + 1;
		if (c + 0 < p->cost[_stmt_NT]) {  /* stmt : RETF(reg) */
			p->cost[_stmt_NT] = c + 0;
			p->rule._stmt = 41;
		}
		break;
	case 245:  /* RETI */
		_label(LEFT_CHILD(a));
		c = ((struct _state*)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + 1;
		if (c + 0 < p->cost[_stmt_NT]) {  /* stmt : RETI(reg) */
			p->cost[_stmt_NT] = c + 0;
			p->rule._stmt = 42;
		}
		break;
	case 373:  /* RSHI */
		_label(LEFT_CHILD(a));
		_label(RIGHT_CHILD(a));
		c = ((struct _state*)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + ((struct _state*)(RIGHT_CHILD(a)->x.state))->cost[_rc5_NT] + 1;
		if (c + 0 < p->cost[_reg_NT]) {  /* reg : RSHI(reg,rc5) */
			p->cost[_reg_NT] = c + 0;
			p->rule._reg = 44;
			_closure_reg(a, c + 0);
		}
		break;
	case 374:  /* RSHU */
		_label(LEFT_CHILD(a));
		_label(RIGHT_CHILD(a));
		c = ((struct _state*)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + ((struct _state*)(RIGHT_CHILD(a)->x.state))->cost[_rc5_NT] + 1;
		if (c + 0 < p->cost[_reg_NT]) {  /* reg : RSHU(reg,rc5) */
			p->cost[_reg_NT] = c + 0;
			p->rule._reg = 45;
			_closure_reg(a, c + 0);
		}
		break;
	case 322:  /* SUBD */
		_label(LEFT_CHILD(a));
		_label(RIGHT_CHILD(a));
		c = ((struct _state*)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + ((struct _state*)(RIGHT_CHILD(a)->x.state))->cost[_reg_NT] + 1;
		if (c + 0 < p->cost[_reg_NT]) {  /* reg : SUBD(reg,reg) */
			p->cost[_reg_NT] = c + 0;
			p->rule._reg = 59;
			_closure_reg(a, c + 0);
		}
		break;
	case 321:  /* SUBF */
		_label(LEFT_CHILD(a));
		_label(RIGHT_CHILD(a));
		c = ((struct _state*)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + ((struct _state*)(RIGHT_CHILD(a)->x.state))->cost[_reg_NT] + 1;
		if (c + 0 < p->cost[_reg_NT]) {  /* reg : SUBF(reg,reg) */
			p->cost[_reg_NT] = c + 0;
			p->rule._reg = 60;
			_closure_reg(a, c + 0);
		}
		break;
	case 325:  /* SUBI */
		_label(LEFT_CHILD(a));
		_label(RIGHT_CHILD(a));
		c = ((struct _state*)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + ((struct _state*)(RIGHT_CHILD(a)->x.state))->cost[_rc_NT] + 1;
		if (c + 0 < p->cost[_reg_NT]) {  /* reg : SUBI(reg,rc) */
			p->cost[_reg_NT] = c + 0;
			p->rule._reg = 39;
			_closure_reg(a, c + 0);
		}
		break;
	case 327:  /* SUBP */
		_label(LEFT_CHILD(a));
		_label(RIGHT_CHILD(a));
		c = ((struct _state*)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + ((struct _state*)(RIGHT_CHILD(a)->x.state))->cost[_rc_NT] + 1;
		if (c + 0 < p->cost[_reg_NT]) {  /* reg : SUBP(reg,rc) */
			p->cost[_reg_NT] = c + 0;
			p->rule._reg = 40;
			_closure_reg(a, c + 0);
		}
		break;
	case 326:  /* SUBU */
		_label(LEFT_CHILD(a));
		_label(RIGHT_CHILD(a));
		c = ((struct _state*)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + ((struct _state*)(RIGHT_CHILD(a)->x.state))->cost[_rc_NT] + 1;
		if (c + 0 < p->cost[_reg_NT]) {  /* reg : SUBU(reg,rc) */
			p->cost[_reg_NT] = c + 0;
			p->rule._reg = 41;
			_closure_reg(a, c + 0);
		}
		break;
	case 615:  /* VREGP */
		break;
	default:
		fatal("_label", "Bad terminal %d\n", OP_LABEL(a));
	}
}

static void _kids(p, eruleno, kids) NODEPTR_TYPE p, kids[]; {
	if (!p)
		fatal("_kids", "Null tree\n", 0);
	switch (eruleno) {
	case 1:  /* reg: INDIRC(VREGP) */
	case 2:  /* reg: INDIRD(VREGP) */
	case 3:  /* reg: INDIRF(VREGP) */
	case 4:  /* reg: INDIRI(VREGP) */
	case 5:  /* reg: INDIRP(VREGP) */
	case 6:  /* reg: INDIRS(VREGP) */
	case 13:  /* con: CNSTC */
	case 14:  /* con: CNSTI */
	case 15:  /* con: CNSTP */
	case 16:  /* con: CNSTS */
	case 17:  /* con: CNSTU */
	case 24:  /* acon: ADDRGP */
	case 30:  /* addr: ADDRFP */
	case 31:  /* addr: ADDRLP */
	case 33:  /* reg: CNSTC */
	case 34:  /* reg: CNSTS */
	case 35:  /* reg: CNSTI */
	case 36:  /* reg: CNSTU */
	case 37:  /* reg: CNSTP */
	case 71:  /* rc5: CNSTI */
	case 116:  /* stmt: LABELV */
	case 141:  /* ar: ADDRGP */
	case 147:  /* ar: CNSTP */
		break;
	case 46:  /* reg: CVCI(INDIRC(addr)) */
	case 47:  /* reg: CVSI(INDIRS(addr)) */
	case 48:  /* reg: CVCU(INDIRC(addr)) */
	case 49:  /* reg: CVSU(INDIRS(addr)) */
	case 155:  /* stmt: ARGB(INDIRB(reg)) */
		kids[0] = LEFT_CHILD(LEFT_CHILD(p));
		break;
	case 19:  /* reg: CVIU(reg) */
	case 20:  /* reg: CVPU(reg) */
	case 21:  /* reg: CVUI(reg) */
	case 22:  /* reg: CVUP(reg) */
	case 42:  /* reg: INDIRC(addr) */
	case 43:  /* reg: INDIRS(addr) */
	case 44:  /* reg: INDIRI(addr) */
	case 45:  /* reg: INDIRP(addr) */
	case 50:  /* reg: INDIRD(addr) */
	case 51:  /* reg: INDIRF(addr) */
	case 77:  /* reg: BCOMU(reg) */
	case 78:  /* reg: NEGI(reg) */
	case 79:  /* reg: LOADC(reg) */
	case 80:  /* reg: LOADS(reg) */
	case 81:  /* reg: LOADI(reg) */
	case 82:  /* reg: LOADP(reg) */
	case 83:  /* reg: LOADU(reg) */
	case 92:  /* reg: LOADD(reg) */
	case 93:  /* reg: LOADF(reg) */
	case 94:  /* reg: NEGD(reg) */
	case 95:  /* reg: NEGF(reg) */
	case 96:  /* reg: CVCI(reg) */
	case 97:  /* reg: CVSI(reg) */
	case 98:  /* reg: CVCU(reg) */
	case 99:  /* reg: CVSU(reg) */
	case 100:  /* reg: CVIC(reg) */
	case 101:  /* reg: CVIS(reg) */
	case 102:  /* reg: CVUC(reg) */
	case 103:  /* reg: CVUS(reg) */
	case 104:  /* reg: CVIC(reg) */
	case 105:  /* reg: CVIS(reg) */
	case 106:  /* reg: CVIU(reg) */
	case 107:  /* reg: CVPU(reg) */
	case 108:  /* reg: CVUC(reg) */
	case 109:  /* reg: CVUI(reg) */
	case 110:  /* reg: CVUP(reg) */
	case 111:  /* reg: CVUS(reg) */
	case 112:  /* reg: CVDF(reg) */
	case 113:  /* reg: CVFD(reg) */
	case 114:  /* reg: CVID(reg) */
	case 115:  /* reg: CVDI(reg) */
	case 117:  /* stmt: JUMPV(acon) */
	case 118:  /* stmt: JUMPV(reg) */
	case 142:  /* reg: CALLD(ar) */
	case 143:  /* reg: CALLF(ar) */
	case 144:  /* reg: CALLI(ar) */
	case 145:  /* stmt: CALLV(ar) */
	case 148:  /* stmt: RETD(reg) */
	case 149:  /* stmt: RETF(reg) */
	case 150:  /* stmt: RETI(reg) */
	case 151:  /* stmt: ARGD(reg) */
	case 152:  /* stmt: ARGF(reg) */
	case 153:  /* stmt: ARGI(reg) */
	case 154:  /* stmt: ARGP(reg) */
		kids[0] = LEFT_CHILD(p);
		break;
	case 156:  /* stmt: ASGNB(reg,INDIRB(reg)) */
		kids[0] = LEFT_CHILD(p);
		kids[1] = LEFT_CHILD(RIGHT_CHILD(p));
		break;
	case 25:  /* addr: ADDI(reg,acon) */
	case 26:  /* addr: ADDU(reg,acon) */
	case 27:  /* addr: ADDP(reg,acon) */
	case 38:  /* stmt: ASGNC(addr,reg) */
	case 39:  /* stmt: ASGNS(addr,reg) */
	case 40:  /* stmt: ASGNI(addr,reg) */
	case 41:  /* stmt: ASGNP(addr,reg) */
	case 52:  /* stmt: ASGND(addr,reg) */
	case 53:  /* stmt: ASGNF(addr,reg) */
	case 54:  /* reg: DIVI(reg,reg) */
	case 55:  /* reg: DIVU(reg,reg) */
	case 56:  /* reg: MODI(reg,reg) */
	case 57:  /* reg: MODU(reg,reg) */
	case 58:  /* reg: MULI(reg,reg) */
	case 59:  /* reg: MULU(reg,reg) */
	case 62:  /* reg: ADDI(reg,rc) */
	case 63:  /* reg: ADDP(reg,rc) */
	case 64:  /* reg: ADDU(reg,rc) */
	case 65:  /* reg: BANDU(reg,rc) */
	case 66:  /* reg: BORU(reg,rc) */
	case 67:  /* reg: BXORU(reg,rc) */
	case 68:  /* reg: SUBI(reg,rc) */
	case 69:  /* reg: SUBP(reg,rc) */
	case 70:  /* reg: SUBU(reg,rc) */
	case 73:  /* reg: LSHI(reg,rc5) */
	case 74:  /* reg: LSHU(reg,rc5) */
	case 75:  /* reg: RSHI(reg,rc5) */
	case 76:  /* reg: RSHU(reg,rc5) */
	case 84:  /* reg: ADDD(reg,reg) */
	case 85:  /* reg: ADDF(reg,reg) */
	case 86:  /* reg: DIVD(reg,reg) */
	case 87:  /* reg: DIVF(reg,reg) */
	case 88:  /* reg: MULD(reg,reg) */
	case 89:  /* reg: MULF(reg,reg) */
	case 90:  /* reg: SUBD(reg,reg) */
	case 91:  /* reg: SUBF(reg,reg) */
	case 119:  /* stmt: EQI(reg,reg) */
	case 120:  /* stmt: GEI(reg,reg) */
	case 121:  /* stmt: GEU(reg,reg) */
	case 122:  /* stmt: GTI(reg,reg) */
	case 123:  /* stmt: GTU(reg,reg) */
	case 124:  /* stmt: LEI(reg,reg) */
	case 125:  /* stmt: LEU(reg,reg) */
	case 126:  /* stmt: LTI(reg,reg) */
	case 127:  /* stmt: LTU(reg,reg) */
	case 128:  /* stmt: NEI(reg,reg) */
	case 129:  /* stmt: EQD(reg,reg) */
	case 130:  /* stmt: EQF(reg,reg) */
	case 131:  /* stmt: LED(reg,reg) */
	case 132:  /* stmt: LEF(reg,reg) */
	case 133:  /* stmt: LTD(reg,reg) */
	case 134:  /* stmt: LTF(reg,reg) */
	case 135:  /* stmt: GED(reg,reg) */
	case 136:  /* stmt: GEF(reg,reg) */
	case 137:  /* stmt: GTD(reg,reg) */
	case 138:  /* stmt: GTF(reg,reg) */
	case 139:  /* stmt: NED(reg,reg) */
	case 140:  /* stmt: NEF(reg,reg) */
		kids[0] = LEFT_CHILD(p);
		kids[1] = RIGHT_CHILD(p);
		break;
	case 7:  /* stmt: ASGNC(VREGP,reg) */
	case 8:  /* stmt: ASGND(VREGP,reg) */
	case 9:  /* stmt: ASGNF(VREGP,reg) */
	case 10:  /* stmt: ASGNI(VREGP,reg) */
	case 11:  /* stmt: ASGNP(VREGP,reg) */
	case 12:  /* stmt: ASGNS(VREGP,reg) */
		kids[0] = RIGHT_CHILD(p);
		break;
	case 18:  /* stmt: reg */
	case 23:  /* acon: con */
	case 28:  /* addr: acon */
	case 29:  /* addr: reg */
	case 32:  /* reg: addr */
	case 60:  /* rc: con */
	case 61:  /* rc: reg */
	case 72:  /* rc5: reg */
	case 146:  /* ar: reg */
		kids[0] = p;
		break;
	default:
		fatal("_kids", "Bad rule number %d\n", eruleno);
	}
}
static void progend(){}
static void progbeg(argc, argv) int argc; char *argv[]; {
	int i;

	{
		union {
			char c;
			int i;
		} u;
		u.i = 0;
		u.c = 1;
		swap = (u.i == 1) != IR->little_endian;
	}
	print(".set reorder\n");
	parseflags(argc, argv);
	for (i = 0; i < argc; i++)
		if (strncmp(argv[i], "-G", 2) == 0)
			gnum = atoi(argv[i] + 2);
	for (i = 0; i < 31; i += 2)
		freg2[i] = mkreg("%d", i, 3, FREG);
	for (i = 0; i < 32; i++)
		ireg[i] = mkreg("%d", i, 1, IREG);
	ireg[29]->x.name = "sp";
	d6 = mkreg("6", 6, 3, IREG);
	rmap[C] = rmap[S] = rmap[P] = rmap[B] = rmap[U] = rmap[I] =
		mkwildcard(ireg);
	rmap[F] = rmap[D] = mkwildcard(freg2);
	tmask[IREG] = INTTMP; tmask[FREG] = FLTTMP;
	vmask[IREG] = INTVAR; vmask[FREG] = FLTVAR;
	blkreg = mkreg("8", 8, 7, IREG);
}
static void target(p) Node p; {
	assert(p);
	switch (p->op) {
	case CNSTC: case CNSTI: case CNSTS: case CNSTU: case CNSTP:
		if (range(p, 0, 0) == 0) {
			setreg(p, ireg[0]);
			p->x.registered = 1;
		}
		break;
	case CALLD: case CALLF:  setreg(p, freg2[0]);      break;
	case CALLI:              setreg(p, ireg[2]);       break;
	case RETD: case RETF:    rtarget(p, 0, freg2[0]);  break;
	case RETI:               rtarget(p, 0, ireg[2]);   break;
	case ARGD: case ARGF: case ARGI: case ARGP: {
		static int ty0;
		int ty = optype(p->op);
		Symbol q = argreg(p->x.argno, p->syms[2]->u.c.v.i, ty, ty0);
		if (p->x.argno == 0)
			ty0 = ty;
		if (q && !((ty == F || ty == D) && q->x.regnode->set == IREG))
			rtarget(p, 0, q);
		break;
		}
	case ASGNB:  rtarget(p->kids[1], 0, blkreg);  break;
	case ARGB:   rtarget(p->kids[0], 0, blkreg);  break;
	}
}
static void clobber(p) Node p; {
	assert(p);
	switch (p->op) {
	case CALLD: case CALLF:
		spill(INTTMP | INTRET, IREG, p);
		spill(FLTTMP,          FREG, p);
		break;
	case CALLI:
		spill(INTTMP,          IREG, p);
		spill(FLTTMP | FLTRET, FREG, p);
		break;
	case CALLV:
		spill(INTTMP | INTRET, IREG, p);
		spill(FLTTMP | FLTRET, FREG, p);
		break;
	}
}
static void emit2(p) Node p; {
	int dst, n, src, ty;
	static int ty0;
	Symbol q;

	switch (p->op) {
	case ARGD: case ARGF: case ARGI: case ARGP:
		ty = optype(p->op);
		if (p->x.argno == 0)
			ty0 = ty;
		q = argreg(p->x.argno, p->syms[2]->u.c.v.i, ty, ty0);
		src = getregnum(p->x.kids[0]);
		if (q == NULL && ty == F)
			print("s.s $f%d,%d($sp)\n", src, p->syms[2]->u.c.v.i);
		else if (q == NULL && ty == D)
			print("s.d $f%d,%d($sp)\n", src, p->syms[2]->u.c.v.i);
		else if (q == NULL)
			print("sw $%d,%d($sp)\n", src, p->syms[2]->u.c.v.i);
		else if (ty == F && q->x.regnode->set == IREG)
			print("mfc1 $%d,$f%d\n", q->x.regnode->number, src);
		else if (ty == D && q->x.regnode->set == IREG)
			print("mfc1.d $%d,$f%d\n", q->x.regnode->number, src);
		break;
	case ASGNB:
		dalign = salign = p->syms[1]->u.c.v.i;
		blkcopy(getregnum(p->x.kids[0]), 0,
			getregnum(p->x.kids[1]), 0,
			p->syms[0]->u.c.v.i, tmpregs);
		break;
	case ARGB:
		dalign = 4;
		salign = p->syms[1]->u.c.v.i;
		blkcopy(29, p->syms[2]->u.c.v.i,
			getregnum(p->x.kids[0]), 0,
			p->syms[0]->u.c.v.i, tmpregs);
		n = p->syms[2]->u.c.v.i + p->syms[0]->u.c.v.i;
		for (dst = p->syms[2]->u.c.v.i; dst <= 12 && dst < n; dst += 4)
			print("lw $%d,%d($sp)\n", (dst/4)+4, dst);
		break;
	}
}
static Symbol argreg(argno, offset, ty, ty0) {
	assert((offset&3) == 0);
	if (offset > 12)
		return NULL;
	else if (argno == 0 && (ty == F || ty == D))
		return freg2[12];
	else if (argno == 1 && (ty == F || ty == D)
	&& (ty0 == F || ty0 == D))
		return freg2[14];
	else if (argno == 1 && ty == D)
		return d6;  /* Pair! */
	else
		return ireg[(offset/4) + 4];
}
static void doarg(p) Node p; {
	static int argno;
	int size;

	if (argoffset == 0)
		argno = 0;
	p->x.argno = argno++;
	size = p->syms[1]->u.c.v.i < 4 ? 4 : p->syms[1]->u.c.v.i;
	p->syms[2] = intconst(mkactual(size, p->syms[0]->u.c.v.i));
}
static void local(p) Symbol p; {
	if (askregvar(p, rmap[ttob(p->type)]) == 0)
		mkauto(p);
}
static void function(f, caller, callee, ncalls)
Symbol f, callee[], caller[]; {
	int i, saved, sizefsave, sizeisave, varargs;
	Symbol r, argregs[4];

	usedmask[0] = usedmask[1] = 0;
		freemask[0] = freemask[1] = ~(unsigned)0;
	offset = maxoffset = maxargoffset = 0;
	for (i = 0; callee[i]; i++)
		;
	varargs = variadic(f->type)
		|| i > 0 && strcmp(callee[i-1]->name, "va_alist") == 0;
	for (i = 0; callee[i]; i++) {
		Symbol p = callee[i];
		Symbol q = caller[i];
		assert(q);
		offset = roundup(offset, q->type->align);
		p->x.offset = q->x.offset = offset;
		p->x.name = q->x.name = stringd(offset);
		r = argreg(i, offset, ttob(q->type), ttob(caller[0]->type));
		if (i < 4)
			argregs[i] = r;
		offset = roundup(offset + q->type->size, 4);
		if (varargs)
			p->sclass = AUTO;
		else if (r && ncalls == 0 &&
			 !isstruct(q->type) && !p->addressed &&
			 !(isfloat(q->type) && r->x.regnode->set == IREG)
) {
			p->sclass = q->sclass = REGISTER;
			askregvar(p, r);
			assert(p->x.regnode && p->x.regnode->vbl == p);
			q->x = p->x;
			q->type = p->type;
		}
		else if (askregvar(p, rmap[ttob(p->type)]) &&
			 r &&
			 (isint(p->type) || p->type == q->type)) {
			assert(q->sclass != REGISTER);
			p->sclass = q->sclass = REGISTER;
			q->type = p->type;
		}
	}
	assert(caller[i] == 0);
	offset = 0;
	gencode(caller, callee);
	if (ncalls)
		usedmask[IREG] |= ((unsigned)1)<<31;
	usedmask[IREG] &= 0xc0ff0000;
	usedmask[FREG] &= 0xfff00000;
	maxargoffset = roundup(maxargoffset, 4);
	if (maxargoffset && maxargoffset < 16)
		maxargoffset = 16;
	sizefsave = 4*bitcount(usedmask[FREG]);
	sizeisave = 4*bitcount(usedmask[IREG]);
	framesize = roundup(maxargoffset + sizefsave
		+ sizeisave + maxoffset, 8);
	segment(CODE);
	print(".align 2\n");
	print(".ent %s\n", f->x.name);
	print("%s:\n", f->x.name);
	i = maxargoffset + sizefsave - framesize;
	print(".frame $sp,%d,$31\n", framesize);
	if (framesize > 0)
		print("addu $sp,$sp,%d\n", -framesize);
	if (usedmask[FREG])
		print(".fmask 0x%x,%d\n", usedmask[FREG], i - 8);
	if (usedmask[IREG])
		print(".mask 0x%x,%d\n", usedmask[IREG], i + sizeisave - 4);
	saved = maxargoffset;
	for (i = 20; i <= 30; i += 2)
		if (usedmask[FREG]&(3<<i)) {
			print("s.d $f%d,%d($sp)\n", i, saved);
			saved += 8;
		}
	for (i = 16; i <= 31; i++)
		if (usedmask[IREG]&(1<<i)) {
			print("sw $%d,%d($sp)\n", i, saved);
			saved += 4;
		}
	for (i = 0; i < 4 && callee[i]; i++) {
		r = argregs[i];
		if (r && r->x.regnode != callee[i]->x.regnode) {
			Symbol out = callee[i];
			Symbol in = caller[i];
			int rn = r->x.regnode->number;
			int rs = r->x.regnode->set;
			int tyin = ttob(in->type);

			assert(out && in && r && r->x.regnode);
			assert(out->sclass != REGISTER || out->x.regnode);
			if (out->sclass == REGISTER
			&& (isint(out->type) || out->type == in->type)) {
				int outn = out->x.regnode->number;
				if (rs == FREG && tyin == D)
					print("mov.d $f%d,$f%d\n", outn, rn);
				else if (rs == FREG && tyin == F)
					print("mov.s $f%d,$f%d\n", outn, rn);
				else if (rs == IREG && tyin == D)
					print("mtc1.d $%d,$f%d\n", rn, outn);
				else if (rs == IREG && tyin == F)
					print("mtc1 $%d,$f%d\n", rn, outn);
				else
					print("move $%d,$%d\n", outn, rn);
			} else {
				int off = in->x.offset + framesize;
				if (rs == FREG && tyin == D)
					print("s.d $f%d,%d($sp)\n", rn, off);
				else if (rs == FREG && tyin == F)
					print("s.s $f%d,%d($sp)\n", rn, off);
				else {
					int i, n = (in->type->size + 3)/4;
					for (i = rn; i < rn+n && i <= 7; i++)
						print("sw $%d,%d($sp)\n", i, off + (i-rn)*4);
				}
			}
		}
	}
	if (varargs && callee[i-1]) {
		i = callee[i-1]->x.offset + callee[i-1]->type->size;
		for (i = roundup(i, 4)/4; i <= 3; i++)
			print("sw $%d,%d($sp)\n", i + 4, framesize + 4*i);
		}
	emitcode();
	saved = maxargoffset;
	for (i = 20; i <= 30; i += 2)
		if (usedmask[FREG]&(3<<i)) {
			print("l.d $f%d,%d($sp)\n", i, saved);
			saved += 8;
		}
	for (i = 16; i <= 31; i++)
		if (usedmask[IREG]&(1<<i)) {
			print("lw $%d,%d($sp)\n", i, saved);
			saved += 4;
		}
	if (framesize > 0)
		print("addu $sp,$sp,%d\n", framesize);
	print("j $31\n");
	print(".end %s\n", f->x.name);
}
static void defconst(ty, v) int ty; Value v; {
	switch (ty) {
	case C: print(".byte %d\n",   v.uc); return;
	case S: print(".half %d\n",   v.ss); return;
	case I: print(".word 0x%x\n", v.i);  return;
	case U: print(".word 0x%x\n", v.u);  return;
	case P: print(".word 0x%x\n", v.p); return;
	case F:  print(".word 0x%x\n", *(unsigned *)&v.f);  return;
	case D: {
		unsigned *p = (unsigned *)&v.d;
		print(".word 0x%x\n.word 0x%x\n", p[swap], p[!swap]);
		return;
		}
	}
	assert(0);
}
static void defaddress(p) Symbol p; {
	print(".word %s\n", p->x.name);
}
static void defstring(n, str) int n; char *str; {
	char *s;

	for (s = str; s < str + n; s++)
		print(".byte %d\n", *s);
}
static void export(p) Symbol p; {
	print(".globl %s\n", p->x.name);
}
static void import(p) Symbol p; {
	if (!isfunc(p->type))
		print(".extern %s %d\n", p->name, p->type->size);
}
static void defsymbol(p) Symbol p; {
	if (p->scope >= LOCAL && p->sclass == STATIC)
		p->x.name = stringf("L.%d", genlabel(1));
	else if (p->generated)
		p->x.name = stringf("L.%s", p->name);
	else
		assert(p->scope != CONSTANTS || isint(p->type) || isptr(p->type)),
		p->x.name = p->name;
}
static void address(q, p, n) Symbol q, p; {
	q->x.offset = p->x.offset + n;
	if (p->scope == GLOBAL
	|| p->sclass == STATIC || p->sclass == EXTERN)
		q->x.name = stringf("%s%s%d", p->x.name,
			n >= 0 ? "+" : "", n);
	else
		q->x.name = stringd(q->x.offset);
}
static void global(p) Symbol p; {
	if (p->u.seg == BSS) {
		if (p->sclass == STATIC || Aflag >= 2)
			print(".lcomm %s,%d\n", p->x.name, p->type->size);
		else
			print( ".comm %s,%d\n", p->x.name, p->type->size);
	} else {
		if (p->u.seg == DATA
		&& (p->type->size == 0 || p->type->size > gnum))
			print(".data\n");
		else if (p->u.seg == DATA)
			print(".sdata\n");
		print(".align %c\n", ".01.2...3"[p->type->align]);
		print("%s:\n", p->x.name);
	}
}
static void segment(n) {
	cseg = n;
	switch (n) {
	case CODE:	print(".text\n");  break;
	case LIT:	print(".rdata\n"); break;
	}
}
static void space(n) {
	if (cseg != BSS)
		print(".space %d\n", n);
}
static void blkloop(dreg, doff, sreg, soff, size, tmps)
int tmps[]; {
	int lab = genlabel(1);

	print("addu $%d,$%d,%d\n", sreg, sreg, size&~7);
	print("addu $%d,$%d,%d\n", tmps[2], dreg, size&~7);
	blkcopy(tmps[2], doff, sreg, soff, size&7, tmps);
	print("L.%d:\n", lab);
	print("addu $%d,$%d,%d\n", sreg, sreg, -8);
	print("addu $%d,$%d,%d\n", tmps[2], tmps[2], -8);
	blkcopy(tmps[2], doff, sreg, soff, 8, tmps);
	print("bltu $%d,$%d,L.%d\n", dreg, tmps[2], lab);
}
static void blkfetch(size, off, reg, tmp) {
	assert(size == 1 || size == 2 || size == 4);
	if (size == 1)
		print("lbu $%d,%d($%d)\n",  tmp, off, reg);
	else if (salign >= size && size == 2)
		print("lhu $%d,%d($%d)\n",  tmp, off, reg);
	else if (salign >= size)
		print("lw $%d,%d($%d)\n",   tmp, off, reg);
	else if (size == 2)
		print("ulhu $%d,%d($%d)\n", tmp, off, reg);
	else
		print("ulw $%d,%d($%d)\n",  tmp, off, reg);
}
static void blkstore(size, off, reg, tmp) {
	if (size == 1)
		print("sb $%d,%d($%d)\n",  tmp, off, reg);
	else if (dalign >= size && size == 2)
		print("sh $%d,%d($%d)\n",  tmp, off, reg);
	else if (dalign >= size)
		print("sw $%d,%d($%d)\n",  tmp, off, reg);
	else if (size == 2)
		print("ush $%d,%d($%d)\n", tmp, off, reg);
	else
		print("usw $%d,%d($%d)\n", tmp, off, reg);
}
static void stabinit ARGS((char *, int, char *[]));
static void stabline ARGS((Coordinate *));
static void stabsym ARGS((Symbol));

static char *currentfile;

static int bitcount(mask) unsigned mask; {
	unsigned i, n = 0;

	for (i = 1; i; i <<= 1)
		if (mask&i)
			n++;
	return n;
}

/* stabinit - initialize stab output */
static void stabinit(file, argc, argv) char *file, *argv[]; {
	if (file) {
		print(".file 2,\"%s\"\n", file);
		currentfile = file;
	}
}

/* stabline - emit stab entry for source coordinate *cp */
static void stabline(cp) Coordinate *cp; {
	if (cp->file && cp->file != currentfile) {
		print(".file 2,\"%s\"\n", cp->file);
		currentfile = cp->file;
	}
	print(".loc 2,%d\n", cp->y);
}

/* stabsym - output a stab entry for symbol p */
static void stabsym(p) Symbol p; {
	if (p == cfunc && IR->stabline)
		(*IR->stabline)(&p->src);
}
Interface mipsebInterface = {
	1, 1, 0,  /* char */
	2, 2, 0,  /* short */
	4, 4, 0,  /* int */
	4, 4, 1,  /* float */
	8, 8, 1,  /* double */
	4, 4, 0,  /* T * */
	0, 1, 0,  /* struct */
	0,	/* little_endian */
	0,  /* mulops_calls */
	0,  /* wants_callb */
	1,  /* wants_argb */
	1,  /* left_to_right */
	0,  /* wants_dag */
	address,
	blockbeg,
	blockend,
	defaddress,
	defconst,
	defstring,
	defsymbol,
	emit,
	export,
	function,
	gen,
	global,
	import,
	local,
	progbeg,
	progend,
	segment,
	space,
	0, 0, 0, stabinit, stabline, stabsym, 0,
	{
		4,	/* max_unaligned_load */
		blkfetch, blkstore, blkloop,
		_label,
		_rule,
		_nts,
		_kids,
		_opname,
		_arity,
		_string,
		_templates,
		_isinstruction,
		_ntname,
		emit2,
		doarg,
		target,
		clobber,

	}
}, mipselInterface = {
	1, 1, 0,  /* char */
	2, 2, 0,  /* short */
	4, 4, 0,  /* int */
	4, 4, 1,  /* float */
	8, 8, 1,  /* double */
	4, 4, 0,  /* T * */
	0, 1, 0,  /* struct */
	1,	/* little_endian */
	0,  /* mulops_calls */
	0,  /* wants_callb */
	1,  /* wants_argb */
	1,  /* left_to_right */
	0,  /* wants_dag */
	address,
	blockbeg,
	blockend,
	defaddress,
	defconst,
	defstring,
	defsymbol,
	emit,
	export,
	function,
	gen,
	global,
	import,
	local,
	progbeg,
	progend,
	segment,
	space,
	0, 0, 0, stabinit, stabline, stabsym, 0,
	{
		4,	/* max_unaligned_load */
		blkfetch, blkstore, blkloop,
		_label,
		_rule,
		_nts,
		_kids,
		_opname,
		_arity,
		_string,
		_templates,
		_isinstruction,
		_ntname,
		emit2,
		doarg,
		target,
		clobber,

	}
};
