#include "c.h"
#define NODEPTR_TYPE Node
#define OP_LABEL(p) ((p)->op)
#define LEFT_CHILD(p) ((p)->kids[0])
#define RIGHT_CHILD(p) ((p)->kids[1])
#define STATE_LABEL(p) ((p)->x.state)
static void address     ARGS((Symbol, Symbol, int));
static void blkfetch    ARGS((int, int, int, int));
static void blkloop     ARGS((int, int, int, int, int, int[]));
static void blkstore    ARGS((int, int, int, int));
static void defaddress  ARGS((Symbol));
static void defconst    ARGS((int, Value));
static void defstring   ARGS((int, char *));
static void defsymbol   ARGS((Symbol));
static void doarg       ARGS((Node));
static void emit2       ARGS((Node));
static void export      ARGS((Symbol));
static void clobber     ARGS((Node));
static void function    ARGS((Symbol, Symbol [], Symbol [], int));
static void global      ARGS((Symbol));
static void import      ARGS((Symbol));
static void local       ARGS((Symbol));
static void progbeg     ARGS((int, char **));
static void progend     ARGS((void));
static void segment     ARGS((int));
static void space       ARGS((int));
static void target      ARGS((Node));
static int imm ARGS((Node));
static void rename ARGS((void));
static void defsymbol2 ARGS((Symbol));
static void global2 ARGS((Symbol));
static void segment2 ARGS((int));

static Symbol greg[32];
static Symbol *oreg = &greg[8], *ireg = &greg[24];
static Symbol freg[32], freg2[32];

static int retstruct;

static int pflag = 0;

static int cseg;

static char *_templates[] = {
/*   0 */  0,
/*   1 */  "# read register\n",  /* reg: INDIRC(VREGP) */
/*   2 */  "# read register\n",  /* reg: INDIRD(VREGP) */
/*   3 */  "# read register\n",  /* reg: INDIRF(VREGP) */
/*   4 */  "# read register\n",  /* reg: INDIRI(VREGP) */
/*   5 */  "# read register\n",  /* reg: INDIRP(VREGP) */
/*   6 */  "# read register\n",  /* reg: INDIRS(VREGP) */
/*   7 */  "# write register\n",  /* stmt: ASGNC(VREGP,reg) */
/*   8 */  "# write register\n",  /* stmt: ASGND(VREGP,reg) */
/*   9 */  "# write register\n",  /* stmt: ASGNF(VREGP,reg) */
/*  10 */  "# write register\n",  /* stmt: ASGNI(VREGP,reg) */
/*  11 */  "# write register\n",  /* stmt: ASGNP(VREGP,reg) */
/*  12 */  "# write register\n",  /* stmt: ASGNS(VREGP,reg) */
/*  13 */  "%a",  /* con: CNSTC */
/*  14 */  "%a",  /* con: CNSTI */
/*  15 */  "%a",  /* con: CNSTP */
/*  16 */  "%a",  /* con: CNSTS */
/*  17 */  "%a",  /* con: CNSTU */
/*  18 */  "",  /* stmt: reg */
/*  19 */  "%0",  /* reg: CVIU(reg) */
/*  20 */  "%0",  /* reg: CVPU(reg) */
/*  21 */  "%0",  /* reg: CVUI(reg) */
/*  22 */  "%0",  /* reg: CVUP(reg) */
/*  23 */  "set %a,%%%c\n",  /* reg: ADDRGP */
/*  24 */  "%a",  /* stk13: ADDRFP */
/*  25 */  "%a",  /* stk13: ADDRLP */
/*  26 */  "add %0,%%fp,%%%c\n",  /* reg: stk13 */
/*  27 */  "set %a,%%%c\n",  /* stk: ADDRFP */
/*  28 */  "set %a,%%%c\n",  /* stk: ADDRLP */
/*  29 */  "set %a,%%%c\nadd %%%c,%%fp,%%%c\n",  /* reg: ADDRFP */
/*  30 */  "set %a,%%%c\nadd %%%c,%%fp,%%%c\n",  /* reg: ADDRLP */
/*  31 */  "%a",  /* con13: CNSTC */
/*  32 */  "%a",  /* con13: CNSTI */
/*  33 */  "%a",  /* con13: CNSTP */
/*  34 */  "%a",  /* con13: CNSTS */
/*  35 */  "%a",  /* con13: CNSTU */
/*  36 */  "%%%0+%1",  /* base: ADDI(reg,con13) */
/*  37 */  "%%%0+%1",  /* base: ADDP(reg,con13) */
/*  38 */  "%%%0+%1",  /* base: ADDU(reg,con13) */
/*  39 */  "%%%0",  /* base: reg */
/*  40 */  "%0",  /* base: con13 */
/*  41 */  "%%fp+%0",  /* base: stk13 */
/*  42 */  "%0",  /* addr: base */
/*  43 */  "%%%0+%%%1",  /* addr: ADDI(reg,reg) */
/*  44 */  "%%%0+%%%1",  /* addr: ADDP(reg,reg) */
/*  45 */  "%%%0+%%%1",  /* addr: ADDU(reg,reg) */
/*  46 */  "%%fp+%%%0",  /* addr: stk */
/*  47 */  "ldsb [%0],%%%c\n",  /* reg: INDIRC(addr) */
/*  48 */  "ldsh [%0],%%%c\n",  /* reg: INDIRS(addr) */
/*  49 */  "ld [%0],%%%c\n",  /* reg: INDIRI(addr) */
/*  50 */  "ld [%0],%%%c\n",  /* reg: INDIRP(addr) */
/*  51 */  "ld [%0],%%f%c\n",  /* reg: INDIRF(addr) */
/*  52 */  "stb %%%1,[%0]\n",  /* stmt: ASGNC(addr,reg) */
/*  53 */  "sth %%%1,[%0]\n",  /* stmt: ASGNS(addr,reg) */
/*  54 */  "st %%%1,[%0]\n",  /* stmt: ASGNI(addr,reg) */
/*  55 */  "st %%%1,[%0]\n",  /* stmt: ASGNP(addr,reg) */
/*  56 */  "st %%f%1,[%0]\n",  /* stmt: ASGNF(addr,reg) */
/*  57 */  "%%%fp+%a",  /* addrl: ADDRLP */
/*  58 */  "ldd [%0],%%f%c\n",  /* reg: INDIRD(addrl) */
/*  59 */  "std %%f%1,[%0]\n",  /* stmt: ASGND(addrl,reg) */
/*  60 */  "ld2 [%0],%%f%c\n",  /* reg: INDIRD(base) */
/*  61 */  "st2 %%f%1,[%0]\n",  /* stmt: ASGND(base,reg) */
/*  62 */  "%a",  /* spill: ADDRLP */
/*  63 */  "set %0,%%g1\nstb %%%1,[%%g1]\n",  /* stmt: ASGNC(spill,reg) */
/*  64 */  "set %0,%%g1\nsth %%%1,[%%g1]\n",  /* stmt: ASGNS(spill,reg) */
/*  65 */  "set %0,%%g1\nst %%%1,[%%g1]\n",  /* stmt: ASGNI(spill,reg) */
/*  66 */  "set %0,%%g1\nst %%%1,[%%g1]\n",  /* stmt: ASGNP(spill,reg) */
/*  67 */  "set %0,%%g1\nst %%f%1,[%%g1]\n",  /* stmt: ASGNF(spill,reg) */
/*  68 */  "set %0,%%g1\nstd %%f%1,[%%g1]\n",  /* stmt: ASGND(spill,reg) */
/*  69 */  "ldsb [%0],%%%c\n",  /* reg: CVCI(INDIRC(addr)) */
/*  70 */  "ldsh [%0],%%%c\n",  /* reg: CVSI(INDIRS(addr)) */
/*  71 */  "ldub [%0],%%%c\n",  /* reg: CVCU(INDIRC(addr)) */
/*  72 */  "lduh [%0],%%%c\n",  /* reg: CVSU(INDIRS(addr)) */
/*  73 */  "mov %%%0,%%%c\n",  /* reg: CVIC(reg) */
/*  74 */  "mov %%%0,%%%c\n",  /* reg: CVIS(reg) */
/*  75 */  "mov %%%0,%%%c\n",  /* reg: CVIU(reg) */
/*  76 */  "mov %%%0,%%%c\n",  /* reg: CVPU(reg) */
/*  77 */  "mov %%%0,%%%c\n",  /* reg: CVUC(reg) */
/*  78 */  "mov %%%0,%%%c\n",  /* reg: CVUI(reg) */
/*  79 */  "mov %%%0,%%%c\n",  /* reg: CVUP(reg) */
/*  80 */  "mov %%%0,%%%c\n",  /* reg: CVUS(reg) */
/*  81 */  "%0",  /* reg: CVIC(reg) */
/*  82 */  "%0",  /* reg: CVIS(reg) */
/*  83 */  "%0",  /* reg: CVUC(reg) */
/*  84 */  "%0",  /* reg: CVUS(reg) */
/*  85 */  "mov %%%0,%%%c\n",  /* reg: LOADC(reg) */
/*  86 */  "mov %%%0,%%%c\n",  /* reg: LOADI(reg) */
/*  87 */  "mov %%%0,%%%c\n",  /* reg: LOADP(reg) */
/*  88 */  "mov %%%0,%%%c\n",  /* reg: LOADS(reg) */
/*  89 */  "mov %%%0,%%%c\n",  /* reg: LOADU(reg) */
/*  90 */  "# reg\n",  /* reg: CNSTC */
/*  91 */  "# reg\n",  /* reg: CNSTI */
/*  92 */  "# reg\n",  /* reg: CNSTP */
/*  93 */  "# reg\n",  /* reg: CNSTS */
/*  94 */  "# reg\n",  /* reg: CNSTU */
/*  95 */  "set %0,%%%c\n",  /* reg: con */
/*  96 */  "%0",  /* rc: con13 */
/*  97 */  "%%%0",  /* rc: reg */
/*  98 */  "add %%%0,%1,%%%c\n",  /* reg: ADDI(reg,rc) */
/*  99 */  "add %%%0,%1,%%%c\n",  /* reg: ADDP(reg,rc) */
/* 100 */  "add %%%0,%1,%%%c\n",  /* reg: ADDU(reg,rc) */
/* 101 */  "and %%%0,%1,%%%c\n",  /* reg: BANDU(reg,rc) */
/* 102 */  "or %%%0,%1,%%%c\n",  /* reg: BORU(reg,rc) */
/* 103 */  "xor %%%0,%1,%%%c\n",  /* reg: BXORU(reg,rc) */
/* 104 */  "sub %%%0,%1,%%%c\n",  /* reg: SUBI(reg,rc) */
/* 105 */  "sub %%%0,%1,%%%c\n",  /* reg: SUBP(reg,rc) */
/* 106 */  "sub %%%0,%1,%%%c\n",  /* reg: SUBU(reg,rc) */
/* 107 */  "%a",  /* rc5: CNSTI */
/* 108 */  "%%%0",  /* rc5: reg */
/* 109 */  "sll %%%0,%1,%%%c\n",  /* reg: LSHI(reg,rc5) */
/* 110 */  "sll %%%0,%1,%%%c\n",  /* reg: LSHU(reg,rc5) */
/* 111 */  "sra %%%0,%1,%%%c\n",  /* reg: RSHI(reg,rc5) */
/* 112 */  "srl %%%0,%1,%%%c\n",  /* reg: RSHU(reg,rc5) */
/* 113 */  "andn %%%0,%1,%%%c\n",  /* reg: BANDU(reg,BCOMU(rc)) */
/* 114 */  "orn %%%0,%1,%%%c\n",  /* reg: BORU(reg,BCOMU(rc)) */
/* 115 */  "xnor %%%0,%1,%%%c\n",  /* reg: BXORU(reg,BCOMU(rc)) */
/* 116 */  "neg %%%0,%%%c\n",  /* reg: NEGI(reg) */
/* 117 */  "not %%%0,%%%c\n",  /* reg: BCOMU(reg) */
/* 118 */  "sll %%%0,24,%%g1; sra %%g1,24,%%%c\n",  /* reg: CVCI(reg) */
/* 119 */  "sll %%%0,16,%%g1; sra %%g1,16,%%%c\n",  /* reg: CVSI(reg) */
/* 120 */  "and %%%0,0xff,%%%c\n",  /* reg: CVCU(reg) */
/* 121 */  "set 0xffff,%%g1; and %%%0,%%g1,%%%c\n",  /* reg: CVSU(reg) */
/* 122 */  "%a",  /* addrg: ADDRGP */
/* 123 */  "ba %0; nop\n",  /* stmt: JUMPV(addrg) */
/* 124 */  "jmp %0; nop\n",  /* stmt: JUMPV(addr) */
/* 125 */  "%a:\n",  /* stmt: LABELV */
/* 126 */  "cmp %%%0,%1; be %a; nop\n",  /* stmt: EQI(reg,rc) */
/* 127 */  "cmp %%%0,%1; bge %a; nop\n",  /* stmt: GEI(reg,rc) */
/* 128 */  "cmp %%%0,%1; bgeu %a; nop\n",  /* stmt: GEU(reg,rc) */
/* 129 */  "cmp %%%0,%1; bg %a; nop\n",  /* stmt: GTI(reg,rc) */
/* 130 */  "cmp %%%0,%1; bgu %a; nop\n",  /* stmt: GTU(reg,rc) */
/* 131 */  "cmp %%%0,%1; ble %a; nop\n",  /* stmt: LEI(reg,rc) */
/* 132 */  "cmp %%%0,%1; bleu %a; nop\n",  /* stmt: LEU(reg,rc) */
/* 133 */  "cmp %%%0,%1; bl %a; nop\n",  /* stmt: LTI(reg,rc) */
/* 134 */  "cmp %%%0,%1; blu %a; nop\n",  /* stmt: LTU(reg,rc) */
/* 135 */  "cmp %%%0,%1; bne %a; nop\n",  /* stmt: NEI(reg,rc) */
/* 136 */  "%a",  /* call: ADDRGP */
/* 137 */  "%0",  /* call: addr */
/* 138 */  "call %0; nop\n",  /* reg: CALLD(call) */
/* 139 */  "call %0; nop\n",  /* reg: CALLF(call) */
/* 140 */  "call %0; nop\n",  /* reg: CALLI(call) */
/* 141 */  "call %0; nop\n",  /* stmt: CALLV(call) */
/* 142 */  "call %0; st %%%1,[%%sp+64]\n",  /* stmt: CALLB(call,reg) */
/* 143 */  "# ret\n",  /* stmt: RETD(reg) */
/* 144 */  "# ret\n",  /* stmt: RETF(reg) */
/* 145 */  "# ret\n",  /* stmt: RETI(reg) */
/* 146 */  "st %%%0,[%%sp+4*%c+68]\n",  /* stmt: ARGI(reg) */
/* 147 */  "st %%%0,[%%sp+4*%c+68]\n",  /* stmt: ARGP(reg) */
/* 148 */  "# ARGD\n",  /* stmt: ARGD(reg) */
/* 149 */  "# ARGF\n",  /* stmt: ARGF(reg) */
/* 150 */  "call .div,2; nop\n",  /* reg: DIVI(reg,reg) */
/* 151 */  "call .udiv,2; nop\n",  /* reg: DIVU(reg,reg) */
/* 152 */  "call .rem,2; nop\n",  /* reg: MODI(reg,reg) */
/* 153 */  "call .urem,2; nop\n",  /* reg: MODU(reg,reg) */
/* 154 */  "call .mul,2; nop\n",  /* reg: MULI(reg,reg) */
/* 155 */  "call .umul,2; nop\n",  /* reg: MULU(reg,reg) */
/* 156 */  "faddd %%f%0,%%f%1,%%f%c\n",  /* reg: ADDD(reg,reg) */
/* 157 */  "fadds %%f%0,%%f%1,%%f%c\n",  /* reg: ADDF(reg,reg) */
/* 158 */  "fdivd %%f%0,%%f%1,%%f%c\n",  /* reg: DIVD(reg,reg) */
/* 159 */  "fdivs %%f%0,%%f%1,%%f%c\n",  /* reg: DIVF(reg,reg) */
/* 160 */  "fmuld %%f%0,%%f%1,%%f%c\n",  /* reg: MULD(reg,reg) */
/* 161 */  "fmuls %%f%0,%%f%1,%%f%c\n",  /* reg: MULF(reg,reg) */
/* 162 */  "fsubd %%f%0,%%f%1,%%f%c\n",  /* reg: SUBD(reg,reg) */
/* 163 */  "fsubs %%f%0,%%f%1,%%f%c\n",  /* reg: SUBF(reg,reg) */
/* 164 */  "fnegs %%f%0,%%f%c\n",  /* reg: NEGF(reg) */
/* 165 */  "fmovs %%f%0,%%f%c\n",  /* reg: LOADF(reg) */
/* 166 */  "fdtos %%f%0,%%f%c\n",  /* reg: CVDF(reg) */
/* 167 */  "fstod %%f%0,%%f%c\n",  /* reg: CVFD(reg) */
/* 168 */  "fdtoi %%f%0,%%f0; st %%f0,[%%sp+64]; ld [%%sp+64],%%%c\n",  /* reg: CVDI(reg) */
/* 169 */  "st %%%0,[%%sp+64]; ld [%%sp+64],%%f%c; fitod %%f%c,%%f%c\n",  /* reg: CVID(reg) */
/* 170 */  "fcmped %%f%0,%%f%1; nop; fbue %a; nop\n",  /* stmt: EQD(reg,reg) */
/* 171 */  "fcmpes %%f%0,%%f%1; nop; fbue %a; nop\n",  /* stmt: EQF(reg,reg) */
/* 172 */  "fcmped %%f%0,%%f%1; nop; fbuge %a; nop\n",  /* stmt: GED(reg,reg) */
/* 173 */  "fcmpes %%f%0,%%f%1; nop; fbuge %a; nop\n",  /* stmt: GEF(reg,reg) */
/* 174 */  "fcmped %%f%0,%%f%1; nop; fbug %a; nop\n",  /* stmt: GTD(reg,reg) */
/* 175 */  "fcmpes %%f%0,%%f%1; nop; fbug %a; nop\n",  /* stmt: GTF(reg,reg) */
/* 176 */  "fcmped %%f%0,%%f%1; nop; fbule %a; nop\n",  /* stmt: LED(reg,reg) */
/* 177 */  "fcmpes %%f%0,%%f%1; nop; fbule %a; nop\n",  /* stmt: LEF(reg,reg) */
/* 178 */  "fcmped %%f%0,%%f%1; nop; fbul %a; nop\n",  /* stmt: LTD(reg,reg) */
/* 179 */  "fcmpes %%f%0,%%f%1; nop; fbul %a; nop\n",  /* stmt: LTF(reg,reg) */
/* 180 */  "fcmped %%f%0,%%f%1; nop; fbne %a; nop\n",  /* stmt: NED(reg,reg) */
/* 181 */  "fcmpes %%f%0,%%f%1; nop; fbne %a; nop\n",  /* stmt: NEF(reg,reg) */
/* 182 */  "# LOADD\n",  /* reg: LOADD(reg) */
/* 183 */  "# NEGD\n",  /* reg: NEGD(reg) */
/* 184 */  "# ASGNB\n",  /* stmt: ASGNB(reg,INDIRB(reg)) */
};

static char _isinstruction[] = {
/*   0 */  0,
/*   1 */  1,/* # read register\n */
/*   2 */  1,/* # read register\n */
/*   3 */  1,/* # read register\n */
/*   4 */  1,/* # read register\n */
/*   5 */  1,/* # read register\n */
/*   6 */  1,/* # read register\n */
/*   7 */  1,/* # write register\n */
/*   8 */  1,/* # write register\n */
/*   9 */  1,/* # write register\n */
/*  10 */  1,/* # write register\n */
/*  11 */  1,/* # write register\n */
/*  12 */  1,/* # write register\n */
/*  13 */  0,/* %a */
/*  14 */  0,/* %a */
/*  15 */  0,/* %a */
/*  16 */  0,/* %a */
/*  17 */  0,/* %a */
/*  18 */  0,/*  */
/*  19 */  0,/* %0 */
/*  20 */  0,/* %0 */
/*  21 */  0,/* %0 */
/*  22 */  0,/* %0 */
/*  23 */  1,/* set %a,%%%c\n */
/*  24 */  0,/* %a */
/*  25 */  0,/* %a */
/*  26 */  1,/* add %0,%%fp,%%%c\n */
/*  27 */  1,/* set %a,%%%c\n */
/*  28 */  1,/* set %a,%%%c\n */
/*  29 */  1,/* set %a,%%%c\nadd %%%c,%%fp,%%%c\n */
/*  30 */  1,/* set %a,%%%c\nadd %%%c,%%fp,%%%c\n */
/*  31 */  0,/* %a */
/*  32 */  0,/* %a */
/*  33 */  0,/* %a */
/*  34 */  0,/* %a */
/*  35 */  0,/* %a */
/*  36 */  0,/* %%%0+%1 */
/*  37 */  0,/* %%%0+%1 */
/*  38 */  0,/* %%%0+%1 */
/*  39 */  0,/* %%%0 */
/*  40 */  0,/* %0 */
/*  41 */  0,/* %%fp+%0 */
/*  42 */  0,/* %0 */
/*  43 */  0,/* %%%0+%%%1 */
/*  44 */  0,/* %%%0+%%%1 */
/*  45 */  0,/* %%%0+%%%1 */
/*  46 */  0,/* %%fp+%%%0 */
/*  47 */  1,/* ldsb [%0],%%%c\n */
/*  48 */  1,/* ldsh [%0],%%%c\n */
/*  49 */  1,/* ld [%0],%%%c\n */
/*  50 */  1,/* ld [%0],%%%c\n */
/*  51 */  1,/* ld [%0],%%f%c\n */
/*  52 */  1,/* stb %%%1,[%0]\n */
/*  53 */  1,/* sth %%%1,[%0]\n */
/*  54 */  1,/* st %%%1,[%0]\n */
/*  55 */  1,/* st %%%1,[%0]\n */
/*  56 */  1,/* st %%f%1,[%0]\n */
/*  57 */  0,/* %%%fp+%a */
/*  58 */  1,/* ldd [%0],%%f%c\n */
/*  59 */  1,/* std %%f%1,[%0]\n */
/*  60 */  1,/* ld2 [%0],%%f%c\n */
/*  61 */  1,/* st2 %%f%1,[%0]\n */
/*  62 */  0,/* %a */
/*  63 */  1,/* set %0,%%g1\nstb %%%1,[%%g1]\n */
/*  64 */  1,/* set %0,%%g1\nsth %%%1,[%%g1]\n */
/*  65 */  1,/* set %0,%%g1\nst %%%1,[%%g1]\n */
/*  66 */  1,/* set %0,%%g1\nst %%%1,[%%g1]\n */
/*  67 */  1,/* set %0,%%g1\nst %%f%1,[%%g1]\n */
/*  68 */  1,/* set %0,%%g1\nstd %%f%1,[%%g1]\n */
/*  69 */  1,/* ldsb [%0],%%%c\n */
/*  70 */  1,/* ldsh [%0],%%%c\n */
/*  71 */  1,/* ldub [%0],%%%c\n */
/*  72 */  1,/* lduh [%0],%%%c\n */
/*  73 */  1,/* mov %%%0,%%%c\n */
/*  74 */  1,/* mov %%%0,%%%c\n */
/*  75 */  1,/* mov %%%0,%%%c\n */
/*  76 */  1,/* mov %%%0,%%%c\n */
/*  77 */  1,/* mov %%%0,%%%c\n */
/*  78 */  1,/* mov %%%0,%%%c\n */
/*  79 */  1,/* mov %%%0,%%%c\n */
/*  80 */  1,/* mov %%%0,%%%c\n */
/*  81 */  0,/* %0 */
/*  82 */  0,/* %0 */
/*  83 */  0,/* %0 */
/*  84 */  0,/* %0 */
/*  85 */  1,/* mov %%%0,%%%c\n */
/*  86 */  1,/* mov %%%0,%%%c\n */
/*  87 */  1,/* mov %%%0,%%%c\n */
/*  88 */  1,/* mov %%%0,%%%c\n */
/*  89 */  1,/* mov %%%0,%%%c\n */
/*  90 */  1,/* # reg\n */
/*  91 */  1,/* # reg\n */
/*  92 */  1,/* # reg\n */
/*  93 */  1,/* # reg\n */
/*  94 */  1,/* # reg\n */
/*  95 */  1,/* set %0,%%%c\n */
/*  96 */  0,/* %0 */
/*  97 */  0,/* %%%0 */
/*  98 */  1,/* add %%%0,%1,%%%c\n */
/*  99 */  1,/* add %%%0,%1,%%%c\n */
/* 100 */  1,/* add %%%0,%1,%%%c\n */
/* 101 */  1,/* and %%%0,%1,%%%c\n */
/* 102 */  1,/* or %%%0,%1,%%%c\n */
/* 103 */  1,/* xor %%%0,%1,%%%c\n */
/* 104 */  1,/* sub %%%0,%1,%%%c\n */
/* 105 */  1,/* sub %%%0,%1,%%%c\n */
/* 106 */  1,/* sub %%%0,%1,%%%c\n */
/* 107 */  0,/* %a */
/* 108 */  0,/* %%%0 */
/* 109 */  1,/* sll %%%0,%1,%%%c\n */
/* 110 */  1,/* sll %%%0,%1,%%%c\n */
/* 111 */  1,/* sra %%%0,%1,%%%c\n */
/* 112 */  1,/* srl %%%0,%1,%%%c\n */
/* 113 */  1,/* andn %%%0,%1,%%%c\n */
/* 114 */  1,/* orn %%%0,%1,%%%c\n */
/* 115 */  1,/* xnor %%%0,%1,%%%c\n */
/* 116 */  1,/* neg %%%0,%%%c\n */
/* 117 */  1,/* not %%%0,%%%c\n */
/* 118 */  1,/* sll %%%0,24,%%g1; sra %%g1,24,%%%c\n */
/* 119 */  1,/* sll %%%0,16,%%g1; sra %%g1,16,%%%c\n */
/* 120 */  1,/* and %%%0,0xff,%%%c\n */
/* 121 */  1,/* set 0xffff,%%g1; and %%%0,%%g1,%%%c\n */
/* 122 */  0,/* %a */
/* 123 */  1,/* ba %0; nop\n */
/* 124 */  1,/* jmp %0; nop\n */
/* 125 */  1,/* %a:\n */
/* 126 */  1,/* cmp %%%0,%1; be %a; nop\n */
/* 127 */  1,/* cmp %%%0,%1; bge %a; nop\n */
/* 128 */  1,/* cmp %%%0,%1; bgeu %a; nop\n */
/* 129 */  1,/* cmp %%%0,%1; bg %a; nop\n */
/* 130 */  1,/* cmp %%%0,%1; bgu %a; nop\n */
/* 131 */  1,/* cmp %%%0,%1; ble %a; nop\n */
/* 132 */  1,/* cmp %%%0,%1; bleu %a; nop\n */
/* 133 */  1,/* cmp %%%0,%1; bl %a; nop\n */
/* 134 */  1,/* cmp %%%0,%1; blu %a; nop\n */
/* 135 */  1,/* cmp %%%0,%1; bne %a; nop\n */
/* 136 */  0,/* %a */
/* 137 */  0,/* %0 */
/* 138 */  1,/* call %0; nop\n */
/* 139 */  1,/* call %0; nop\n */
/* 140 */  1,/* call %0; nop\n */
/* 141 */  1,/* call %0; nop\n */
/* 142 */  1,/* call %0; st %%%1,[%%sp+64]\n */
/* 143 */  1,/* # ret\n */
/* 144 */  1,/* # ret\n */
/* 145 */  1,/* # ret\n */
/* 146 */  1,/* st %%%0,[%%sp+4*%c+68]\n */
/* 147 */  1,/* st %%%0,[%%sp+4*%c+68]\n */
/* 148 */  1,/* # ARGD\n */
/* 149 */  1,/* # ARGF\n */
/* 150 */  1,/* call .div,2; nop\n */
/* 151 */  1,/* call .udiv,2; nop\n */
/* 152 */  1,/* call .rem,2; nop\n */
/* 153 */  1,/* call .urem,2; nop\n */
/* 154 */  1,/* call .mul,2; nop\n */
/* 155 */  1,/* call .umul,2; nop\n */
/* 156 */  1,/* faddd %%f%0,%%f%1,%%f%c\n */
/* 157 */  1,/* fadds %%f%0,%%f%1,%%f%c\n */
/* 158 */  1,/* fdivd %%f%0,%%f%1,%%f%c\n */
/* 159 */  1,/* fdivs %%f%0,%%f%1,%%f%c\n */
/* 160 */  1,/* fmuld %%f%0,%%f%1,%%f%c\n */
/* 161 */  1,/* fmuls %%f%0,%%f%1,%%f%c\n */
/* 162 */  1,/* fsubd %%f%0,%%f%1,%%f%c\n */
/* 163 */  1,/* fsubs %%f%0,%%f%1,%%f%c\n */
/* 164 */  1,/* fnegs %%f%0,%%f%c\n */
/* 165 */  1,/* fmovs %%f%0,%%f%c\n */
/* 166 */  1,/* fdtos %%f%0,%%f%c\n */
/* 167 */  1,/* fstod %%f%0,%%f%c\n */
/* 168 */  1,/* fdtoi %%f%0,%%f0; st %%f0,[%%sp+64]; ld [%%sp+64],%%%c\n */
/* 169 */  1,/* st %%%0,[%%sp+64]; ld [%%sp+64],%%f%c; fitod %%f%c,%%f%c\n */
/* 170 */  1,/* fcmped %%f%0,%%f%1; nop; fbue %a; nop\n */
/* 171 */  1,/* fcmpes %%f%0,%%f%1; nop; fbue %a; nop\n */
/* 172 */  1,/* fcmped %%f%0,%%f%1; nop; fbuge %a; nop\n */
/* 173 */  1,/* fcmpes %%f%0,%%f%1; nop; fbuge %a; nop\n */
/* 174 */  1,/* fcmped %%f%0,%%f%1; nop; fbug %a; nop\n */
/* 175 */  1,/* fcmpes %%f%0,%%f%1; nop; fbug %a; nop\n */
/* 176 */  1,/* fcmped %%f%0,%%f%1; nop; fbule %a; nop\n */
/* 177 */  1,/* fcmpes %%f%0,%%f%1; nop; fbule %a; nop\n */
/* 178 */  1,/* fcmped %%f%0,%%f%1; nop; fbul %a; nop\n */
/* 179 */  1,/* fcmpes %%f%0,%%f%1; nop; fbul %a; nop\n */
/* 180 */  1,/* fcmped %%f%0,%%f%1; nop; fbne %a; nop\n */
/* 181 */  1,/* fcmpes %%f%0,%%f%1; nop; fbne %a; nop\n */
/* 182 */  1,/* # LOADD\n */
/* 183 */  1,/* # NEGD\n */
/* 184 */  1,/* # ASGNB\n */
};

static void _kids ARGS((NODEPTR_TYPE, int, NODEPTR_TYPE[]));
static void _label ARGS((NODEPTR_TYPE));
static int _rule ARGS((void*, int));
#define _stmt_NT 1
#define _addr_NT 2
#define _addrg_NT 3
#define _addrl_NT 4
#define _base_NT 5
#define _call_NT 6
#define _con_NT 7
#define _con13_NT 8
#define _rc_NT 9
#define _rc5_NT 10
#define _reg_NT 11
#define _spill_NT 12
#define _stk_NT 13
#define _stk13_NT 14

static char *_ntname[] = {
	0,
	"stmt",
	"addr",
	"addrg",
	"addrl",
	"base",
	"call",
	"con",
	"con13",
	"rc",
	"rc5",
	"reg",
	"spill",
	"stk",
	"stk13",
	0
};

static char _arity[] = {
	0,
	0,  /* 1 */
	0,  /* 2 */
	0,  /* 3 */
	0,  /* 4 */
	0,  /* 5 */
	0,  /* 6 */
	0,  /* 7 */
	0,  /* 8 */
	0,  /* 9 */
	0,  /* 10 */
	0,  /* 11 */
	0,  /* 12 */
	0,  /* 13 */
	0,  /* 14 */
	0,  /* 15 */
	0,  /* 16 */
	0,  /* 17=CNSTF */
	0,  /* 18=CNSTD */
	0,  /* 19=CNSTC */
	0,  /* 20=CNSTS */
	0,  /* 21=CNSTI */
	0,  /* 22=CNSTU */
	0,  /* 23=CNSTP */
	0,  /* 24 */
	0,  /* 25 */
	0,  /* 26 */
	0,  /* 27 */
	0,  /* 28 */
	0,  /* 29 */
	0,  /* 30 */
	0,  /* 31 */
	0,  /* 32 */
	1,  /* 33=ARGF */
	1,  /* 34=ARGD */
	0,  /* 35 */
	0,  /* 36 */
	1,  /* 37=ARGI */
	0,  /* 38 */
	1,  /* 39=ARGP */
	0,  /* 40 */
	0,  /* 41=ARGB */
	0,  /* 42 */
	0,  /* 43 */
	0,  /* 44 */
	0,  /* 45 */
	0,  /* 46 */
	0,  /* 47 */
	0,  /* 48 */
	2,  /* 49=ASGNF */
	2,  /* 50=ASGND */
	2,  /* 51=ASGNC */
	2,  /* 52=ASGNS */
	2,  /* 53=ASGNI */
	0,  /* 54 */
	2,  /* 55=ASGNP */
	0,  /* 56 */
	2,  /* 57=ASGNB */
	0,  /* 58 */
	0,  /* 59 */
	0,  /* 60 */
	0,  /* 61 */
	0,  /* 62 */
	0,  /* 63 */
	0,  /* 64 */
	1,  /* 65=INDIRF */
	1,  /* 66=INDIRD */
	1,  /* 67=INDIRC */
	1,  /* 68=INDIRS */
	1,  /* 69=INDIRI */
	0,  /* 70 */
	1,  /* 71=INDIRP */
	0,  /* 72 */
	1,  /* 73=INDIRB */
	0,  /* 74 */
	0,  /* 75 */
	0,  /* 76 */
	0,  /* 77 */
	0,  /* 78 */
	0,  /* 79 */
	0,  /* 80 */
	0,  /* 81 */
	0,  /* 82 */
	0,  /* 83 */
	0,  /* 84 */
	1,  /* 85=CVCI */
	1,  /* 86=CVCU */
	0,  /* 87 */
	0,  /* 88 */
	0,  /* 89 */
	0,  /* 90 */
	0,  /* 91 */
	0,  /* 92 */
	0,  /* 93 */
	0,  /* 94 */
	0,  /* 95 */
	0,  /* 96 */
	1,  /* 97=CVDF */
	0,  /* 98 */
	0,  /* 99 */
	0,  /* 100 */
	1,  /* 101=CVDI */
	0,  /* 102 */
	0,  /* 103 */
	0,  /* 104 */
	0,  /* 105 */
	0,  /* 106 */
	0,  /* 107 */
	0,  /* 108 */
	0,  /* 109 */
	0,  /* 110 */
	0,  /* 111 */
	0,  /* 112 */
	0,  /* 113 */
	1,  /* 114=CVFD */
	0,  /* 115 */
	0,  /* 116 */
	0,  /* 117 */
	0,  /* 118 */
	0,  /* 119 */
	0,  /* 120 */
	0,  /* 121 */
	0,  /* 122 */
	0,  /* 123 */
	0,  /* 124 */
	0,  /* 125 */
	0,  /* 126 */
	0,  /* 127 */
	0,  /* 128 */
	0,  /* 129 */
	1,  /* 130=CVID */
	1,  /* 131=CVIC */
	1,  /* 132=CVIS */
	0,  /* 133 */
	1,  /* 134=CVIU */
	0,  /* 135 */
	0,  /* 136 */
	0,  /* 137 */
	0,  /* 138 */
	0,  /* 139 */
	0,  /* 140 */
	0,  /* 141 */
	0,  /* 142 */
	0,  /* 143 */
	0,  /* 144 */
	0,  /* 145 */
	0,  /* 146 */
	0,  /* 147 */
	0,  /* 148 */
	0,  /* 149 */
	1,  /* 150=CVPU */
	0,  /* 151 */
	0,  /* 152 */
	0,  /* 153 */
	0,  /* 154 */
	0,  /* 155 */
	0,  /* 156 */
	0,  /* 157 */
	0,  /* 158 */
	0,  /* 159 */
	0,  /* 160 */
	0,  /* 161 */
	0,  /* 162 */
	0,  /* 163 */
	0,  /* 164 */
	1,  /* 165=CVSI */
	1,  /* 166=CVSU */
	0,  /* 167 */
	0,  /* 168 */
	0,  /* 169 */
	0,  /* 170 */
	0,  /* 171 */
	0,  /* 172 */
	0,  /* 173 */
	0,  /* 174 */
	0,  /* 175 */
	0,  /* 176 */
	0,  /* 177 */
	0,  /* 178 */
	1,  /* 179=CVUC */
	1,  /* 180=CVUS */
	1,  /* 181=CVUI */
	0,  /* 182 */
	1,  /* 183=CVUP */
	0,  /* 184 */
	0,  /* 185 */
	0,  /* 186 */
	0,  /* 187 */
	0,  /* 188 */
	0,  /* 189 */
	0,  /* 190 */
	0,  /* 191 */
	0,  /* 192 */
	1,  /* 193=NEGF */
	1,  /* 194=NEGD */
	0,  /* 195 */
	0,  /* 196 */
	1,  /* 197=NEGI */
	0,  /* 198 */
	0,  /* 199 */
	0,  /* 200 */
	0,  /* 201 */
	0,  /* 202 */
	0,  /* 203 */
	0,  /* 204 */
	0,  /* 205 */
	0,  /* 206 */
	0,  /* 207 */
	0,  /* 208 */
	1,  /* 209=CALLF */
	1,  /* 210=CALLD */
	0,  /* 211 */
	0,  /* 212 */
	1,  /* 213=CALLI */
	0,  /* 214 */
	0,  /* 215 */
	1,  /* 216=CALLV */
	2,  /* 217=CALLB */
	0,  /* 218 */
	0,  /* 219 */
	0,  /* 220 */
	0,  /* 221 */
	0,  /* 222 */
	0,  /* 223 */
	0,  /* 224 */
	1,  /* 225=LOADF */
	1,  /* 226=LOADD */
	1,  /* 227=LOADC */
	1,  /* 228=LOADS */
	1,  /* 229=LOADI */
	1,  /* 230=LOADU */
	1,  /* 231=LOADP */
	0,  /* 232 */
	0,  /* 233=LOADB */
	0,  /* 234 */
	0,  /* 235 */
	0,  /* 236 */
	0,  /* 237 */
	0,  /* 238 */
	0,  /* 239 */
	0,  /* 240 */
	1,  /* 241=RETF */
	1,  /* 242=RETD */
	0,  /* 243 */
	0,  /* 244 */
	1,  /* 245=RETI */
	0,  /* 246 */
	0,  /* 247 */
	0,  /* 248 */
	0,  /* 249 */
	0,  /* 250 */
	0,  /* 251 */
	0,  /* 252 */
	0,  /* 253 */
	0,  /* 254 */
	0,  /* 255 */
	0,  /* 256 */
	0,  /* 257 */
	0,  /* 258 */
	0,  /* 259 */
	0,  /* 260 */
	0,  /* 261 */
	0,  /* 262 */
	0,  /* 263=ADDRGP */
	0,  /* 264 */
	0,  /* 265 */
	0,  /* 266 */
	0,  /* 267 */
	0,  /* 268 */
	0,  /* 269 */
	0,  /* 270 */
	0,  /* 271 */
	0,  /* 272 */
	0,  /* 273 */
	0,  /* 274 */
	0,  /* 275 */
	0,  /* 276 */
	0,  /* 277 */
	0,  /* 278 */
	0,  /* 279=ADDRFP */
	0,  /* 280 */
	0,  /* 281 */
	0,  /* 282 */
	0,  /* 283 */
	0,  /* 284 */
	0,  /* 285 */
	0,  /* 286 */
	0,  /* 287 */
	0,  /* 288 */
	0,  /* 289 */
	0,  /* 290 */
	0,  /* 291 */
	0,  /* 292 */
	0,  /* 293 */
	0,  /* 294 */
	0,  /* 295=ADDRLP */
	0,  /* 296 */
	0,  /* 297 */
	0,  /* 298 */
	0,  /* 299 */
	0,  /* 300 */
	0,  /* 301 */
	0,  /* 302 */
	0,  /* 303 */
	0,  /* 304 */
	2,  /* 305=ADDF */
	2,  /* 306=ADDD */
	0,  /* 307 */
	0,  /* 308 */
	2,  /* 309=ADDI */
	2,  /* 310=ADDU */
	2,  /* 311=ADDP */
	0,  /* 312 */
	0,  /* 313 */
	0,  /* 314 */
	0,  /* 315 */
	0,  /* 316 */
	0,  /* 317 */
	0,  /* 318 */
	0,  /* 319 */
	0,  /* 320 */
	2,  /* 321=SUBF */
	2,  /* 322=SUBD */
	0,  /* 323 */
	0,  /* 324 */
	2,  /* 325=SUBI */
	2,  /* 326=SUBU */
	2,  /* 327=SUBP */
	0,  /* 328 */
	0,  /* 329 */
	0,  /* 330 */
	0,  /* 331 */
	0,  /* 332 */
	0,  /* 333 */
	0,  /* 334 */
	0,  /* 335 */
	0,  /* 336 */
	0,  /* 337 */
	0,  /* 338 */
	0,  /* 339 */
	0,  /* 340 */
	2,  /* 341=LSHI */
	2,  /* 342=LSHU */
	0,  /* 343 */
	0,  /* 344 */
	0,  /* 345 */
	0,  /* 346 */
	0,  /* 347 */
	0,  /* 348 */
	0,  /* 349 */
	0,  /* 350 */
	0,  /* 351 */
	0,  /* 352 */
	0,  /* 353 */
	0,  /* 354 */
	0,  /* 355 */
	0,  /* 356 */
	2,  /* 357=MODI */
	2,  /* 358=MODU */
	0,  /* 359 */
	0,  /* 360 */
	0,  /* 361 */
	0,  /* 362 */
	0,  /* 363 */
	0,  /* 364 */
	0,  /* 365 */
	0,  /* 366 */
	0,  /* 367 */
	0,  /* 368 */
	0,  /* 369 */
	0,  /* 370 */
	0,  /* 371 */
	0,  /* 372 */
	2,  /* 373=RSHI */
	2,  /* 374=RSHU */
	0,  /* 375 */
	0,  /* 376 */
	0,  /* 377 */
	0,  /* 378 */
	0,  /* 379 */
	0,  /* 380 */
	0,  /* 381 */
	0,  /* 382 */
	0,  /* 383 */
	0,  /* 384 */
	0,  /* 385 */
	0,  /* 386 */
	0,  /* 387 */
	0,  /* 388 */
	0,  /* 389 */
	2,  /* 390=BANDU */
	0,  /* 391 */
	0,  /* 392 */
	0,  /* 393 */
	0,  /* 394 */
	0,  /* 395 */
	0,  /* 396 */
	0,  /* 397 */
	0,  /* 398 */
	0,  /* 399 */
	0,  /* 400 */
	0,  /* 401 */
	0,  /* 402 */
	0,  /* 403 */
	0,  /* 404 */
	0,  /* 405 */
	1,  /* 406=BCOMU */
	0,  /* 407 */
	0,  /* 408 */
	0,  /* 409 */
	0,  /* 410 */
	0,  /* 411 */
	0,  /* 412 */
	0,  /* 413 */
	0,  /* 414 */
	0,  /* 415 */
	0,  /* 416 */
	0,  /* 417 */
	0,  /* 418 */
	0,  /* 419 */
	0,  /* 420 */
	0,  /* 421 */
	2,  /* 422=BORU */
	0,  /* 423 */
	0,  /* 424 */
	0,  /* 425 */
	0,  /* 426 */
	0,  /* 427 */
	0,  /* 428 */
	0,  /* 429 */
	0,  /* 430 */
	0,  /* 431 */
	0,  /* 432 */
	0,  /* 433 */
	0,  /* 434 */
	0,  /* 435 */
	0,  /* 436 */
	0,  /* 437 */
	2,  /* 438=BXORU */
	0,  /* 439 */
	0,  /* 440 */
	0,  /* 441 */
	0,  /* 442 */
	0,  /* 443 */
	0,  /* 444 */
	0,  /* 445 */
	0,  /* 446 */
	0,  /* 447 */
	0,  /* 448 */
	2,  /* 449=DIVF */
	2,  /* 450=DIVD */
	0,  /* 451 */
	0,  /* 452 */
	2,  /* 453=DIVI */
	2,  /* 454=DIVU */
	0,  /* 455 */
	0,  /* 456 */
	0,  /* 457 */
	0,  /* 458 */
	0,  /* 459 */
	0,  /* 460 */
	0,  /* 461 */
	0,  /* 462 */
	0,  /* 463 */
	0,  /* 464 */
	2,  /* 465=MULF */
	2,  /* 466=MULD */
	0,  /* 467 */
	0,  /* 468 */
	2,  /* 469=MULI */
	2,  /* 470=MULU */
	0,  /* 471 */
	0,  /* 472 */
	0,  /* 473 */
	0,  /* 474 */
	0,  /* 475 */
	0,  /* 476 */
	0,  /* 477 */
	0,  /* 478 */
	0,  /* 479 */
	0,  /* 480 */
	2,  /* 481=EQF */
	2,  /* 482=EQD */
	0,  /* 483 */
	0,  /* 484 */
	2,  /* 485=EQI */
	0,  /* 486 */
	0,  /* 487 */
	0,  /* 488 */
	0,  /* 489 */
	0,  /* 490 */
	0,  /* 491 */
	0,  /* 492 */
	0,  /* 493 */
	0,  /* 494 */
	0,  /* 495 */
	0,  /* 496 */
	2,  /* 497=GEF */
	2,  /* 498=GED */
	0,  /* 499 */
	0,  /* 500 */
	2,  /* 501=GEI */
	2,  /* 502=GEU */
	0,  /* 503 */
	0,  /* 504 */
	0,  /* 505 */
	0,  /* 506 */
	0,  /* 507 */
	0,  /* 508 */
	0,  /* 509 */
	0,  /* 510 */
	0,  /* 511 */
	0,  /* 512 */
	2,  /* 513=GTF */
	2,  /* 514=GTD */
	0,  /* 515 */
	0,  /* 516 */
	2,  /* 517=GTI */
	2,  /* 518=GTU */
	0,  /* 519 */
	0,  /* 520 */
	0,  /* 521 */
	0,  /* 522 */
	0,  /* 523 */
	0,  /* 524 */
	0,  /* 525 */
	0,  /* 526 */
	0,  /* 527 */
	0,  /* 528 */
	2,  /* 529=LEF */
	2,  /* 530=LED */
	0,  /* 531 */
	0,  /* 532 */
	2,  /* 533=LEI */
	2,  /* 534=LEU */
	0,  /* 535 */
	0,  /* 536 */
	0,  /* 537 */
	0,  /* 538 */
	0,  /* 539 */
	0,  /* 540 */
	0,  /* 541 */
	0,  /* 542 */
	0,  /* 543 */
	0,  /* 544 */
	2,  /* 545=LTF */
	2,  /* 546=LTD */
	0,  /* 547 */
	0,  /* 548 */
	2,  /* 549=LTI */
	2,  /* 550=LTU */
	0,  /* 551 */
	0,  /* 552 */
	0,  /* 553 */
	0,  /* 554 */
	0,  /* 555 */
	0,  /* 556 */
	0,  /* 557 */
	0,  /* 558 */
	0,  /* 559 */
	0,  /* 560 */
	2,  /* 561=NEF */
	2,  /* 562=NED */
	0,  /* 563 */
	0,  /* 564 */
	2,  /* 565=NEI */
	0,  /* 566 */
	0,  /* 567 */
	0,  /* 568 */
	0,  /* 569 */
	0,  /* 570 */
	0,  /* 571 */
	0,  /* 572 */
	0,  /* 573 */
	0,  /* 574 */
	0,  /* 575 */
	0,  /* 576 */
	0,  /* 577 */
	0,  /* 578 */
	0,  /* 579 */
	0,  /* 580 */
	0,  /* 581 */
	0,  /* 582 */
	0,  /* 583 */
	1,  /* 584=JUMPV */
	0,  /* 585 */
	0,  /* 586 */
	0,  /* 587 */
	0,  /* 588 */
	0,  /* 589 */
	0,  /* 590 */
	0,  /* 591 */
	0,  /* 592 */
	0,  /* 593 */
	0,  /* 594 */
	0,  /* 595 */
	0,  /* 596 */
	0,  /* 597 */
	0,  /* 598 */
	0,  /* 599 */
	0,  /* 600=LABELV */
	0,  /* 601 */
	0,  /* 602 */
	0,  /* 603 */
	0,  /* 604 */
	0,  /* 605 */
	0,  /* 606 */
	0,  /* 607 */
	0,  /* 608 */
	0,  /* 609 */
	0,  /* 610 */
	0,  /* 611 */
	0,  /* 612 */
	0,  /* 613 */
	0,  /* 614 */
	0,  /* 615=VREGP */
};

static char *_opname[] = {
	0,
	0,  /* 1 */
	0,  /* 2 */
	0,  /* 3 */
	0,  /* 4 */
	0,  /* 5 */
	0,  /* 6 */
	0,  /* 7 */
	0,  /* 8 */
	0,  /* 9 */
	0,  /* 10 */
	0,  /* 11 */
	0,  /* 12 */
	0,  /* 13 */
	0,  /* 14 */
	0,  /* 15 */
	0,  /* 16 */
	"CNSTF",  /* 17 */
	"CNSTD",  /* 18 */
	"CNSTC",  /* 19 */
	"CNSTS",  /* 20 */
	"CNSTI",  /* 21 */
	"CNSTU",  /* 22 */
	"CNSTP",  /* 23 */
	0,  /* 24 */
	0,  /* 25 */
	0,  /* 26 */
	0,  /* 27 */
	0,  /* 28 */
	0,  /* 29 */
	0,  /* 30 */
	0,  /* 31 */
	0,  /* 32 */
	"ARGF",  /* 33 */
	"ARGD",  /* 34 */
	0,  /* 35 */
	0,  /* 36 */
	"ARGI",  /* 37 */
	0,  /* 38 */
	"ARGP",  /* 39 */
	0,  /* 40 */
	"ARGB",  /* 41 */
	0,  /* 42 */
	0,  /* 43 */
	0,  /* 44 */
	0,  /* 45 */
	0,  /* 46 */
	0,  /* 47 */
	0,  /* 48 */
	"ASGNF",  /* 49 */
	"ASGND",  /* 50 */
	"ASGNC",  /* 51 */
	"ASGNS",  /* 52 */
	"ASGNI",  /* 53 */
	0,  /* 54 */
	"ASGNP",  /* 55 */
	0,  /* 56 */
	"ASGNB",  /* 57 */
	0,  /* 58 */
	0,  /* 59 */
	0,  /* 60 */
	0,  /* 61 */
	0,  /* 62 */
	0,  /* 63 */
	0,  /* 64 */
	"INDIRF",  /* 65 */
	"INDIRD",  /* 66 */
	"INDIRC",  /* 67 */
	"INDIRS",  /* 68 */
	"INDIRI",  /* 69 */
	0,  /* 70 */
	"INDIRP",  /* 71 */
	0,  /* 72 */
	"INDIRB",  /* 73 */
	0,  /* 74 */
	0,  /* 75 */
	0,  /* 76 */
	0,  /* 77 */
	0,  /* 78 */
	0,  /* 79 */
	0,  /* 80 */
	0,  /* 81 */
	0,  /* 82 */
	0,  /* 83 */
	0,  /* 84 */
	"CVCI",  /* 85 */
	"CVCU",  /* 86 */
	0,  /* 87 */
	0,  /* 88 */
	0,  /* 89 */
	0,  /* 90 */
	0,  /* 91 */
	0,  /* 92 */
	0,  /* 93 */
	0,  /* 94 */
	0,  /* 95 */
	0,  /* 96 */
	"CVDF",  /* 97 */
	0,  /* 98 */
	0,  /* 99 */
	0,  /* 100 */
	"CVDI",  /* 101 */
	0,  /* 102 */
	0,  /* 103 */
	0,  /* 104 */
	0,  /* 105 */
	0,  /* 106 */
	0,  /* 107 */
	0,  /* 108 */
	0,  /* 109 */
	0,  /* 110 */
	0,  /* 111 */
	0,  /* 112 */
	0,  /* 113 */
	"CVFD",  /* 114 */
	0,  /* 115 */
	0,  /* 116 */
	0,  /* 117 */
	0,  /* 118 */
	0,  /* 119 */
	0,  /* 120 */
	0,  /* 121 */
	0,  /* 122 */
	0,  /* 123 */
	0,  /* 124 */
	0,  /* 125 */
	0,  /* 126 */
	0,  /* 127 */
	0,  /* 128 */
	0,  /* 129 */
	"CVID",  /* 130 */
	"CVIC",  /* 131 */
	"CVIS",  /* 132 */
	0,  /* 133 */
	"CVIU",  /* 134 */
	0,  /* 135 */
	0,  /* 136 */
	0,  /* 137 */
	0,  /* 138 */
	0,  /* 139 */
	0,  /* 140 */
	0,  /* 141 */
	0,  /* 142 */
	0,  /* 143 */
	0,  /* 144 */
	0,  /* 145 */
	0,  /* 146 */
	0,  /* 147 */
	0,  /* 148 */
	0,  /* 149 */
	"CVPU",  /* 150 */
	0,  /* 151 */
	0,  /* 152 */
	0,  /* 153 */
	0,  /* 154 */
	0,  /* 155 */
	0,  /* 156 */
	0,  /* 157 */
	0,  /* 158 */
	0,  /* 159 */
	0,  /* 160 */
	0,  /* 161 */
	0,  /* 162 */
	0,  /* 163 */
	0,  /* 164 */
	"CVSI",  /* 165 */
	"CVSU",  /* 166 */
	0,  /* 167 */
	0,  /* 168 */
	0,  /* 169 */
	0,  /* 170 */
	0,  /* 171 */
	0,  /* 172 */
	0,  /* 173 */
	0,  /* 174 */
	0,  /* 175 */
	0,  /* 176 */
	0,  /* 177 */
	0,  /* 178 */
	"CVUC",  /* 179 */
	"CVUS",  /* 180 */
	"CVUI",  /* 181 */
	0,  /* 182 */
	"CVUP",  /* 183 */
	0,  /* 184 */
	0,  /* 185 */
	0,  /* 186 */
	0,  /* 187 */
	0,  /* 188 */
	0,  /* 189 */
	0,  /* 190 */
	0,  /* 191 */
	0,  /* 192 */
	"NEGF",  /* 193 */
	"NEGD",  /* 194 */
	0,  /* 195 */
	0,  /* 196 */
	"NEGI",  /* 197 */
	0,  /* 198 */
	0,  /* 199 */
	0,  /* 200 */
	0,  /* 201 */
	0,  /* 202 */
	0,  /* 203 */
	0,  /* 204 */
	0,  /* 205 */
	0,  /* 206 */
	0,  /* 207 */
	0,  /* 208 */
	"CALLF",  /* 209 */
	"CALLD",  /* 210 */
	0,  /* 211 */
	0,  /* 212 */
	"CALLI",  /* 213 */
	0,  /* 214 */
	0,  /* 215 */
	"CALLV",  /* 216 */
	"CALLB",  /* 217 */
	0,  /* 218 */
	0,  /* 219 */
	0,  /* 220 */
	0,  /* 221 */
	0,  /* 222 */
	0,  /* 223 */
	0,  /* 224 */
	"LOADF",  /* 225 */
	"LOADD",  /* 226 */
	"LOADC",  /* 227 */
	"LOADS",  /* 228 */
	"LOADI",  /* 229 */
	"LOADU",  /* 230 */
	"LOADP",  /* 231 */
	0,  /* 232 */
	"LOADB",  /* 233 */
	0,  /* 234 */
	0,  /* 235 */
	0,  /* 236 */
	0,  /* 237 */
	0,  /* 238 */
	0,  /* 239 */
	0,  /* 240 */
	"RETF",  /* 241 */
	"RETD",  /* 242 */
	0,  /* 243 */
	0,  /* 244 */
	"RETI",  /* 245 */
	0,  /* 246 */
	0,  /* 247 */
	0,  /* 248 */
	0,  /* 249 */
	0,  /* 250 */
	0,  /* 251 */
	0,  /* 252 */
	0,  /* 253 */
	0,  /* 254 */
	0,  /* 255 */
	0,  /* 256 */
	0,  /* 257 */
	0,  /* 258 */
	0,  /* 259 */
	0,  /* 260 */
	0,  /* 261 */
	0,  /* 262 */
	"ADDRGP",  /* 263 */
	0,  /* 264 */
	0,  /* 265 */
	0,  /* 266 */
	0,  /* 267 */
	0,  /* 268 */
	0,  /* 269 */
	0,  /* 270 */
	0,  /* 271 */
	0,  /* 272 */
	0,  /* 273 */
	0,  /* 274 */
	0,  /* 275 */
	0,  /* 276 */
	0,  /* 277 */
	0,  /* 278 */
	"ADDRFP",  /* 279 */
	0,  /* 280 */
	0,  /* 281 */
	0,  /* 282 */
	0,  /* 283 */
	0,  /* 284 */
	0,  /* 285 */
	0,  /* 286 */
	0,  /* 287 */
	0,  /* 288 */
	0,  /* 289 */
	0,  /* 290 */
	0,  /* 291 */
	0,  /* 292 */
	0,  /* 293 */
	0,  /* 294 */
	"ADDRLP",  /* 295 */
	0,  /* 296 */
	0,  /* 297 */
	0,  /* 298 */
	0,  /* 299 */
	0,  /* 300 */
	0,  /* 301 */
	0,  /* 302 */
	0,  /* 303 */
	0,  /* 304 */
	"ADDF",  /* 305 */
	"ADDD",  /* 306 */
	0,  /* 307 */
	0,  /* 308 */
	"ADDI",  /* 309 */
	"ADDU",  /* 310 */
	"ADDP",  /* 311 */
	0,  /* 312 */
	0,  /* 313 */
	0,  /* 314 */
	0,  /* 315 */
	0,  /* 316 */
	0,  /* 317 */
	0,  /* 318 */
	0,  /* 319 */
	0,  /* 320 */
	"SUBF",  /* 321 */
	"SUBD",  /* 322 */
	0,  /* 323 */
	0,  /* 324 */
	"SUBI",  /* 325 */
	"SUBU",  /* 326 */
	"SUBP",  /* 327 */
	0,  /* 328 */
	0,  /* 329 */
	0,  /* 330 */
	0,  /* 331 */
	0,  /* 332 */
	0,  /* 333 */
	0,  /* 334 */
	0,  /* 335 */
	0,  /* 336 */
	0,  /* 337 */
	0,  /* 338 */
	0,  /* 339 */
	0,  /* 340 */
	"LSHI",  /* 341 */
	"LSHU",  /* 342 */
	0,  /* 343 */
	0,  /* 344 */
	0,  /* 345 */
	0,  /* 346 */
	0,  /* 347 */
	0,  /* 348 */
	0,  /* 349 */
	0,  /* 350 */
	0,  /* 351 */
	0,  /* 352 */
	0,  /* 353 */
	0,  /* 354 */
	0,  /* 355 */
	0,  /* 356 */
	"MODI",  /* 357 */
	"MODU",  /* 358 */
	0,  /* 359 */
	0,  /* 360 */
	0,  /* 361 */
	0,  /* 362 */
	0,  /* 363 */
	0,  /* 364 */
	0,  /* 365 */
	0,  /* 366 */
	0,  /* 367 */
	0,  /* 368 */
	0,  /* 369 */
	0,  /* 370 */
	0,  /* 371 */
	0,  /* 372 */
	"RSHI",  /* 373 */
	"RSHU",  /* 374 */
	0,  /* 375 */
	0,  /* 376 */
	0,  /* 377 */
	0,  /* 378 */
	0,  /* 379 */
	0,  /* 380 */
	0,  /* 381 */
	0,  /* 382 */
	0,  /* 383 */
	0,  /* 384 */
	0,  /* 385 */
	0,  /* 386 */
	0,  /* 387 */
	0,  /* 388 */
	0,  /* 389 */
	"BANDU",  /* 390 */
	0,  /* 391 */
	0,  /* 392 */
	0,  /* 393 */
	0,  /* 394 */
	0,  /* 395 */
	0,  /* 396 */
	0,  /* 397 */
	0,  /* 398 */
	0,  /* 399 */
	0,  /* 400 */
	0,  /* 401 */
	0,  /* 402 */
	0,  /* 403 */
	0,  /* 404 */
	0,  /* 405 */
	"BCOMU",  /* 406 */
	0,  /* 407 */
	0,  /* 408 */
	0,  /* 409 */
	0,  /* 410 */
	0,  /* 411 */
	0,  /* 412 */
	0,  /* 413 */
	0,  /* 414 */
	0,  /* 415 */
	0,  /* 416 */
	0,  /* 417 */
	0,  /* 418 */
	0,  /* 419 */
	0,  /* 420 */
	0,  /* 421 */
	"BORU",  /* 422 */
	0,  /* 423 */
	0,  /* 424 */
	0,  /* 425 */
	0,  /* 426 */
	0,  /* 427 */
	0,  /* 428 */
	0,  /* 429 */
	0,  /* 430 */
	0,  /* 431 */
	0,  /* 432 */
	0,  /* 433 */
	0,  /* 434 */
	0,  /* 435 */
	0,  /* 436 */
	0,  /* 437 */
	"BXORU",  /* 438 */
	0,  /* 439 */
	0,  /* 440 */
	0,  /* 441 */
	0,  /* 442 */
	0,  /* 443 */
	0,  /* 444 */
	0,  /* 445 */
	0,  /* 446 */
	0,  /* 447 */
	0,  /* 448 */
	"DIVF",  /* 449 */
	"DIVD",  /* 450 */
	0,  /* 451 */
	0,  /* 452 */
	"DIVI",  /* 453 */
	"DIVU",  /* 454 */
	0,  /* 455 */
	0,  /* 456 */
	0,  /* 457 */
	0,  /* 458 */
	0,  /* 459 */
	0,  /* 460 */
	0,  /* 461 */
	0,  /* 462 */
	0,  /* 463 */
	0,  /* 464 */
	"MULF",  /* 465 */
	"MULD",  /* 466 */
	0,  /* 467 */
	0,  /* 468 */
	"MULI",  /* 469 */
	"MULU",  /* 470 */
	0,  /* 471 */
	0,  /* 472 */
	0,  /* 473 */
	0,  /* 474 */
	0,  /* 475 */
	0,  /* 476 */
	0,  /* 477 */
	0,  /* 478 */
	0,  /* 479 */
	0,  /* 480 */
	"EQF",  /* 481 */
	"EQD",  /* 482 */
	0,  /* 483 */
	0,  /* 484 */
	"EQI",  /* 485 */
	0,  /* 486 */
	0,  /* 487 */
	0,  /* 488 */
	0,  /* 489 */
	0,  /* 490 */
	0,  /* 491 */
	0,  /* 492 */
	0,  /* 493 */
	0,  /* 494 */
	0,  /* 495 */
	0,  /* 496 */
	"GEF",  /* 497 */
	"GED",  /* 498 */
	0,  /* 499 */
	0,  /* 500 */
	"GEI",  /* 501 */
	"GEU",  /* 502 */
	0,  /* 503 */
	0,  /* 504 */
	0,  /* 505 */
	0,  /* 506 */
	0,  /* 507 */
	0,  /* 508 */
	0,  /* 509 */
	0,  /* 510 */
	0,  /* 511 */
	0,  /* 512 */
	"GTF",  /* 513 */
	"GTD",  /* 514 */
	0,  /* 515 */
	0,  /* 516 */
	"GTI",  /* 517 */
	"GTU",  /* 518 */
	0,  /* 519 */
	0,  /* 520 */
	0,  /* 521 */
	0,  /* 522 */
	0,  /* 523 */
	0,  /* 524 */
	0,  /* 525 */
	0,  /* 526 */
	0,  /* 527 */
	0,  /* 528 */
	"LEF",  /* 529 */
	"LED",  /* 530 */
	0,  /* 531 */
	0,  /* 532 */
	"LEI",  /* 533 */
	"LEU",  /* 534 */
	0,  /* 535 */
	0,  /* 536 */
	0,  /* 537 */
	0,  /* 538 */
	0,  /* 539 */
	0,  /* 540 */
	0,  /* 541 */
	0,  /* 542 */
	0,  /* 543 */
	0,  /* 544 */
	"LTF",  /* 545 */
	"LTD",  /* 546 */
	0,  /* 547 */
	0,  /* 548 */
	"LTI",  /* 549 */
	"LTU",  /* 550 */
	0,  /* 551 */
	0,  /* 552 */
	0,  /* 553 */
	0,  /* 554 */
	0,  /* 555 */
	0,  /* 556 */
	0,  /* 557 */
	0,  /* 558 */
	0,  /* 559 */
	0,  /* 560 */
	"NEF",  /* 561 */
	"NED",  /* 562 */
	0,  /* 563 */
	0,  /* 564 */
	"NEI",  /* 565 */
	0,  /* 566 */
	0,  /* 567 */
	0,  /* 568 */
	0,  /* 569 */
	0,  /* 570 */
	0,  /* 571 */
	0,  /* 572 */
	0,  /* 573 */
	0,  /* 574 */
	0,  /* 575 */
	0,  /* 576 */
	0,  /* 577 */
	0,  /* 578 */
	0,  /* 579 */
	0,  /* 580 */
	0,  /* 581 */
	0,  /* 582 */
	0,  /* 583 */
	"JUMPV",  /* 584 */
	0,  /* 585 */
	0,  /* 586 */
	0,  /* 587 */
	0,  /* 588 */
	0,  /* 589 */
	0,  /* 590 */
	0,  /* 591 */
	0,  /* 592 */
	0,  /* 593 */
	0,  /* 594 */
	0,  /* 595 */
	0,  /* 596 */
	0,  /* 597 */
	0,  /* 598 */
	0,  /* 599 */
	"LABELV",  /* 600 */
	0,  /* 601 */
	0,  /* 602 */
	0,  /* 603 */
	0,  /* 604 */
	0,  /* 605 */
	0,  /* 606 */
	0,  /* 607 */
	0,  /* 608 */
	0,  /* 609 */
	0,  /* 610 */
	0,  /* 611 */
	0,  /* 612 */
	0,  /* 613 */
	0,  /* 614 */
	"VREGP",  /* 615 */
};

static char *_string[] = {
	0,
	"reg: INDIRC(VREGP)",  /* 1 */
	"reg: INDIRD(VREGP)",  /* 2 */
	"reg: INDIRF(VREGP)",  /* 3 */
	"reg: INDIRI(VREGP)",  /* 4 */
	"reg: INDIRP(VREGP)",  /* 5 */
	"reg: INDIRS(VREGP)",  /* 6 */
	"stmt: ASGNC(VREGP,reg)",  /* 7 */
	"stmt: ASGND(VREGP,reg)",  /* 8 */
	"stmt: ASGNF(VREGP,reg)",  /* 9 */
	"stmt: ASGNI(VREGP,reg)",  /* 10 */
	"stmt: ASGNP(VREGP,reg)",  /* 11 */
	"stmt: ASGNS(VREGP,reg)",  /* 12 */
	"con: CNSTC",  /* 13 */
	"con: CNSTI",  /* 14 */
	"con: CNSTP",  /* 15 */
	"con: CNSTS",  /* 16 */
	"con: CNSTU",  /* 17 */
	"stmt: reg",  /* 18 */
	"reg: CVIU(reg)",  /* 19 */
	"reg: CVPU(reg)",  /* 20 */
	"reg: CVUI(reg)",  /* 21 */
	"reg: CVUP(reg)",  /* 22 */
	"reg: ADDRGP",  /* 23 */
	"stk13: ADDRFP",  /* 24 */
	"stk13: ADDRLP",  /* 25 */
	"reg: stk13",  /* 26 */
	"stk: ADDRFP",  /* 27 */
	"stk: ADDRLP",  /* 28 */
	"reg: ADDRFP",  /* 29 */
	"reg: ADDRLP",  /* 30 */
	"con13: CNSTC",  /* 31 */
	"con13: CNSTI",  /* 32 */
	"con13: CNSTP",  /* 33 */
	"con13: CNSTS",  /* 34 */
	"con13: CNSTU",  /* 35 */
	"base: ADDI(reg,con13)",  /* 36 */
	"base: ADDP(reg,con13)",  /* 37 */
	"base: ADDU(reg,con13)",  /* 38 */
	"base: reg",  /* 39 */
	"base: con13",  /* 40 */
	"base: stk13",  /* 41 */
	"addr: base",  /* 42 */
	"addr: ADDI(reg,reg)",  /* 43 */
	"addr: ADDP(reg,reg)",  /* 44 */
	"addr: ADDU(reg,reg)",  /* 45 */
	"addr: stk",  /* 46 */
	"reg: INDIRC(addr)",  /* 47 */
	"reg: INDIRS(addr)",  /* 48 */
	"reg: INDIRI(addr)",  /* 49 */
	"reg: INDIRP(addr)",  /* 50 */
	"reg: INDIRF(addr)",  /* 51 */
	"stmt: ASGNC(addr,reg)",  /* 52 */
	"stmt: ASGNS(addr,reg)",  /* 53 */
	"stmt: ASGNI(addr,reg)",  /* 54 */
	"stmt: ASGNP(addr,reg)",  /* 55 */
	"stmt: ASGNF(addr,reg)",  /* 56 */
	"addrl: ADDRLP",  /* 57 */
	"reg: INDIRD(addrl)",  /* 58 */
	"stmt: ASGND(addrl,reg)",  /* 59 */
	"reg: INDIRD(base)",  /* 60 */
	"stmt: ASGND(base,reg)",  /* 61 */
	"spill: ADDRLP",  /* 62 */
	"stmt: ASGNC(spill,reg)",  /* 63 */
	"stmt: ASGNS(spill,reg)",  /* 64 */
	"stmt: ASGNI(spill,reg)",  /* 65 */
	"stmt: ASGNP(spill,reg)",  /* 66 */
	"stmt: ASGNF(spill,reg)",  /* 67 */
	"stmt: ASGND(spill,reg)",  /* 68 */
	"reg: CVCI(INDIRC(addr))",  /* 69 */
	"reg: CVSI(INDIRS(addr))",  /* 70 */
	"reg: CVCU(INDIRC(addr))",  /* 71 */
	"reg: CVSU(INDIRS(addr))",  /* 72 */
	"reg: CVIC(reg)",  /* 73 */
	"reg: CVIS(reg)",  /* 74 */
	"reg: CVIU(reg)",  /* 75 */
	"reg: CVPU(reg)",  /* 76 */
	"reg: CVUC(reg)",  /* 77 */
	"reg: CVUI(reg)",  /* 78 */
	"reg: CVUP(reg)",  /* 79 */
	"reg: CVUS(reg)",  /* 80 */
	"reg: CVIC(reg)",  /* 81 */
	"reg: CVIS(reg)",  /* 82 */
	"reg: CVUC(reg)",  /* 83 */
	"reg: CVUS(reg)",  /* 84 */
	"reg: LOADC(reg)",  /* 85 */
	"reg: LOADI(reg)",  /* 86 */
	"reg: LOADP(reg)",  /* 87 */
	"reg: LOADS(reg)",  /* 88 */
	"reg: LOADU(reg)",  /* 89 */
	"reg: CNSTC",  /* 90 */
	"reg: CNSTI",  /* 91 */
	"reg: CNSTP",  /* 92 */
	"reg: CNSTS",  /* 93 */
	"reg: CNSTU",  /* 94 */
	"reg: con",  /* 95 */
	"rc: con13",  /* 96 */
	"rc: reg",  /* 97 */
	"reg: ADDI(reg,rc)",  /* 98 */
	"reg: ADDP(reg,rc)",  /* 99 */
	"reg: ADDU(reg,rc)",  /* 100 */
	"reg: BANDU(reg,rc)",  /* 101 */
	"reg: BORU(reg,rc)",  /* 102 */
	"reg: BXORU(reg,rc)",  /* 103 */
	"reg: SUBI(reg,rc)",  /* 104 */
	"reg: SUBP(reg,rc)",  /* 105 */
	"reg: SUBU(reg,rc)",  /* 106 */
	"rc5: CNSTI",  /* 107 */
	"rc5: reg",  /* 108 */
	"reg: LSHI(reg,rc5)",  /* 109 */
	"reg: LSHU(reg,rc5)",  /* 110 */
	"reg: RSHI(reg,rc5)",  /* 111 */
	"reg: RSHU(reg,rc5)",  /* 112 */
	"reg: BANDU(reg,BCOMU(rc))",  /* 113 */
	"reg: BORU(reg,BCOMU(rc))",  /* 114 */
	"reg: BXORU(reg,BCOMU(rc))",  /* 115 */
	"reg: NEGI(reg)",  /* 116 */
	"reg: BCOMU(reg)",  /* 117 */
	"reg: CVCI(reg)",  /* 118 */
	"reg: CVSI(reg)",  /* 119 */
	"reg: CVCU(reg)",  /* 120 */
	"reg: CVSU(reg)",  /* 121 */
	"addrg: ADDRGP",  /* 122 */
	"stmt: JUMPV(addrg)",  /* 123 */
	"stmt: JUMPV(addr)",  /* 124 */
	"stmt: LABELV",  /* 125 */
	"stmt: EQI(reg,rc)",  /* 126 */
	"stmt: GEI(reg,rc)",  /* 127 */
	"stmt: GEU(reg,rc)",  /* 128 */
	"stmt: GTI(reg,rc)",  /* 129 */
	"stmt: GTU(reg,rc)",  /* 130 */
	"stmt: LEI(reg,rc)",  /* 131 */
	"stmt: LEU(reg,rc)",  /* 132 */
	"stmt: LTI(reg,rc)",  /* 133 */
	"stmt: LTU(reg,rc)",  /* 134 */
	"stmt: NEI(reg,rc)",  /* 135 */
	"call: ADDRGP",  /* 136 */
	"call: addr",  /* 137 */
	"reg: CALLD(call)",  /* 138 */
	"reg: CALLF(call)",  /* 139 */
	"reg: CALLI(call)",  /* 140 */
	"stmt: CALLV(call)",  /* 141 */
	"stmt: CALLB(call,reg)",  /* 142 */
	"stmt: RETD(reg)",  /* 143 */
	"stmt: RETF(reg)",  /* 144 */
	"stmt: RETI(reg)",  /* 145 */
	"stmt: ARGI(reg)",  /* 146 */
	"stmt: ARGP(reg)",  /* 147 */
	"stmt: ARGD(reg)",  /* 148 */
	"stmt: ARGF(reg)",  /* 149 */
	"reg: DIVI(reg,reg)",  /* 150 */
	"reg: DIVU(reg,reg)",  /* 151 */
	"reg: MODI(reg,reg)",  /* 152 */
	"reg: MODU(reg,reg)",  /* 153 */
	"reg: MULI(reg,reg)",  /* 154 */
	"reg: MULU(reg,reg)",  /* 155 */
	"reg: ADDD(reg,reg)",  /* 156 */
	"reg: ADDF(reg,reg)",  /* 157 */
	"reg: DIVD(reg,reg)",  /* 158 */
	"reg: DIVF(reg,reg)",  /* 159 */
	"reg: MULD(reg,reg)",  /* 160 */
	"reg: MULF(reg,reg)",  /* 161 */
	"reg: SUBD(reg,reg)",  /* 162 */
	"reg: SUBF(reg,reg)",  /* 163 */
	"reg: NEGF(reg)",  /* 164 */
	"reg: LOADF(reg)",  /* 165 */
	"reg: CVDF(reg)",  /* 166 */
	"reg: CVFD(reg)",  /* 167 */
	"reg: CVDI(reg)",  /* 168 */
	"reg: CVID(reg)",  /* 169 */
	"stmt: EQD(reg,reg)",  /* 170 */
	"stmt: EQF(reg,reg)",  /* 171 */
	"stmt: GED(reg,reg)",  /* 172 */
	"stmt: GEF(reg,reg)",  /* 173 */
	"stmt: GTD(reg,reg)",  /* 174 */
	"stmt: GTF(reg,reg)",  /* 175 */
	"stmt: LED(reg,reg)",  /* 176 */
	"stmt: LEF(reg,reg)",  /* 177 */
	"stmt: LTD(reg,reg)",  /* 178 */
	"stmt: LTF(reg,reg)",  /* 179 */
	"stmt: NED(reg,reg)",  /* 180 */
	"stmt: NEF(reg,reg)",  /* 181 */
	"reg: LOADD(reg)",  /* 182 */
	"reg: NEGD(reg)",  /* 183 */
	"stmt: ASGNB(reg,INDIRB(reg))",  /* 184 */
};

static short _nts_1[] = { 0 };
static short _nts_7[] = { _reg_NT, 0 };
static short _nts_26[] = { _stk13_NT, 0 };
static short _nts_36[] = { _reg_NT, _con13_NT, 0 };
static short _nts_40[] = { _con13_NT, 0 };
static short _nts_42[] = { _base_NT, 0 };
static short _nts_43[] = { _reg_NT, _reg_NT, 0 };
static short _nts_46[] = { _stk_NT, 0 };
static short _nts_47[] = { _addr_NT, 0 };
static short _nts_52[] = { _addr_NT, _reg_NT, 0 };
static short _nts_58[] = { _addrl_NT, 0 };
static short _nts_59[] = { _addrl_NT, _reg_NT, 0 };
static short _nts_61[] = { _base_NT, _reg_NT, 0 };
static short _nts_63[] = { _spill_NT, _reg_NT, 0 };
static short _nts_95[] = { _con_NT, 0 };
static short _nts_98[] = { _reg_NT, _rc_NT, 0 };
static short _nts_109[] = { _reg_NT, _rc5_NT, 0 };
static short _nts_123[] = { _addrg_NT, 0 };
static short _nts_138[] = { _call_NT, 0 };
static short _nts_142[] = { _call_NT, _reg_NT, 0 };

static short *_nts[] = {
	0,
	_nts_1,	/* 1 */
	_nts_1,	/* 2 */
	_nts_1,	/* 3 */
	_nts_1,	/* 4 */
	_nts_1,	/* 5 */
	_nts_1,	/* 6 */
	_nts_7,	/* 7 */
	_nts_7,	/* 8 */
	_nts_7,	/* 9 */
	_nts_7,	/* 10 */
	_nts_7,	/* 11 */
	_nts_7,	/* 12 */
	_nts_1,	/* 13 */
	_nts_1,	/* 14 */
	_nts_1,	/* 15 */
	_nts_1,	/* 16 */
	_nts_1,	/* 17 */
	_nts_7,	/* 18 */
	_nts_7,	/* 19 */
	_nts_7,	/* 20 */
	_nts_7,	/* 21 */
	_nts_7,	/* 22 */
	_nts_1,	/* 23 */
	_nts_1,	/* 24 */
	_nts_1,	/* 25 */
	_nts_26,	/* 26 */
	_nts_1,	/* 27 */
	_nts_1,	/* 28 */
	_nts_1,	/* 29 */
	_nts_1,	/* 30 */
	_nts_1,	/* 31 */
	_nts_1,	/* 32 */
	_nts_1,	/* 33 */
	_nts_1,	/* 34 */
	_nts_1,	/* 35 */
	_nts_36,	/* 36 */
	_nts_36,	/* 37 */
	_nts_36,	/* 38 */
	_nts_7,	/* 39 */
	_nts_40,	/* 40 */
	_nts_26,	/* 41 */
	_nts_42,	/* 42 */
	_nts_43,	/* 43 */
	_nts_43,	/* 44 */
	_nts_43,	/* 45 */
	_nts_46,	/* 46 */
	_nts_47,	/* 47 */
	_nts_47,	/* 48 */
	_nts_47,	/* 49 */
	_nts_47,	/* 50 */
	_nts_47,	/* 51 */
	_nts_52,	/* 52 */
	_nts_52,	/* 53 */
	_nts_52,	/* 54 */
	_nts_52,	/* 55 */
	_nts_52,	/* 56 */
	_nts_1,	/* 57 */
	_nts_58,	/* 58 */
	_nts_59,	/* 59 */
	_nts_42,	/* 60 */
	_nts_61,	/* 61 */
	_nts_1,	/* 62 */
	_nts_63,	/* 63 */
	_nts_63,	/* 64 */
	_nts_63,	/* 65 */
	_nts_63,	/* 66 */
	_nts_63,	/* 67 */
	_nts_63,	/* 68 */
	_nts_47,	/* 69 */
	_nts_47,	/* 70 */
	_nts_47,	/* 71 */
	_nts_47,	/* 72 */
	_nts_7,	/* 73 */
	_nts_7,	/* 74 */
	_nts_7,	/* 75 */
	_nts_7,	/* 76 */
	_nts_7,	/* 77 */
	_nts_7,	/* 78 */
	_nts_7,	/* 79 */
	_nts_7,	/* 80 */
	_nts_7,	/* 81 */
	_nts_7,	/* 82 */
	_nts_7,	/* 83 */
	_nts_7,	/* 84 */
	_nts_7,	/* 85 */
	_nts_7,	/* 86 */
	_nts_7,	/* 87 */
	_nts_7,	/* 88 */
	_nts_7,	/* 89 */
	_nts_1,	/* 90 */
	_nts_1,	/* 91 */
	_nts_1,	/* 92 */
	_nts_1,	/* 93 */
	_nts_1,	/* 94 */
	_nts_95,	/* 95 */
	_nts_40,	/* 96 */
	_nts_7,	/* 97 */
	_nts_98,	/* 98 */
	_nts_98,	/* 99 */
	_nts_98,	/* 100 */
	_nts_98,	/* 101 */
	_nts_98,	/* 102 */
	_nts_98,	/* 103 */
	_nts_98,	/* 104 */
	_nts_98,	/* 105 */
	_nts_98,	/* 106 */
	_nts_1,	/* 107 */
	_nts_7,	/* 108 */
	_nts_109,	/* 109 */
	_nts_109,	/* 110 */
	_nts_109,	/* 111 */
	_nts_109,	/* 112 */
	_nts_98,	/* 113 */
	_nts_98,	/* 114 */
	_nts_98,	/* 115 */
	_nts_7,	/* 116 */
	_nts_7,	/* 117 */
	_nts_7,	/* 118 */
	_nts_7,	/* 119 */
	_nts_7,	/* 120 */
	_nts_7,	/* 121 */
	_nts_1,	/* 122 */
	_nts_123,	/* 123 */
	_nts_47,	/* 124 */
	_nts_1,	/* 125 */
	_nts_98,	/* 126 */
	_nts_98,	/* 127 */
	_nts_98,	/* 128 */
	_nts_98,	/* 129 */
	_nts_98,	/* 130 */
	_nts_98,	/* 131 */
	_nts_98,	/* 132 */
	_nts_98,	/* 133 */
	_nts_98,	/* 134 */
	_nts_98,	/* 135 */
	_nts_1,	/* 136 */
	_nts_47,	/* 137 */
	_nts_138,	/* 138 */
	_nts_138,	/* 139 */
	_nts_138,	/* 140 */
	_nts_138,	/* 141 */
	_nts_142,	/* 142 */
	_nts_7,	/* 143 */
	_nts_7,	/* 144 */
	_nts_7,	/* 145 */
	_nts_7,	/* 146 */
	_nts_7,	/* 147 */
	_nts_7,	/* 148 */
	_nts_7,	/* 149 */
	_nts_43,	/* 150 */
	_nts_43,	/* 151 */
	_nts_43,	/* 152 */
	_nts_43,	/* 153 */
	_nts_43,	/* 154 */
	_nts_43,	/* 155 */
	_nts_43,	/* 156 */
	_nts_43,	/* 157 */
	_nts_43,	/* 158 */
	_nts_43,	/* 159 */
	_nts_43,	/* 160 */
	_nts_43,	/* 161 */
	_nts_43,	/* 162 */
	_nts_43,	/* 163 */
	_nts_7,	/* 164 */
	_nts_7,	/* 165 */
	_nts_7,	/* 166 */
	_nts_7,	/* 167 */
	_nts_7,	/* 168 */
	_nts_7,	/* 169 */
	_nts_43,	/* 170 */
	_nts_43,	/* 171 */
	_nts_43,	/* 172 */
	_nts_43,	/* 173 */
	_nts_43,	/* 174 */
	_nts_43,	/* 175 */
	_nts_43,	/* 176 */
	_nts_43,	/* 177 */
	_nts_43,	/* 178 */
	_nts_43,	/* 179 */
	_nts_43,	/* 180 */
	_nts_43,	/* 181 */
	_nts_7,	/* 182 */
	_nts_7,	/* 183 */
	_nts_43,	/* 184 */
};

struct _state {
	short cost[15];
	struct {
		unsigned int _stmt:6;
		unsigned int _addr:3;
		unsigned int _addrg:1;
		unsigned int _addrl:1;
		unsigned int _base:3;
		unsigned int _call:2;
		unsigned int _con:3;
		unsigned int _con13:3;
		unsigned int _rc:2;
		unsigned int _rc5:2;
		unsigned int _reg:7;
		unsigned int _spill:1;
		unsigned int _stk:2;
		unsigned int _stk13:2;
	} rule;
};

static short _decode_addrl[] = {
	0,
	57,
};

static short _decode_rc5[] = {
	0,
	107,
	108,
};

static short _decode_con13[] = {
	0,
	31,
	32,
	33,
	34,
	35,
};

static short _decode_spill[] = {
	0,
	62,
};

static short _decode_rc[] = {
	0,
	96,
	97,
};

static short _decode_call[] = {
	0,
	136,
	137,
};

static short _decode_stmt[] = {
	0,
	7,
	8,
	9,
	10,
	11,
	12,
	18,
	52,
	53,
	54,
	55,
	56,
	59,
	61,
	63,
	64,
	65,
	66,
	67,
	68,
	123,
	124,
	125,
	126,
	127,
	128,
	129,
	130,
	131,
	132,
	133,
	134,
	135,
	141,
	142,
	143,
	144,
	145,
	146,
	147,
	148,
	149,
	170,
	171,
	172,
	173,
	174,
	175,
	176,
	177,
	178,
	179,
	180,
	181,
	184,
};

static short _decode_reg[] = {
	0,
	1,
	2,
	3,
	4,
	5,
	6,
	19,
	20,
	21,
	22,
	23,
	26,
	29,
	30,
	47,
	48,
	49,
	50,
	51,
	58,
	60,
	69,
	70,
	71,
	72,
	73,
	74,
	75,
	76,
	77,
	78,
	79,
	80,
	81,
	82,
	83,
	84,
	85,
	86,
	87,
	88,
	89,
	90,
	91,
	92,
	93,
	94,
	95,
	98,
	99,
	100,
	101,
	102,
	103,
	104,
	105,
	106,
	109,
	110,
	111,
	112,
	113,
	114,
	115,
	116,
	117,
	118,
	119,
	120,
	121,
	138,
	139,
	140,
	150,
	151,
	152,
	153,
	154,
	155,
	156,
	157,
	158,
	159,
	160,
	161,
	162,
	163,
	164,
	165,
	166,
	167,
	168,
	169,
	182,
	183,
};

static short _decode_stk[] = {
	0,
	27,
	28,
};

static short _decode_con[] = {
	0,
	13,
	14,
	15,
	16,
	17,
};

static short _decode_addr[] = {
	0,
	42,
	43,
	44,
	45,
	46,
};

static short _decode_base[] = {
	0,
	36,
	37,
	38,
	39,
	40,
	41,
};

static short _decode_addrg[] = {
	0,
	122,
};

static short _decode_stk13[] = {
	0,
	24,
	25,
};

#define _addrl_rule(a)	_decode_addrl[((struct _state *)a)->rule._addrl]
#define _rc5_rule(a)	_decode_rc5[((struct _state *)a)->rule._rc5]
#define _con13_rule(a)	_decode_con13[((struct _state *)a)->rule._con13]
#define _spill_rule(a)	_decode_spill[((struct _state *)a)->rule._spill]
#define _rc_rule(a)	_decode_rc[((struct _state *)a)->rule._rc]
#define _call_rule(a)	_decode_call[((struct _state *)a)->rule._call]
#define _stmt_rule(a)	_decode_stmt[((struct _state *)a)->rule._stmt]
#define _reg_rule(a)	_decode_reg[((struct _state *)a)->rule._reg]
#define _stk_rule(a)	_decode_stk[((struct _state *)a)->rule._stk]
#define _con_rule(a)	_decode_con[((struct _state *)a)->rule._con]
#define _addr_rule(a)	_decode_addr[((struct _state *)a)->rule._addr]
#define _base_rule(a)	_decode_base[((struct _state *)a)->rule._base]
#define _addrg_rule(a)	_decode_addrg[((struct _state *)a)->rule._addrg]
#define _stk13_rule(a)	_decode_stk13[((struct _state *)a)->rule._stk13]
static int _rule(state, goalnt) void *state; {
	if (goalnt < 1 || goalnt > 14)
		fatal("_rule", "Bad goal nonterminal %d\n", goalnt);
	if (!state)
		return 0;
	switch (goalnt) {
	case _addrl_NT:	return _addrl_rule(state);
	case _rc5_NT:	return _rc5_rule(state);
	case _con13_NT:	return _con13_rule(state);
	case _spill_NT:	return _spill_rule(state);
	case _rc_NT:	return _rc_rule(state);
	case _call_NT:	return _call_rule(state);
	case _stmt_NT:	return _stmt_rule(state);
	case _reg_NT:	return _reg_rule(state);
	case _stk_NT:	return _stk_rule(state);
	case _con_NT:	return _con_rule(state);
	case _addr_NT:	return _addr_rule(state);
	case _base_NT:	return _base_rule(state);
	case _addrg_NT:	return _addrg_rule(state);
	case _stk13_NT:	return _stk13_rule(state);
	default:
		fatal("_rule", "Bad goalnt %d\n", goalnt);
		return 0;
	}
}

static void _closure_con13 ARGS((NODEPTR_TYPE, int));
static void _closure_reg ARGS((NODEPTR_TYPE, int));
static void _closure_stk ARGS((NODEPTR_TYPE, int));
static void _closure_con ARGS((NODEPTR_TYPE, int));
static void _closure_addr ARGS((NODEPTR_TYPE, int));
static void _closure_base ARGS((NODEPTR_TYPE, int));
static void _closure_stk13 ARGS((NODEPTR_TYPE, int));
static void _closure_con13(a, c) NODEPTR_TYPE a; {
	struct _state *p = STATE_LABEL(a);
	if (c + 0 < p->cost[_rc_NT]) {  /* rc : con13 */
		p->cost[_rc_NT] = c + 0;
		p->rule._rc = 1;
	}
	if (c + 0 < p->cost[_base_NT]) {  /* base : con13 */
		p->cost[_base_NT] = c + 0;
		p->rule._base = 5;
		_closure_base(a, c + 0);
	}
}

static void _closure_reg(a, c) NODEPTR_TYPE a; {
	struct _state *p = STATE_LABEL(a);
	if (c + 0 < p->cost[_rc5_NT]) {  /* rc5 : reg */
		p->cost[_rc5_NT] = c + 0;
		p->rule._rc5 = 2;
	}
	if (c + 0 < p->cost[_rc_NT]) {  /* rc : reg */
		p->cost[_rc_NT] = c + 0;
		p->rule._rc = 2;
	}
	if (c + 0 < p->cost[_stmt_NT]) {  /* stmt : reg */
		p->cost[_stmt_NT] = c + 0;
		p->rule._stmt = 7;
	}
	if (c + 0 < p->cost[_base_NT]) {  /* base : reg */
		p->cost[_base_NT] = c + 0;
		p->rule._base = 4;
		_closure_base(a, c + 0);
	}
}

static void _closure_stk(a, c) NODEPTR_TYPE a; {
	struct _state *p = STATE_LABEL(a);
	if (c + 0 < p->cost[_addr_NT]) {  /* addr : stk */
		p->cost[_addr_NT] = c + 0;
		p->rule._addr = 5;
		_closure_addr(a, c + 0);
	}
}

static void _closure_con(a, c) NODEPTR_TYPE a; {
	struct _state *p = STATE_LABEL(a);
	if (c + 1 < p->cost[_reg_NT]) {  /* reg : con */
		p->cost[_reg_NT] = c + 1;
		p->rule._reg = 48;
		_closure_reg(a, c + 1);
	}
}

static void _closure_addr(a, c) NODEPTR_TYPE a; {
	struct _state *p = STATE_LABEL(a);
	if (c + 0 < p->cost[_call_NT]) {  /* call : addr */
		p->cost[_call_NT] = c + 0;
		p->rule._call = 2;
	}
}

static void _closure_base(a, c) NODEPTR_TYPE a; {
	struct _state *p = STATE_LABEL(a);
	if (c + 0 < p->cost[_addr_NT]) {  /* addr : base */
		p->cost[_addr_NT] = c + 0;
		p->rule._addr = 1;
		_closure_addr(a, c + 0);
	}
}

static void _closure_stk13(a, c) NODEPTR_TYPE a; {
	struct _state *p = STATE_LABEL(a);
	if (c + 1 < p->cost[_reg_NT]) {  /* reg : stk13 */
		p->cost[_reg_NT] = c + 1;
		p->rule._reg = 12;
		_closure_reg(a, c + 1);
	}
	if (c + 0 < p->cost[_base_NT]) {  /* base : stk13 */
		p->cost[_base_NT] = c + 0;
		p->rule._base = 6;
		_closure_base(a, c + 0);
	}
}

static void _label(a) NODEPTR_TYPE a; {
	int c;
	struct _state *p;

	if (!a)
		fatal("_label", "Null tree\n", 0);
	STATE_LABEL(a) = p = allocate(sizeof (*p), FUNC);
	p->rule._stmt = 0;
	p->cost[1] = 
	p->cost[2] = 
	p->cost[3] = 
	p->cost[4] = 
	p->cost[5] = 
	p->cost[6] = 
	p->cost[7] = 
	p->cost[8] = 
	p->cost[9] = 
	p->cost[10] = 
	p->cost[11] = 
	p->cost[12] = 
	p->cost[13] = 
	p->cost[14] = 
		0x7fff;
	switch (OP_LABEL(a)) {
	case 306:  /* ADDD */
		_label(LEFT_CHILD(a));
		_label(RIGHT_CHILD(a));
		c = ((struct _state*)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + ((struct _state*)(RIGHT_CHILD(a)->x.state))->cost[_reg_NT] + 1;
		if (c + 0 < p->cost[_reg_NT]) {  /* reg : ADDD(reg,reg) */
			p->cost[_reg_NT] = c + 0;
			p->rule._reg = 80;
			_closure_reg(a, c + 0);
		}
		break;
	case 305:  /* ADDF */
		_label(LEFT_CHILD(a));
		_label(RIGHT_CHILD(a));
		c = ((struct _state*)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + ((struct _state*)(RIGHT_CHILD(a)->x.state))->cost[_reg_NT] + 1;
		if (c + 0 < p->cost[_reg_NT]) {  /* reg : ADDF(reg,reg) */
			p->cost[_reg_NT] = c + 0;
			p->rule._reg = 81;
			_closure_reg(a, c + 0);
		}
		break;
	case 309:  /* ADDI */
		_label(LEFT_CHILD(a));
		_label(RIGHT_CHILD(a));
		c = ((struct _state*)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + ((struct _state*)(RIGHT_CHILD(a)->x.state))->cost[_con13_NT] + 0;
		if (c + 0 < p->cost[_base_NT]) {  /* base : ADDI(reg,con13) */
			p->cost[_base_NT] = c + 0;
			p->rule._base = 1;
			_closure_base(a, c + 0);
		}
		c = ((struct _state*)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + ((struct _state*)(RIGHT_CHILD(a)->x.state))->cost[_reg_NT] + 0;
		if (c + 0 < p->cost[_addr_NT]) {  /* addr : ADDI(reg,reg) */
			p->cost[_addr_NT] = c + 0;
			p->rule._addr = 2;
			_closure_addr(a, c + 0);
		}
		c = ((struct _state*)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + ((struct _state*)(RIGHT_CHILD(a)->x.state))->cost[_rc_NT] + 1;
		if (c + 0 < p->cost[_reg_NT]) {  /* reg : ADDI(reg,rc) */
			p->cost[_reg_NT] = c + 0;
			p->rule._reg = 49;
			_closure_reg(a, c + 0);
		}
		break;
	case 311:  /* ADDP */
		_label(LEFT_CHILD(a));
		_label(RIGHT_CHILD(a));
		c = ((struct _state*)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + ((struct _state*)(RIGHT_CHILD(a)->x.state))->cost[_con13_NT] + 0;
		if (c + 0 < p->cost[_base_NT]) {  /* base : ADDP(reg,con13) */
			p->cost[_base_NT] = c + 0;
			p->rule._base = 2;
			_closure_base(a, c + 0);
		}
		c = ((struct _state*)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + ((struct _state*)(RIGHT_CHILD(a)->x.state))->cost[_reg_NT] + 0;
		if (c + 0 < p->cost[_addr_NT]) {  /* addr : ADDP(reg,reg) */
			p->cost[_addr_NT] = c + 0;
			p->rule._addr = 3;
			_closure_addr(a, c + 0);
		}
		c = ((struct _state*)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + ((struct _state*)(RIGHT_CHILD(a)->x.state))->cost[_rc_NT] + 1;
		if (c + 0 < p->cost[_reg_NT]) {  /* reg : ADDP(reg,rc) */
			p->cost[_reg_NT] = c + 0;
			p->rule._reg = 50;
			_closure_reg(a, c + 0);
		}
		break;
	case 279:  /* ADDRFP */
		c = imm(a);
		if (c + 0 < p->cost[_stk13_NT]) {  /* stk13 : ADDRFP */
			p->cost[_stk13_NT] = c + 0;
			p->rule._stk13 = 1;
			_closure_stk13(a, c + 0);
		}
		c = 2;
		if (c + 0 < p->cost[_stk_NT]) {  /* stk : ADDRFP */
			p->cost[_stk_NT] = c + 0;
			p->rule._stk = 1;
			_closure_stk(a, c + 0);
		}
		c = 3;
		if (c + 0 < p->cost[_reg_NT]) {  /* reg : ADDRFP */
			p->cost[_reg_NT] = c + 0;
			p->rule._reg = 13;
			_closure_reg(a, c + 0);
		}
		break;
	case 263:  /* ADDRGP */
		c = 1;
		if (c + 0 < p->cost[_reg_NT]) {  /* reg : ADDRGP */
			p->cost[_reg_NT] = c + 0;
			p->rule._reg = 11;
			_closure_reg(a, c + 0);
		}
		c = 0;
		if (c + 0 < p->cost[_addrg_NT]) {  /* addrg : ADDRGP */
			p->cost[_addrg_NT] = c + 0;
			p->rule._addrg = 1;
		}
		c = 0;
		if (c + 0 < p->cost[_call_NT]) {  /* call : ADDRGP */
			p->cost[_call_NT] = c + 0;
			p->rule._call = 1;
		}
		break;
	case 295:  /* ADDRLP */
		c = imm(a);
		if (c + 0 < p->cost[_stk13_NT]) {  /* stk13 : ADDRLP */
			p->cost[_stk13_NT] = c + 0;
			p->rule._stk13 = 2;
			_closure_stk13(a, c + 0);
		}
		c = 2;
		if (c + 0 < p->cost[_stk_NT]) {  /* stk : ADDRLP */
			p->cost[_stk_NT] = c + 0;
			p->rule._stk = 2;
			_closure_stk(a, c + 0);
		}
		c = 3;
		if (c + 0 < p->cost[_reg_NT]) {  /* reg : ADDRLP */
			p->cost[_reg_NT] = c + 0;
			p->rule._reg = 14;
			_closure_reg(a, c + 0);
		}
		c = imm(a);
		if (c + 0 < p->cost[_addrl_NT]) {  /* addrl : ADDRLP */
			p->cost[_addrl_NT] = c + 0;
			p->rule._addrl = 1;
		}
		c = !imm(a);
		if (c + 0 < p->cost[_spill_NT]) {  /* spill : ADDRLP */
			p->cost[_spill_NT] = c + 0;
			p->rule._spill = 1;
		}
		break;
	case 310:  /* ADDU */
		_label(LEFT_CHILD(a));
		_label(RIGHT_CHILD(a));
		c = ((struct _state*)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + ((struct _state*)(RIGHT_CHILD(a)->x.state))->cost[_con13_NT] + 0;
		if (c + 0 < p->cost[_base_NT]) {  /* base : ADDU(reg,con13) */
			p->cost[_base_NT] = c + 0;
			p->rule._base = 3;
			_closure_base(a, c + 0);
		}
		c = ((struct _state*)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + ((struct _state*)(RIGHT_CHILD(a)->x.state))->cost[_reg_NT] + 0;
		if (c + 0 < p->cost[_addr_NT]) {  /* addr : ADDU(reg,reg) */
			p->cost[_addr_NT] = c + 0;
			p->rule._addr = 4;
			_closure_addr(a, c + 0);
		}
		c = ((struct _state*)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + ((struct _state*)(RIGHT_CHILD(a)->x.state))->cost[_rc_NT] + 1;
		if (c + 0 < p->cost[_reg_NT]) {  /* reg : ADDU(reg,rc) */
			p->cost[_reg_NT] = c + 0;
			p->rule._reg = 51;
			_closure_reg(a, c + 0);
		}
		break;
	case 41:  /* ARGB */
		break;
	case 34:  /* ARGD */
		_label(LEFT_CHILD(a));
		c = ((struct _state*)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + 1;
		if (c + 0 < p->cost[_stmt_NT]) {  /* stmt : ARGD(reg) */
			p->cost[_stmt_NT] = c + 0;
			p->rule._stmt = 41;
		}
		break;
	case 33:  /* ARGF */
		_label(LEFT_CHILD(a));
		c = ((struct _state*)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + 1;
		if (c + 0 < p->cost[_stmt_NT]) {  /* stmt : ARGF(reg) */
			p->cost[_stmt_NT] = c + 0;
			p->rule._stmt = 42;
		}
		break;
	case 37:  /* ARGI */
		_label(LEFT_CHILD(a));
		c = ((struct _state*)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + 1;
		if (c + 0 < p->cost[_stmt_NT]) {  /* stmt : ARGI(reg) */
			p->cost[_stmt_NT] = c + 0;
			p->rule._stmt = 39;
		}
		break;
	case 39:  /* ARGP */
		_label(LEFT_CHILD(a));
		c = ((struct _state*)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + 1;
		if (c + 0 < p->cost[_stmt_NT]) {  /* stmt : ARGP(reg) */
			p->cost[_stmt_NT] = c + 0;
			p->rule._stmt = 40;
		}
		break;
	case 57:  /* ASGNB */
		_label(LEFT_CHILD(a));
		_label(RIGHT_CHILD(a));
		if (
			RIGHT_CHILD(a)->op == 73 /* INDIRB */
		) {
			c = ((struct _state*)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + ((struct _state*)(LEFT_CHILD(RIGHT_CHILD(a))->x.state))->cost[_reg_NT] + 0;
			if (c + 0 < p->cost[_stmt_NT]) {  /* stmt : ASGNB(reg,INDIRB(reg)) */
				p->cost[_stmt_NT] = c + 0;
				p->rule._stmt = 55;
			}
		}
		break;
	case 51:  /* ASGNC */
		_label(LEFT_CHILD(a));
		_label(RIGHT_CHILD(a));
		if (
			LEFT_CHILD(a)->op == 615 /* VREGP */
		) {
			c = ((struct _state*)(RIGHT_CHILD(a)->x.state))->cost[_reg_NT] + 0;
			if (c + 0 < p->cost[_stmt_NT]) {  /* stmt : ASGNC(VREGP,reg) */
				p->cost[_stmt_NT] = c + 0;
				p->rule._stmt = 1;
			}
		}
		c = ((struct _state*)(LEFT_CHILD(a)->x.state))->cost[_addr_NT] + ((struct _state*)(RIGHT_CHILD(a)->x.state))->cost[_reg_NT] + 1;
		if (c + 0 < p->cost[_stmt_NT]) {  /* stmt : ASGNC(addr,reg) */
			p->cost[_stmt_NT] = c + 0;
			p->rule._stmt = 8;
		}
		c = ((struct _state*)(LEFT_CHILD(a)->x.state))->cost[_spill_NT] + ((struct _state*)(RIGHT_CHILD(a)->x.state))->cost[_reg_NT] + 0;
		if (c + 0 < p->cost[_stmt_NT]) {  /* stmt : ASGNC(spill,reg) */
			p->cost[_stmt_NT] = c + 0;
			p->rule._stmt = 15;
		}
		break;
	case 50:  /* ASGND */
		_label(LEFT_CHILD(a));
		_label(RIGHT_CHILD(a));
		if (
			LEFT_CHILD(a)->op == 615 /* VREGP */
		) {
			c = ((struct _state*)(RIGHT_CHILD(a)->x.state))->cost[_reg_NT] + 0;
			if (c + 0 < p->cost[_stmt_NT]) {  /* stmt : ASGND(VREGP,reg) */
				p->cost[_stmt_NT] = c + 0;
				p->rule._stmt = 2;
			}
		}
		c = ((struct _state*)(LEFT_CHILD(a)->x.state))->cost[_addrl_NT] + ((struct _state*)(RIGHT_CHILD(a)->x.state))->cost[_reg_NT] + 1;
		if (c + 0 < p->cost[_stmt_NT]) {  /* stmt : ASGND(addrl,reg) */
			p->cost[_stmt_NT] = c + 0;
			p->rule._stmt = 13;
		}
		c = ((struct _state*)(LEFT_CHILD(a)->x.state))->cost[_base_NT] + ((struct _state*)(RIGHT_CHILD(a)->x.state))->cost[_reg_NT] + 2;
		if (c + 0 < p->cost[_stmt_NT]) {  /* stmt : ASGND(base,reg) */
			p->cost[_stmt_NT] = c + 0;
			p->rule._stmt = 14;
		}
		c = ((struct _state*)(LEFT_CHILD(a)->x.state))->cost[_spill_NT] + ((struct _state*)(RIGHT_CHILD(a)->x.state))->cost[_reg_NT] + 0;
		if (c + 0 < p->cost[_stmt_NT]) {  /* stmt : ASGND(spill,reg) */
			p->cost[_stmt_NT] = c + 0;
			p->rule._stmt = 20;
		}
		break;
	case 49:  /* ASGNF */
		_label(LEFT_CHILD(a));
		_label(RIGHT_CHILD(a));
		if (
			LEFT_CHILD(a)->op == 615 /* VREGP */
		) {
			c = ((struct _state*)(RIGHT_CHILD(a)->x.state))->cost[_reg_NT] + 0;
			if (c + 0 < p->cost[_stmt_NT]) {  /* stmt : ASGNF(VREGP,reg) */
				p->cost[_stmt_NT] = c + 0;
				p->rule._stmt = 3;
			}
		}
		c = ((struct _state*)(LEFT_CHILD(a)->x.state))->cost[_addr_NT] + ((struct _state*)(RIGHT_CHILD(a)->x.state))->cost[_reg_NT] + 1;
		if (c + 0 < p->cost[_stmt_NT]) {  /* stmt : ASGNF(addr,reg) */
			p->cost[_stmt_NT] = c + 0;
			p->rule._stmt = 12;
		}
		c = ((struct _state*)(LEFT_CHILD(a)->x.state))->cost[_spill_NT] + ((struct _state*)(RIGHT_CHILD(a)->x.state))->cost[_reg_NT] + 0;
		if (c + 0 < p->cost[_stmt_NT]) {  /* stmt : ASGNF(spill,reg) */
			p->cost[_stmt_NT] = c + 0;
			p->rule._stmt = 19;
		}
		break;
	case 53:  /* ASGNI */
		_label(LEFT_CHILD(a));
		_label(RIGHT_CHILD(a));
		if (
			LEFT_CHILD(a)->op == 615 /* VREGP */
		) {
			c = ((struct _state*)(RIGHT_CHILD(a)->x.state))->cost[_reg_NT] + 0;
			if (c + 0 < p->cost[_stmt_NT]) {  /* stmt : ASGNI(VREGP,reg) */
				p->cost[_stmt_NT] = c + 0;
				p->rule._stmt = 4;
			}
		}
		c = ((struct _state*)(LEFT_CHILD(a)->x.state))->cost[_addr_NT] + ((struct _state*)(RIGHT_CHILD(a)->x.state))->cost[_reg_NT] + 1;
		if (c + 0 < p->cost[_stmt_NT]) {  /* stmt : ASGNI(addr,reg) */
			p->cost[_stmt_NT] = c + 0;
			p->rule._stmt = 10;
		}
		c = ((struct _state*)(LEFT_CHILD(a)->x.state))->cost[_spill_NT] + ((struct _state*)(RIGHT_CHILD(a)->x.state))->cost[_reg_NT] + 0;
		if (c + 0 < p->cost[_stmt_NT]) {  /* stmt : ASGNI(spill,reg) */
			p->cost[_stmt_NT] = c + 0;
			p->rule._stmt = 17;
		}
		break;
	case 55:  /* ASGNP */
		_label(LEFT_CHILD(a));
		_label(RIGHT_CHILD(a));
		if (
			LEFT_CHILD(a)->op == 615 /* VREGP */
		) {
			c = ((struct _state*)(RIGHT_CHILD(a)->x.state))->cost[_reg_NT] + 0;
			if (c + 0 < p->cost[_stmt_NT]) {  /* stmt : ASGNP(VREGP,reg) */
				p->cost[_stmt_NT] = c + 0;
				p->rule._stmt = 5;
			}
		}
		c = ((struct _state*)(LEFT_CHILD(a)->x.state))->cost[_addr_NT] + ((struct _state*)(RIGHT_CHILD(a)->x.state))->cost[_reg_NT] + 1;
		if (c + 0 < p->cost[_stmt_NT]) {  /* stmt : ASGNP(addr,reg) */
			p->cost[_stmt_NT] = c + 0;
			p->rule._stmt = 11;
		}
		c = ((struct _state*)(LEFT_CHILD(a)->x.state))->cost[_spill_NT] + ((struct _state*)(RIGHT_CHILD(a)->x.state))->cost[_reg_NT] + 0;
		if (c + 0 < p->cost[_stmt_NT]) {  /* stmt : ASGNP(spill,reg) */
			p->cost[_stmt_NT] = c + 0;
			p->rule._stmt = 18;
		}
		break;
	case 52:  /* ASGNS */
		_label(LEFT_CHILD(a));
		_label(RIGHT_CHILD(a));
		if (
			LEFT_CHILD(a)->op == 615 /* VREGP */
		) {
			c = ((struct _state*)(RIGHT_CHILD(a)->x.state))->cost[_reg_NT] + 0;
			if (c + 0 < p->cost[_stmt_NT]) {  /* stmt : ASGNS(VREGP,reg) */
				p->cost[_stmt_NT] = c + 0;
				p->rule._stmt = 6;
			}
		}
		c = ((struct _state*)(LEFT_CHILD(a)->x.state))->cost[_addr_NT] + ((struct _state*)(RIGHT_CHILD(a)->x.state))->cost[_reg_NT] + 1;
		if (c + 0 < p->cost[_stmt_NT]) {  /* stmt : ASGNS(addr,reg) */
			p->cost[_stmt_NT] = c + 0;
			p->rule._stmt = 9;
		}
		c = ((struct _state*)(LEFT_CHILD(a)->x.state))->cost[_spill_NT] + ((struct _state*)(RIGHT_CHILD(a)->x.state))->cost[_reg_NT] + 0;
		if (c + 0 < p->cost[_stmt_NT]) {  /* stmt : ASGNS(spill,reg) */
			p->cost[_stmt_NT] = c + 0;
			p->rule._stmt = 16;
		}
		break;
	case 390:  /* BANDU */
		_label(LEFT_CHILD(a));
		_label(RIGHT_CHILD(a));
		c = ((struct _state*)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + ((struct _state*)(RIGHT_CHILD(a)->x.state))->cost[_rc_NT] + 1;
		if (c + 0 < p->cost[_reg_NT]) {  /* reg : BANDU(reg,rc) */
			p->cost[_reg_NT] = c + 0;
			p->rule._reg = 52;
			_closure_reg(a, c + 0);
		}
		if (
			RIGHT_CHILD(a)->op == 406 /* BCOMU */
		) {
			c = ((struct _state*)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + ((struct _state*)(LEFT_CHILD(RIGHT_CHILD(a))->x.state))->cost[_rc_NT] + 1;
			if (c + 0 < p->cost[_reg_NT]) {  /* reg : BANDU(reg,BCOMU(rc)) */
				p->cost[_reg_NT] = c + 0;
				p->rule._reg = 62;
				_closure_reg(a, c + 0);
			}
		}
		break;
	case 406:  /* BCOMU */
		_label(LEFT_CHILD(a));
		c = ((struct _state*)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + 1;
		if (c + 0 < p->cost[_reg_NT]) {  /* reg : BCOMU(reg) */
			p->cost[_reg_NT] = c + 0;
			p->rule._reg = 66;
			_closure_reg(a, c + 0);
		}
		break;
	case 422:  /* BORU */
		_label(LEFT_CHILD(a));
		_label(RIGHT_CHILD(a));
		c = ((struct _state*)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + ((struct _state*)(RIGHT_CHILD(a)->x.state))->cost[_rc_NT] + 1;
		if (c + 0 < p->cost[_reg_NT]) {  /* reg : BORU(reg,rc) */
			p->cost[_reg_NT] = c + 0;
			p->rule._reg = 53;
			_closure_reg(a, c + 0);
		}
		if (
			RIGHT_CHILD(a)->op == 406 /* BCOMU */
		) {
			c = ((struct _state*)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + ((struct _state*)(LEFT_CHILD(RIGHT_CHILD(a))->x.state))->cost[_rc_NT] + 1;
			if (c + 0 < p->cost[_reg_NT]) {  /* reg : BORU(reg,BCOMU(rc)) */
				p->cost[_reg_NT] = c + 0;
				p->rule._reg = 63;
				_closure_reg(a, c + 0);
			}
		}
		break;
	case 438:  /* BXORU */
		_label(LEFT_CHILD(a));
		_label(RIGHT_CHILD(a));
		c = ((struct _state*)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + ((struct _state*)(RIGHT_CHILD(a)->x.state))->cost[_rc_NT] + 1;
		if (c + 0 < p->cost[_reg_NT]) {  /* reg : BXORU(reg,rc) */
			p->cost[_reg_NT] = c + 0;
			p->rule._reg = 54;
			_closure_reg(a, c + 0);
		}
		if (
			RIGHT_CHILD(a)->op == 406 /* BCOMU */
		) {
			c = ((struct _state*)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + ((struct _state*)(LEFT_CHILD(RIGHT_CHILD(a))->x.state))->cost[_rc_NT] + 1;
			if (c + 0 < p->cost[_reg_NT]) {  /* reg : BXORU(reg,BCOMU(rc)) */
				p->cost[_reg_NT] = c + 0;
				p->rule._reg = 64;
				_closure_reg(a, c + 0);
			}
		}
		break;
	case 217:  /* CALLB */
		_label(LEFT_CHILD(a));
		_label(RIGHT_CHILD(a));
		c = ((struct _state*)(LEFT_CHILD(a)->x.state))->cost[_call_NT] + ((struct _state*)(RIGHT_CHILD(a)->x.state))->cost[_reg_NT] + 2;
		if (c + 0 < p->cost[_stmt_NT]) {  /* stmt : CALLB(call,reg) */
			p->cost[_stmt_NT] = c + 0;
			p->rule._stmt = 35;
		}
		break;
	case 210:  /* CALLD */
		_label(LEFT_CHILD(a));
		c = ((struct _state*)(LEFT_CHILD(a)->x.state))->cost[_call_NT] + 2;
		if (c + 0 < p->cost[_reg_NT]) {  /* reg : CALLD(call) */
			p->cost[_reg_NT] = c + 0;
			p->rule._reg = 71;
			_closure_reg(a, c + 0);
		}
		break;
	case 209:  /* CALLF */
		_label(LEFT_CHILD(a));
		c = ((struct _state*)(LEFT_CHILD(a)->x.state))->cost[_call_NT] + 2;
		if (c + 0 < p->cost[_reg_NT]) {  /* reg : CALLF(call) */
			p->cost[_reg_NT] = c + 0;
			p->rule._reg = 72;
			_closure_reg(a, c + 0);
		}
		break;
	case 213:  /* CALLI */
		_label(LEFT_CHILD(a));
		c = ((struct _state*)(LEFT_CHILD(a)->x.state))->cost[_call_NT] + 2;
		if (c + 0 < p->cost[_reg_NT]) {  /* reg : CALLI(call) */
			p->cost[_reg_NT] = c + 0;
			p->rule._reg = 73;
			_closure_reg(a, c + 0);
		}
		break;
	case 216:  /* CALLV */
		_label(LEFT_CHILD(a));
		c = ((struct _state*)(LEFT_CHILD(a)->x.state))->cost[_call_NT] + 2;
		if (c + 0 < p->cost[_stmt_NT]) {  /* stmt : CALLV(call) */
			p->cost[_stmt_NT] = c + 0;
			p->rule._stmt = 34;
		}
		break;
	case 19:  /* CNSTC */
		c = 0;
		if (c + 0 < p->cost[_con_NT]) {  /* con : CNSTC */
			p->cost[_con_NT] = c + 0;
			p->rule._con = 1;
			_closure_con(a, c + 0);
		}
		c = imm(a);
		if (c + 0 < p->cost[_con13_NT]) {  /* con13 : CNSTC */
			p->cost[_con13_NT] = c + 0;
			p->rule._con13 = 1;
			_closure_con13(a, c + 0);
		}
		c = range(a, 0, 0);
		if (c + 0 < p->cost[_reg_NT]) {  /* reg : CNSTC */
			p->cost[_reg_NT] = c + 0;
			p->rule._reg = 43;
			_closure_reg(a, c + 0);
		}
		break;
	case 18:  /* CNSTD */
		break;
	case 17:  /* CNSTF */
		break;
	case 21:  /* CNSTI */
		c = 0;
		if (c + 0 < p->cost[_con_NT]) {  /* con : CNSTI */
			p->cost[_con_NT] = c + 0;
			p->rule._con = 2;
			_closure_con(a, c + 0);
		}
		c = imm(a);
		if (c + 0 < p->cost[_con13_NT]) {  /* con13 : CNSTI */
			p->cost[_con13_NT] = c + 0;
			p->rule._con13 = 2;
			_closure_con13(a, c + 0);
		}
		c = range(a, 0, 0);
		if (c + 0 < p->cost[_reg_NT]) {  /* reg : CNSTI */
			p->cost[_reg_NT] = c + 0;
			p->rule._reg = 44;
			_closure_reg(a, c + 0);
		}
		c = range(a, 0, 31);
		if (c + 0 < p->cost[_rc5_NT]) {  /* rc5 : CNSTI */
			p->cost[_rc5_NT] = c + 0;
			p->rule._rc5 = 1;
		}
		break;
	case 23:  /* CNSTP */
		c = 0;
		if (c + 0 < p->cost[_con_NT]) {  /* con : CNSTP */
			p->cost[_con_NT] = c + 0;
			p->rule._con = 3;
			_closure_con(a, c + 0);
		}
		c = imm(a);
		if (c + 0 < p->cost[_con13_NT]) {  /* con13 : CNSTP */
			p->cost[_con13_NT] = c + 0;
			p->rule._con13 = 3;
			_closure_con13(a, c + 0);
		}
		c = range(a, 0, 0);
		if (c + 0 < p->cost[_reg_NT]) {  /* reg : CNSTP */
			p->cost[_reg_NT] = c + 0;
			p->rule._reg = 45;
			_closure_reg(a, c + 0);
		}
		break;
	case 20:  /* CNSTS */
		c = 0;
		if (c + 0 < p->cost[_con_NT]) {  /* con : CNSTS */
			p->cost[_con_NT] = c + 0;
			p->rule._con = 4;
			_closure_con(a, c + 0);
		}
		c = imm(a);
		if (c + 0 < p->cost[_con13_NT]) {  /* con13 : CNSTS */
			p->cost[_con13_NT] = c + 0;
			p->rule._con13 = 4;
			_closure_con13(a, c + 0);
		}
		c = range(a, 0, 0);
		if (c + 0 < p->cost[_reg_NT]) {  /* reg : CNSTS */
			p->cost[_reg_NT] = c + 0;
			p->rule._reg = 46;
			_closure_reg(a, c + 0);
		}
		break;
	case 22:  /* CNSTU */
		c = 0;
		if (c + 0 < p->cost[_con_NT]) {  /* con : CNSTU */
			p->cost[_con_NT] = c + 0;
			p->rule._con = 5;
			_closure_con(a, c + 0);
		}
		c = imm(a);
		if (c + 0 < p->cost[_con13_NT]) {  /* con13 : CNSTU */
			p->cost[_con13_NT] = c + 0;
			p->rule._con13 = 5;
			_closure_con13(a, c + 0);
		}
		c = range(a, 0, 0);
		if (c + 0 < p->cost[_reg_NT]) {  /* reg : CNSTU */
			p->cost[_reg_NT] = c + 0;
			p->rule._reg = 47;
			_closure_reg(a, c + 0);
		}
		break;
	case 85:  /* CVCI */
		_label(LEFT_CHILD(a));
		if (
			LEFT_CHILD(a)->op == 67 /* INDIRC */
		) {
			c = ((struct _state*)(LEFT_CHILD(LEFT_CHILD(a))->x.state))->cost[_addr_NT] + 1;
			if (c + 0 < p->cost[_reg_NT]) {  /* reg : CVCI(INDIRC(addr)) */
				p->cost[_reg_NT] = c + 0;
				p->rule._reg = 22;
				_closure_reg(a, c + 0);
			}
		}
		c = ((struct _state*)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + 2;
		if (c + 0 < p->cost[_reg_NT]) {  /* reg : CVCI(reg) */
			p->cost[_reg_NT] = c + 0;
			p->rule._reg = 67;
			_closure_reg(a, c + 0);
		}
		break;
	case 86:  /* CVCU */
		_label(LEFT_CHILD(a));
		if (
			LEFT_CHILD(a)->op == 67 /* INDIRC */
		) {
			c = ((struct _state*)(LEFT_CHILD(LEFT_CHILD(a))->x.state))->cost[_addr_NT] + 1;
			if (c + 0 < p->cost[_reg_NT]) {  /* reg : CVCU(INDIRC(addr)) */
				p->cost[_reg_NT] = c + 0;
				p->rule._reg = 24;
				_closure_reg(a, c + 0);
			}
		}
		c = ((struct _state*)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + 1;
		if (c + 0 < p->cost[_reg_NT]) {  /* reg : CVCU(reg) */
			p->cost[_reg_NT] = c + 0;
			p->rule._reg = 69;
			_closure_reg(a, c + 0);
		}
		break;
	case 97:  /* CVDF */
		_label(LEFT_CHILD(a));
		c = ((struct _state*)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + 1;
		if (c + 0 < p->cost[_reg_NT]) {  /* reg : CVDF(reg) */
			p->cost[_reg_NT] = c + 0;
			p->rule._reg = 90;
			_closure_reg(a, c + 0);
		}
		break;
	case 101:  /* CVDI */
		_label(LEFT_CHILD(a));
		c = ((struct _state*)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + 3;
		if (c + 0 < p->cost[_reg_NT]) {  /* reg : CVDI(reg) */
			p->cost[_reg_NT] = c + 0;
			p->rule._reg = 92;
			_closure_reg(a, c + 0);
		}
		break;
	case 114:  /* CVFD */
		_label(LEFT_CHILD(a));
		c = ((struct _state*)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + 1;
		if (c + 0 < p->cost[_reg_NT]) {  /* reg : CVFD(reg) */
			p->cost[_reg_NT] = c + 0;
			p->rule._reg = 91;
			_closure_reg(a, c + 0);
		}
		break;
	case 131:  /* CVIC */
		_label(LEFT_CHILD(a));
		c = ((struct _state*)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + move(a);
		if (c + 0 < p->cost[_reg_NT]) {  /* reg : CVIC(reg) */
			p->cost[_reg_NT] = c + 0;
			p->rule._reg = 26;
			_closure_reg(a, c + 0);
		}
		c = ((struct _state*)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + notarget(a);
		if (c + 0 < p->cost[_reg_NT]) {  /* reg : CVIC(reg) */
			p->cost[_reg_NT] = c + 0;
			p->rule._reg = 34;
			_closure_reg(a, c + 0);
		}
		break;
	case 130:  /* CVID */
		_label(LEFT_CHILD(a));
		c = ((struct _state*)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + 3;
		if (c + 0 < p->cost[_reg_NT]) {  /* reg : CVID(reg) */
			p->cost[_reg_NT] = c + 0;
			p->rule._reg = 93;
			_closure_reg(a, c + 0);
		}
		break;
	case 132:  /* CVIS */
		_label(LEFT_CHILD(a));
		c = ((struct _state*)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + move(a);
		if (c + 0 < p->cost[_reg_NT]) {  /* reg : CVIS(reg) */
			p->cost[_reg_NT] = c + 0;
			p->rule._reg = 27;
			_closure_reg(a, c + 0);
		}
		c = ((struct _state*)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + notarget(a);
		if (c + 0 < p->cost[_reg_NT]) {  /* reg : CVIS(reg) */
			p->cost[_reg_NT] = c + 0;
			p->rule._reg = 35;
			_closure_reg(a, c + 0);
		}
		break;
	case 134:  /* CVIU */
		_label(LEFT_CHILD(a));
		c = ((struct _state*)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + notarget(a);
		if (c + 0 < p->cost[_reg_NT]) {  /* reg : CVIU(reg) */
			p->cost[_reg_NT] = c + 0;
			p->rule._reg = 7;
			_closure_reg(a, c + 0);
		}
		c = ((struct _state*)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + move(a);
		if (c + 0 < p->cost[_reg_NT]) {  /* reg : CVIU(reg) */
			p->cost[_reg_NT] = c + 0;
			p->rule._reg = 28;
			_closure_reg(a, c + 0);
		}
		break;
	case 150:  /* CVPU */
		_label(LEFT_CHILD(a));
		c = ((struct _state*)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + notarget(a);
		if (c + 0 < p->cost[_reg_NT]) {  /* reg : CVPU(reg) */
			p->cost[_reg_NT] = c + 0;
			p->rule._reg = 8;
			_closure_reg(a, c + 0);
		}
		c = ((struct _state*)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + move(a);
		if (c + 0 < p->cost[_reg_NT]) {  /* reg : CVPU(reg) */
			p->cost[_reg_NT] = c + 0;
			p->rule._reg = 29;
			_closure_reg(a, c + 0);
		}
		break;
	case 165:  /* CVSI */
		_label(LEFT_CHILD(a));
		if (
			LEFT_CHILD(a)->op == 68 /* INDIRS */
		) {
			c = ((struct _state*)(LEFT_CHILD(LEFT_CHILD(a))->x.state))->cost[_addr_NT] + 1;
			if (c + 0 < p->cost[_reg_NT]) {  /* reg : CVSI(INDIRS(addr)) */
				p->cost[_reg_NT] = c + 0;
				p->rule._reg = 23;
				_closure_reg(a, c + 0);
			}
		}
		c = ((struct _state*)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + 2;
		if (c + 0 < p->cost[_reg_NT]) {  /* reg : CVSI(reg) */
			p->cost[_reg_NT] = c + 0;
			p->rule._reg = 68;
			_closure_reg(a, c + 0);
		}
		break;
	case 166:  /* CVSU */
		_label(LEFT_CHILD(a));
		if (
			LEFT_CHILD(a)->op == 68 /* INDIRS */
		) {
			c = ((struct _state*)(LEFT_CHILD(LEFT_CHILD(a))->x.state))->cost[_addr_NT] + 1;
			if (c + 0 < p->cost[_reg_NT]) {  /* reg : CVSU(INDIRS(addr)) */
				p->cost[_reg_NT] = c + 0;
				p->rule._reg = 25;
				_closure_reg(a, c + 0);
			}
		}
		c = ((struct _state*)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + 2;
		if (c + 0 < p->cost[_reg_NT]) {  /* reg : CVSU(reg) */
			p->cost[_reg_NT] = c + 0;
			p->rule._reg = 70;
			_closure_reg(a, c + 0);
		}
		break;
	case 179:  /* CVUC */
		_label(LEFT_CHILD(a));
		c = ((struct _state*)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + move(a);
		if (c + 0 < p->cost[_reg_NT]) {  /* reg : CVUC(reg) */
			p->cost[_reg_NT] = c + 0;
			p->rule._reg = 30;
			_closure_reg(a, c + 0);
		}
		c = ((struct _state*)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + notarget(a);
		if (c + 0 < p->cost[_reg_NT]) {  /* reg : CVUC(reg) */
			p->cost[_reg_NT] = c + 0;
			p->rule._reg = 36;
			_closure_reg(a, c + 0);
		}
		break;
	case 181:  /* CVUI */
		_label(LEFT_CHILD(a));
		c = ((struct _state*)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + notarget(a);
		if (c + 0 < p->cost[_reg_NT]) {  /* reg : CVUI(reg) */
			p->cost[_reg_NT] = c + 0;
			p->rule._reg = 9;
			_closure_reg(a, c + 0);
		}
		c = ((struct _state*)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + move(a);
		if (c + 0 < p->cost[_reg_NT]) {  /* reg : CVUI(reg) */
			p->cost[_reg_NT] = c + 0;
			p->rule._reg = 31;
			_closure_reg(a, c + 0);
		}
		break;
	case 183:  /* CVUP */
		_label(LEFT_CHILD(a));
		c = ((struct _state*)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + notarget(a);
		if (c + 0 < p->cost[_reg_NT]) {  /* reg : CVUP(reg) */
			p->cost[_reg_NT] = c + 0;
			p->rule._reg = 10;
			_closure_reg(a, c + 0);
		}
		c = ((struct _state*)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + move(a);
		if (c + 0 < p->cost[_reg_NT]) {  /* reg : CVUP(reg) */
			p->cost[_reg_NT] = c + 0;
			p->rule._reg = 32;
			_closure_reg(a, c + 0);
		}
		break;
	case 180:  /* CVUS */
		_label(LEFT_CHILD(a));
		c = ((struct _state*)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + move(a);
		if (c + 0 < p->cost[_reg_NT]) {  /* reg : CVUS(reg) */
			p->cost[_reg_NT] = c + 0;
			p->rule._reg = 33;
			_closure_reg(a, c + 0);
		}
		c = ((struct _state*)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + notarget(a);
		if (c + 0 < p->cost[_reg_NT]) {  /* reg : CVUS(reg) */
			p->cost[_reg_NT] = c + 0;
			p->rule._reg = 37;
			_closure_reg(a, c + 0);
		}
		break;
	case 450:  /* DIVD */
		_label(LEFT_CHILD(a));
		_label(RIGHT_CHILD(a));
		c = ((struct _state*)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + ((struct _state*)(RIGHT_CHILD(a)->x.state))->cost[_reg_NT] + 1;
		if (c + 0 < p->cost[_reg_NT]) {  /* reg : DIVD(reg,reg) */
			p->cost[_reg_NT] = c + 0;
			p->rule._reg = 82;
			_closure_reg(a, c + 0);
		}
		break;
	case 449:  /* DIVF */
		_label(LEFT_CHILD(a));
		_label(RIGHT_CHILD(a));
		c = ((struct _state*)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + ((struct _state*)(RIGHT_CHILD(a)->x.state))->cost[_reg_NT] + 1;
		if (c + 0 < p->cost[_reg_NT]) {  /* reg : DIVF(reg,reg) */
			p->cost[_reg_NT] = c + 0;
			p->rule._reg = 83;
			_closure_reg(a, c + 0);
		}
		break;
	case 453:  /* DIVI */
		_label(LEFT_CHILD(a));
		_label(RIGHT_CHILD(a));
		c = ((struct _state*)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + ((struct _state*)(RIGHT_CHILD(a)->x.state))->cost[_reg_NT] + 2;
		if (c + 0 < p->cost[_reg_NT]) {  /* reg : DIVI(reg,reg) */
			p->cost[_reg_NT] = c + 0;
			p->rule._reg = 74;
			_closure_reg(a, c + 0);
		}
		break;
	case 454:  /* DIVU */
		_label(LEFT_CHILD(a));
		_label(RIGHT_CHILD(a));
		c = ((struct _state*)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + ((struct _state*)(RIGHT_CHILD(a)->x.state))->cost[_reg_NT] + 2;
		if (c + 0 < p->cost[_reg_NT]) {  /* reg : DIVU(reg,reg) */
			p->cost[_reg_NT] = c + 0;
			p->rule._reg = 75;
			_closure_reg(a, c + 0);
		}
		break;
	case 482:  /* EQD */
		_label(LEFT_CHILD(a));
		_label(RIGHT_CHILD(a));
		c = ((struct _state*)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + ((struct _state*)(RIGHT_CHILD(a)->x.state))->cost[_reg_NT] + 4;
		if (c + 0 < p->cost[_stmt_NT]) {  /* stmt : EQD(reg,reg) */
			p->cost[_stmt_NT] = c + 0;
			p->rule._stmt = 43;
		}
		break;
	case 481:  /* EQF */
		_label(LEFT_CHILD(a));
		_label(RIGHT_CHILD(a));
		c = ((struct _state*)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + ((struct _state*)(RIGHT_CHILD(a)->x.state))->cost[_reg_NT] + 4;
		if (c + 0 < p->cost[_stmt_NT]) {  /* stmt : EQF(reg,reg) */
			p->cost[_stmt_NT] = c + 0;
			p->rule._stmt = 44;
		}
		break;
	case 485:  /* EQI */
		_label(LEFT_CHILD(a));
		_label(RIGHT_CHILD(a));
		c = ((struct _state*)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + ((struct _state*)(RIGHT_CHILD(a)->x.state))->cost[_rc_NT] + 3;
		if (c + 0 < p->cost[_stmt_NT]) {  /* stmt : EQI(reg,rc) */
			p->cost[_stmt_NT] = c + 0;
			p->rule._stmt = 24;
		}
		break;
	case 498:  /* GED */
		_label(LEFT_CHILD(a));
		_label(RIGHT_CHILD(a));
		c = ((struct _state*)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + ((struct _state*)(RIGHT_CHILD(a)->x.state))->cost[_reg_NT] + 4;
		if (c + 0 < p->cost[_stmt_NT]) {  /* stmt : GED(reg,reg) */
			p->cost[_stmt_NT] = c + 0;
			p->rule._stmt = 45;
		}
		break;
	case 497:  /* GEF */
		_label(LEFT_CHILD(a));
		_label(RIGHT_CHILD(a));
		c = ((struct _state*)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + ((struct _state*)(RIGHT_CHILD(a)->x.state))->cost[_reg_NT] + 4;
		if (c + 0 < p->cost[_stmt_NT]) {  /* stmt : GEF(reg,reg) */
			p->cost[_stmt_NT] = c + 0;
			p->rule._stmt = 46;
		}
		break;
	case 501:  /* GEI */
		_label(LEFT_CHILD(a));
		_label(RIGHT_CHILD(a));
		c = ((struct _state*)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + ((struct _state*)(RIGHT_CHILD(a)->x.state))->cost[_rc_NT] + 3;
		if (c + 0 < p->cost[_stmt_NT]) {  /* stmt : GEI(reg,rc) */
			p->cost[_stmt_NT] = c + 0;
			p->rule._stmt = 25;
		}
		break;
	case 502:  /* GEU */
		_label(LEFT_CHILD(a));
		_label(RIGHT_CHILD(a));
		c = ((struct _state*)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + ((struct _state*)(RIGHT_CHILD(a)->x.state))->cost[_rc_NT] + 3;
		if (c + 0 < p->cost[_stmt_NT]) {  /* stmt : GEU(reg,rc) */
			p->cost[_stmt_NT] = c + 0;
			p->rule._stmt = 26;
		}
		break;
	case 514:  /* GTD */
		_label(LEFT_CHILD(a));
		_label(RIGHT_CHILD(a));
		c = ((struct _state*)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + ((struct _state*)(RIGHT_CHILD(a)->x.state))->cost[_reg_NT] + 4;
		if (c + 0 < p->cost[_stmt_NT]) {  /* stmt : GTD(reg,reg) */
			p->cost[_stmt_NT] = c + 0;
			p->rule._stmt = 47;
		}
		break;
	case 513:  /* GTF */
		_label(LEFT_CHILD(a));
		_label(RIGHT_CHILD(a));
		c = ((struct _state*)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + ((struct _state*)(RIGHT_CHILD(a)->x.state))->cost[_reg_NT] + 4;
		if (c + 0 < p->cost[_stmt_NT]) {  /* stmt : GTF(reg,reg) */
			p->cost[_stmt_NT] = c + 0;
			p->rule._stmt = 48;
		}
		break;
	case 517:  /* GTI */
		_label(LEFT_CHILD(a));
		_label(RIGHT_CHILD(a));
		c = ((struct _state*)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + ((struct _state*)(RIGHT_CHILD(a)->x.state))->cost[_rc_NT] + 3;
		if (c + 0 < p->cost[_stmt_NT]) {  /* stmt : GTI(reg,rc) */
			p->cost[_stmt_NT] = c + 0;
			p->rule._stmt = 27;
		}
		break;
	case 518:  /* GTU */
		_label(LEFT_CHILD(a));
		_label(RIGHT_CHILD(a));
		c = ((struct _state*)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + ((struct _state*)(RIGHT_CHILD(a)->x.state))->cost[_rc_NT] + 3;
		if (c + 0 < p->cost[_stmt_NT]) {  /* stmt : GTU(reg,rc) */
			p->cost[_stmt_NT] = c + 0;
			p->rule._stmt = 28;
		}
		break;
	case 73:  /* INDIRB */
		_label(LEFT_CHILD(a));
		break;
	case 67:  /* INDIRC */
		_label(LEFT_CHILD(a));
		if (
			LEFT_CHILD(a)->op == 615 /* VREGP */
		) {
			assert(a);
			if (mayrecalc(a)) {
				struct _state *q = a->syms[RX]->u.t.cse->x.state;
				if(q->cost[_addrl_NT] == 0) {
					p->cost[_addrl_NT] = 0;
					p->rule._addrl = q->rule._addrl;
				}
				if(q->cost[_rc5_NT] == 0) {
					p->cost[_rc5_NT] = 0;
					p->rule._rc5 = q->rule._rc5;
				}
				if(q->cost[_con13_NT] == 0) {
					p->cost[_con13_NT] = 0;
					p->rule._con13 = q->rule._con13;
				}
				if(q->cost[_spill_NT] == 0) {
					p->cost[_spill_NT] = 0;
					p->rule._spill = q->rule._spill;
				}
				if(q->cost[_rc_NT] == 0) {
					p->cost[_rc_NT] = 0;
					p->rule._rc = q->rule._rc;
				}
				if(q->cost[_call_NT] == 0) {
					p->cost[_call_NT] = 0;
					p->rule._call = q->rule._call;
				}
				if(q->cost[_stmt_NT] == 0) {
					p->cost[_stmt_NT] = 0;
					p->rule._stmt = q->rule._stmt;
				}
				if(q->cost[_reg_NT] == 0) {
					p->cost[_reg_NT] = 0;
					p->rule._reg = q->rule._reg;
				}
				if(q->cost[_stk_NT] == 0) {
					p->cost[_stk_NT] = 0;
					p->rule._stk = q->rule._stk;
				}
				if(q->cost[_con_NT] == 0) {
					p->cost[_con_NT] = 0;
					p->rule._con = q->rule._con;
				}
				if(q->cost[_addr_NT] == 0) {
					p->cost[_addr_NT] = 0;
					p->rule._addr = q->rule._addr;
				}
				if(q->cost[_base_NT] == 0) {
					p->cost[_base_NT] = 0;
					p->rule._base = q->rule._base;
				}
				if(q->cost[_addrg_NT] == 0) {
					p->cost[_addrg_NT] = 0;
					p->rule._addrg = q->rule._addrg;
				}
				if(q->cost[_stk13_NT] == 0) {
					p->cost[_stk13_NT] = 0;
					p->rule._stk13 = q->rule._stk13;
				}
			}
			c = 0;
			if (c + 0 < p->cost[_reg_NT]) {  /* reg : INDIRC(VREGP) */
				p->cost[_reg_NT] = c + 0;
				p->rule._reg = 1;
				_closure_reg(a, c + 0);
			}
		}
		c = ((struct _state*)(LEFT_CHILD(a)->x.state))->cost[_addr_NT] + 1;
		if (c + 0 < p->cost[_reg_NT]) {  /* reg : INDIRC(addr) */
			p->cost[_reg_NT] = c + 0;
			p->rule._reg = 15;
			_closure_reg(a, c + 0);
		}
		break;
	case 66:  /* INDIRD */
		_label(LEFT_CHILD(a));
		if (
			LEFT_CHILD(a)->op == 615 /* VREGP */
		) {
			assert(a);
			if (mayrecalc(a)) {
				struct _state *q = a->syms[RX]->u.t.cse->x.state;
				if(q->cost[_addrl_NT] == 0) {
					p->cost[_addrl_NT] = 0;
					p->rule._addrl = q->rule._addrl;
				}
				if(q->cost[_rc5_NT] == 0) {
					p->cost[_rc5_NT] = 0;
					p->rule._rc5 = q->rule._rc5;
				}
				if(q->cost[_con13_NT] == 0) {
					p->cost[_con13_NT] = 0;
					p->rule._con13 = q->rule._con13;
				}
				if(q->cost[_spill_NT] == 0) {
					p->cost[_spill_NT] = 0;
					p->rule._spill = q->rule._spill;
				}
				if(q->cost[_rc_NT] == 0) {
					p->cost[_rc_NT] = 0;
					p->rule._rc = q->rule._rc;
				}
				if(q->cost[_call_NT] == 0) {
					p->cost[_call_NT] = 0;
					p->rule._call = q->rule._call;
				}
				if(q->cost[_stmt_NT] == 0) {
					p->cost[_stmt_NT] = 0;
					p->rule._stmt = q->rule._stmt;
				}
				if(q->cost[_reg_NT] == 0) {
					p->cost[_reg_NT] = 0;
					p->rule._reg = q->rule._reg;
				}
				if(q->cost[_stk_NT] == 0) {
					p->cost[_stk_NT] = 0;
					p->rule._stk = q->rule._stk;
				}
				if(q->cost[_con_NT] == 0) {
					p->cost[_con_NT] = 0;
					p->rule._con = q->rule._con;
				}
				if(q->cost[_addr_NT] == 0) {
					p->cost[_addr_NT] = 0;
					p->rule._addr = q->rule._addr;
				}
				if(q->cost[_base_NT] == 0) {
					p->cost[_base_NT] = 0;
					p->rule._base = q->rule._base;
				}
				if(q->cost[_addrg_NT] == 0) {
					p->cost[_addrg_NT] = 0;
					p->rule._addrg = q->rule._addrg;
				}
				if(q->cost[_stk13_NT] == 0) {
					p->cost[_stk13_NT] = 0;
					p->rule._stk13 = q->rule._stk13;
				}
			}
			c = 0;
			if (c + 0 < p->cost[_reg_NT]) {  /* reg : INDIRD(VREGP) */
				p->cost[_reg_NT] = c + 0;
				p->rule._reg = 2;
				_closure_reg(a, c + 0);
			}
		}
		c = ((struct _state*)(LEFT_CHILD(a)->x.state))->cost[_addrl_NT] + 1;
		if (c + 0 < p->cost[_reg_NT]) {  /* reg : INDIRD(addrl) */
			p->cost[_reg_NT] = c + 0;
			p->rule._reg = 20;
			_closure_reg(a, c + 0);
		}
		c = ((struct _state*)(LEFT_CHILD(a)->x.state))->cost[_base_NT] + 2;
		if (c + 0 < p->cost[_reg_NT]) {  /* reg : INDIRD(base) */
			p->cost[_reg_NT] = c + 0;
			p->rule._reg = 21;
			_closure_reg(a, c + 0);
		}
		break;
	case 65:  /* INDIRF */
		_label(LEFT_CHILD(a));
		if (
			LEFT_CHILD(a)->op == 615 /* VREGP */
		) {
			assert(a);
			if (mayrecalc(a)) {
				struct _state *q = a->syms[RX]->u.t.cse->x.state;
				if(q->cost[_addrl_NT] == 0) {
					p->cost[_addrl_NT] = 0;
					p->rule._addrl = q->rule._addrl;
				}
				if(q->cost[_rc5_NT] == 0) {
					p->cost[_rc5_NT] = 0;
					p->rule._rc5 = q->rule._rc5;
				}
				if(q->cost[_con13_NT] == 0) {
					p->cost[_con13_NT] = 0;
					p->rule._con13 = q->rule._con13;
				}
				if(q->cost[_spill_NT] == 0) {
					p->cost[_spill_NT] = 0;
					p->rule._spill = q->rule._spill;
				}
				if(q->cost[_rc_NT] == 0) {
					p->cost[_rc_NT] = 0;
					p->rule._rc = q->rule._rc;
				}
				if(q->cost[_call_NT] == 0) {
					p->cost[_call_NT] = 0;
					p->rule._call = q->rule._call;
				}
				if(q->cost[_stmt_NT] == 0) {
					p->cost[_stmt_NT] = 0;
					p->rule._stmt = q->rule._stmt;
				}
				if(q->cost[_reg_NT] == 0) {
					p->cost[_reg_NT] = 0;
					p->rule._reg = q->rule._reg;
				}
				if(q->cost[_stk_NT] == 0) {
					p->cost[_stk_NT] = 0;
					p->rule._stk = q->rule._stk;
				}
				if(q->cost[_con_NT] == 0) {
					p->cost[_con_NT] = 0;
					p->rule._con = q->rule._con;
				}
				if(q->cost[_addr_NT] == 0) {
					p->cost[_addr_NT] = 0;
					p->rule._addr = q->rule._addr;
				}
				if(q->cost[_base_NT] == 0) {
					p->cost[_base_NT] = 0;
					p->rule._base = q->rule._base;
				}
				if(q->cost[_addrg_NT] == 0) {
					p->cost[_addrg_NT] = 0;
					p->rule._addrg = q->rule._addrg;
				}
				if(q->cost[_stk13_NT] == 0) {
					p->cost[_stk13_NT] = 0;
					p->rule._stk13 = q->rule._stk13;
				}
			}
			c = 0;
			if (c + 0 < p->cost[_reg_NT]) {  /* reg : INDIRF(VREGP) */
				p->cost[_reg_NT] = c + 0;
				p->rule._reg = 3;
				_closure_reg(a, c + 0);
			}
		}
		c = ((struct _state*)(LEFT_CHILD(a)->x.state))->cost[_addr_NT] + 1;
		if (c + 0 < p->cost[_reg_NT]) {  /* reg : INDIRF(addr) */
			p->cost[_reg_NT] = c + 0;
			p->rule._reg = 19;
			_closure_reg(a, c + 0);
		}
		break;
	case 69:  /* INDIRI */
		_label(LEFT_CHILD(a));
		if (
			LEFT_CHILD(a)->op == 615 /* VREGP */
		) {
			assert(a);
			if (mayrecalc(a)) {
				struct _state *q = a->syms[RX]->u.t.cse->x.state;
				if(q->cost[_addrl_NT] == 0) {
					p->cost[_addrl_NT] = 0;
					p->rule._addrl = q->rule._addrl;
				}
				if(q->cost[_rc5_NT] == 0) {
					p->cost[_rc5_NT] = 0;
					p->rule._rc5 = q->rule._rc5;
				}
				if(q->cost[_con13_NT] == 0) {
					p->cost[_con13_NT] = 0;
					p->rule._con13 = q->rule._con13;
				}
				if(q->cost[_spill_NT] == 0) {
					p->cost[_spill_NT] = 0;
					p->rule._spill = q->rule._spill;
				}
				if(q->cost[_rc_NT] == 0) {
					p->cost[_rc_NT] = 0;
					p->rule._rc = q->rule._rc;
				}
				if(q->cost[_call_NT] == 0) {
					p->cost[_call_NT] = 0;
					p->rule._call = q->rule._call;
				}
				if(q->cost[_stmt_NT] == 0) {
					p->cost[_stmt_NT] = 0;
					p->rule._stmt = q->rule._stmt;
				}
				if(q->cost[_reg_NT] == 0) {
					p->cost[_reg_NT] = 0;
					p->rule._reg = q->rule._reg;
				}
				if(q->cost[_stk_NT] == 0) {
					p->cost[_stk_NT] = 0;
					p->rule._stk = q->rule._stk;
				}
				if(q->cost[_con_NT] == 0) {
					p->cost[_con_NT] = 0;
					p->rule._con = q->rule._con;
				}
				if(q->cost[_addr_NT] == 0) {
					p->cost[_addr_NT] = 0;
					p->rule._addr = q->rule._addr;
				}
				if(q->cost[_base_NT] == 0) {
					p->cost[_base_NT] = 0;
					p->rule._base = q->rule._base;
				}
				if(q->cost[_addrg_NT] == 0) {
					p->cost[_addrg_NT] = 0;
					p->rule._addrg = q->rule._addrg;
				}
				if(q->cost[_stk13_NT] == 0) {
					p->cost[_stk13_NT] = 0;
					p->rule._stk13 = q->rule._stk13;
				}
			}
			c = 0;
			if (c + 0 < p->cost[_reg_NT]) {  /* reg : INDIRI(VREGP) */
				p->cost[_reg_NT] = c + 0;
				p->rule._reg = 4;
				_closure_reg(a, c + 0);
			}
		}
		c = ((struct _state*)(LEFT_CHILD(a)->x.state))->cost[_addr_NT] + 1;
		if (c + 0 < p->cost[_reg_NT]) {  /* reg : INDIRI(addr) */
			p->cost[_reg_NT] = c + 0;
			p->rule._reg = 17;
			_closure_reg(a, c + 0);
		}
		break;
	case 71:  /* INDIRP */
		_label(LEFT_CHILD(a));
		if (
			LEFT_CHILD(a)->op == 615 /* VREGP */
		) {
			assert(a);
			if (mayrecalc(a)) {
				struct _state *q = a->syms[RX]->u.t.cse->x.state;
				if(q->cost[_addrl_NT] == 0) {
					p->cost[_addrl_NT] = 0;
					p->rule._addrl = q->rule._addrl;
				}
				if(q->cost[_rc5_NT] == 0) {
					p->cost[_rc5_NT] = 0;
					p->rule._rc5 = q->rule._rc5;
				}
				if(q->cost[_con13_NT] == 0) {
					p->cost[_con13_NT] = 0;
					p->rule._con13 = q->rule._con13;
				}
				if(q->cost[_spill_NT] == 0) {
					p->cost[_spill_NT] = 0;
					p->rule._spill = q->rule._spill;
				}
				if(q->cost[_rc_NT] == 0) {
					p->cost[_rc_NT] = 0;
					p->rule._rc = q->rule._rc;
				}
				if(q->cost[_call_NT] == 0) {
					p->cost[_call_NT] = 0;
					p->rule._call = q->rule._call;
				}
				if(q->cost[_stmt_NT] == 0) {
					p->cost[_stmt_NT] = 0;
					p->rule._stmt = q->rule._stmt;
				}
				if(q->cost[_reg_NT] == 0) {
					p->cost[_reg_NT] = 0;
					p->rule._reg = q->rule._reg;
				}
				if(q->cost[_stk_NT] == 0) {
					p->cost[_stk_NT] = 0;
					p->rule._stk = q->rule._stk;
				}
				if(q->cost[_con_NT] == 0) {
					p->cost[_con_NT] = 0;
					p->rule._con = q->rule._con;
				}
				if(q->cost[_addr_NT] == 0) {
					p->cost[_addr_NT] = 0;
					p->rule._addr = q->rule._addr;
				}
				if(q->cost[_base_NT] == 0) {
					p->cost[_base_NT] = 0;
					p->rule._base = q->rule._base;
				}
				if(q->cost[_addrg_NT] == 0) {
					p->cost[_addrg_NT] = 0;
					p->rule._addrg = q->rule._addrg;
				}
				if(q->cost[_stk13_NT] == 0) {
					p->cost[_stk13_NT] = 0;
					p->rule._stk13 = q->rule._stk13;
				}
			}
			c = 0;
			if (c + 0 < p->cost[_reg_NT]) {  /* reg : INDIRP(VREGP) */
				p->cost[_reg_NT] = c + 0;
				p->rule._reg = 5;
				_closure_reg(a, c + 0);
			}
		}
		c = ((struct _state*)(LEFT_CHILD(a)->x.state))->cost[_addr_NT] + 1;
		if (c + 0 < p->cost[_reg_NT]) {  /* reg : INDIRP(addr) */
			p->cost[_reg_NT] = c + 0;
			p->rule._reg = 18;
			_closure_reg(a, c + 0);
		}
		break;
	case 68:  /* INDIRS */
		_label(LEFT_CHILD(a));
		if (
			LEFT_CHILD(a)->op == 615 /* VREGP */
		) {
			assert(a);
			if (mayrecalc(a)) {
				struct _state *q = a->syms[RX]->u.t.cse->x.state;
				if(q->cost[_addrl_NT] == 0) {
					p->cost[_addrl_NT] = 0;
					p->rule._addrl = q->rule._addrl;
				}
				if(q->cost[_rc5_NT] == 0) {
					p->cost[_rc5_NT] = 0;
					p->rule._rc5 = q->rule._rc5;
				}
				if(q->cost[_con13_NT] == 0) {
					p->cost[_con13_NT] = 0;
					p->rule._con13 = q->rule._con13;
				}
				if(q->cost[_spill_NT] == 0) {
					p->cost[_spill_NT] = 0;
					p->rule._spill = q->rule._spill;
				}
				if(q->cost[_rc_NT] == 0) {
					p->cost[_rc_NT] = 0;
					p->rule._rc = q->rule._rc;
				}
				if(q->cost[_call_NT] == 0) {
					p->cost[_call_NT] = 0;
					p->rule._call = q->rule._call;
				}
				if(q->cost[_stmt_NT] == 0) {
					p->cost[_stmt_NT] = 0;
					p->rule._stmt = q->rule._stmt;
				}
				if(q->cost[_reg_NT] == 0) {
					p->cost[_reg_NT] = 0;
					p->rule._reg = q->rule._reg;
				}
				if(q->cost[_stk_NT] == 0) {
					p->cost[_stk_NT] = 0;
					p->rule._stk = q->rule._stk;
				}
				if(q->cost[_con_NT] == 0) {
					p->cost[_con_NT] = 0;
					p->rule._con = q->rule._con;
				}
				if(q->cost[_addr_NT] == 0) {
					p->cost[_addr_NT] = 0;
					p->rule._addr = q->rule._addr;
				}
				if(q->cost[_base_NT] == 0) {
					p->cost[_base_NT] = 0;
					p->rule._base = q->rule._base;
				}
				if(q->cost[_addrg_NT] == 0) {
					p->cost[_addrg_NT] = 0;
					p->rule._addrg = q->rule._addrg;
				}
				if(q->cost[_stk13_NT] == 0) {
					p->cost[_stk13_NT] = 0;
					p->rule._stk13 = q->rule._stk13;
				}
			}
			c = 0;
			if (c + 0 < p->cost[_reg_NT]) {  /* reg : INDIRS(VREGP) */
				p->cost[_reg_NT] = c + 0;
				p->rule._reg = 6;
				_closure_reg(a, c + 0);
			}
		}
		c = ((struct _state*)(LEFT_CHILD(a)->x.state))->cost[_addr_NT] + 1;
		if (c + 0 < p->cost[_reg_NT]) {  /* reg : INDIRS(addr) */
			p->cost[_reg_NT] = c + 0;
			p->rule._reg = 16;
			_closure_reg(a, c + 0);
		}
		break;
	case 584:  /* JUMPV */
		_label(LEFT_CHILD(a));
		c = ((struct _state*)(LEFT_CHILD(a)->x.state))->cost[_addrg_NT] + 2;
		if (c + 0 < p->cost[_stmt_NT]) {  /* stmt : JUMPV(addrg) */
			p->cost[_stmt_NT] = c + 0;
			p->rule._stmt = 21;
		}
		c = ((struct _state*)(LEFT_CHILD(a)->x.state))->cost[_addr_NT] + 2;
		if (c + 0 < p->cost[_stmt_NT]) {  /* stmt : JUMPV(addr) */
			p->cost[_stmt_NT] = c + 0;
			p->rule._stmt = 22;
		}
		break;
	case 600:  /* LABELV */
		c = 0;
		if (c + 0 < p->cost[_stmt_NT]) {  /* stmt : LABELV */
			p->cost[_stmt_NT] = c + 0;
			p->rule._stmt = 23;
		}
		break;
	case 530:  /* LED */
		_label(LEFT_CHILD(a));
		_label(RIGHT_CHILD(a));
		c = ((struct _state*)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + ((struct _state*)(RIGHT_CHILD(a)->x.state))->cost[_reg_NT] + 4;
		if (c + 0 < p->cost[_stmt_NT]) {  /* stmt : LED(reg,reg) */
			p->cost[_stmt_NT] = c + 0;
			p->rule._stmt = 49;
		}
		break;
	case 529:  /* LEF */
		_label(LEFT_CHILD(a));
		_label(RIGHT_CHILD(a));
		c = ((struct _state*)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + ((struct _state*)(RIGHT_CHILD(a)->x.state))->cost[_reg_NT] + 4;
		if (c + 0 < p->cost[_stmt_NT]) {  /* stmt : LEF(reg,reg) */
			p->cost[_stmt_NT] = c + 0;
			p->rule._stmt = 50;
		}
		break;
	case 533:  /* LEI */
		_label(LEFT_CHILD(a));
		_label(RIGHT_CHILD(a));
		c = ((struct _state*)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + ((struct _state*)(RIGHT_CHILD(a)->x.state))->cost[_rc_NT] + 3;
		if (c + 0 < p->cost[_stmt_NT]) {  /* stmt : LEI(reg,rc) */
			p->cost[_stmt_NT] = c + 0;
			p->rule._stmt = 29;
		}
		break;
	case 534:  /* LEU */
		_label(LEFT_CHILD(a));
		_label(RIGHT_CHILD(a));
		c = ((struct _state*)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + ((struct _state*)(RIGHT_CHILD(a)->x.state))->cost[_rc_NT] + 3;
		if (c + 0 < p->cost[_stmt_NT]) {  /* stmt : LEU(reg,rc) */
			p->cost[_stmt_NT] = c + 0;
			p->rule._stmt = 30;
		}
		break;
	case 233:  /* LOADB */
		break;
	case 227:  /* LOADC */
		_label(LEFT_CHILD(a));
		c = ((struct _state*)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + move(a);
		if (c + 0 < p->cost[_reg_NT]) {  /* reg : LOADC(reg) */
			p->cost[_reg_NT] = c + 0;
			p->rule._reg = 38;
			_closure_reg(a, c + 0);
		}
		break;
	case 226:  /* LOADD */
		_label(LEFT_CHILD(a));
		c = ((struct _state*)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + 2;
		if (c + 0 < p->cost[_reg_NT]) {  /* reg : LOADD(reg) */
			p->cost[_reg_NT] = c + 0;
			p->rule._reg = 94;
			_closure_reg(a, c + 0);
		}
		break;
	case 225:  /* LOADF */
		_label(LEFT_CHILD(a));
		c = ((struct _state*)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + 1;
		if (c + 0 < p->cost[_reg_NT]) {  /* reg : LOADF(reg) */
			p->cost[_reg_NT] = c + 0;
			p->rule._reg = 89;
			_closure_reg(a, c + 0);
		}
		break;
	case 229:  /* LOADI */
		_label(LEFT_CHILD(a));
		c = ((struct _state*)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + move(a);
		if (c + 0 < p->cost[_reg_NT]) {  /* reg : LOADI(reg) */
			p->cost[_reg_NT] = c + 0;
			p->rule._reg = 39;
			_closure_reg(a, c + 0);
		}
		break;
	case 231:  /* LOADP */
		_label(LEFT_CHILD(a));
		c = ((struct _state*)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + move(a);
		if (c + 0 < p->cost[_reg_NT]) {  /* reg : LOADP(reg) */
			p->cost[_reg_NT] = c + 0;
			p->rule._reg = 40;
			_closure_reg(a, c + 0);
		}
		break;
	case 228:  /* LOADS */
		_label(LEFT_CHILD(a));
		c = ((struct _state*)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + move(a);
		if (c + 0 < p->cost[_reg_NT]) {  /* reg : LOADS(reg) */
			p->cost[_reg_NT] = c + 0;
			p->rule._reg = 41;
			_closure_reg(a, c + 0);
		}
		break;
	case 230:  /* LOADU */
		_label(LEFT_CHILD(a));
		c = ((struct _state*)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + move(a);
		if (c + 0 < p->cost[_reg_NT]) {  /* reg : LOADU(reg) */
			p->cost[_reg_NT] = c + 0;
			p->rule._reg = 42;
			_closure_reg(a, c + 0);
		}
		break;
	case 341:  /* LSHI */
		_label(LEFT_CHILD(a));
		_label(RIGHT_CHILD(a));
		c = ((struct _state*)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + ((struct _state*)(RIGHT_CHILD(a)->x.state))->cost[_rc5_NT] + 1;
		if (c + 0 < p->cost[_reg_NT]) {  /* reg : LSHI(reg,rc5) */
			p->cost[_reg_NT] = c + 0;
			p->rule._reg = 58;
			_closure_reg(a, c + 0);
		}
		break;
	case 342:  /* LSHU */
		_label(LEFT_CHILD(a));
		_label(RIGHT_CHILD(a));
		c = ((struct _state*)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + ((struct _state*)(RIGHT_CHILD(a)->x.state))->cost[_rc5_NT] + 1;
		if (c + 0 < p->cost[_reg_NT]) {  /* reg : LSHU(reg,rc5) */
			p->cost[_reg_NT] = c + 0;
			p->rule._reg = 59;
			_closure_reg(a, c + 0);
		}
		break;
	case 546:  /* LTD */
		_label(LEFT_CHILD(a));
		_label(RIGHT_CHILD(a));
		c = ((struct _state*)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + ((struct _state*)(RIGHT_CHILD(a)->x.state))->cost[_reg_NT] + 4;
		if (c + 0 < p->cost[_stmt_NT]) {  /* stmt : LTD(reg,reg) */
			p->cost[_stmt_NT] = c + 0;
			p->rule._stmt = 51;
		}
		break;
	case 545:  /* LTF */
		_label(LEFT_CHILD(a));
		_label(RIGHT_CHILD(a));
		c = ((struct _state*)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + ((struct _state*)(RIGHT_CHILD(a)->x.state))->cost[_reg_NT] + 4;
		if (c + 0 < p->cost[_stmt_NT]) {  /* stmt : LTF(reg,reg) */
			p->cost[_stmt_NT] = c + 0;
			p->rule._stmt = 52;
		}
		break;
	case 549:  /* LTI */
		_label(LEFT_CHILD(a));
		_label(RIGHT_CHILD(a));
		c = ((struct _state*)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + ((struct _state*)(RIGHT_CHILD(a)->x.state))->cost[_rc_NT] + 3;
		if (c + 0 < p->cost[_stmt_NT]) {  /* stmt : LTI(reg,rc) */
			p->cost[_stmt_NT] = c + 0;
			p->rule._stmt = 31;
		}
		break;
	case 550:  /* LTU */
		_label(LEFT_CHILD(a));
		_label(RIGHT_CHILD(a));
		c = ((struct _state*)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + ((struct _state*)(RIGHT_CHILD(a)->x.state))->cost[_rc_NT] + 3;
		if (c + 0 < p->cost[_stmt_NT]) {  /* stmt : LTU(reg,rc) */
			p->cost[_stmt_NT] = c + 0;
			p->rule._stmt = 32;
		}
		break;
	case 357:  /* MODI */
		_label(LEFT_CHILD(a));
		_label(RIGHT_CHILD(a));
		c = ((struct _state*)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + ((struct _state*)(RIGHT_CHILD(a)->x.state))->cost[_reg_NT] + 2;
		if (c + 0 < p->cost[_reg_NT]) {  /* reg : MODI(reg,reg) */
			p->cost[_reg_NT] = c + 0;
			p->rule._reg = 76;
			_closure_reg(a, c + 0);
		}
		break;
	case 358:  /* MODU */
		_label(LEFT_CHILD(a));
		_label(RIGHT_CHILD(a));
		c = ((struct _state*)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + ((struct _state*)(RIGHT_CHILD(a)->x.state))->cost[_reg_NT] + 2;
		if (c + 0 < p->cost[_reg_NT]) {  /* reg : MODU(reg,reg) */
			p->cost[_reg_NT] = c + 0;
			p->rule._reg = 77;
			_closure_reg(a, c + 0);
		}
		break;
	case 466:  /* MULD */
		_label(LEFT_CHILD(a));
		_label(RIGHT_CHILD(a));
		c = ((struct _state*)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + ((struct _state*)(RIGHT_CHILD(a)->x.state))->cost[_reg_NT] + 1;
		if (c + 0 < p->cost[_reg_NT]) {  /* reg : MULD(reg,reg) */
			p->cost[_reg_NT] = c + 0;
			p->rule._reg = 84;
			_closure_reg(a, c + 0);
		}
		break;
	case 465:  /* MULF */
		_label(LEFT_CHILD(a));
		_label(RIGHT_CHILD(a));
		c = ((struct _state*)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + ((struct _state*)(RIGHT_CHILD(a)->x.state))->cost[_reg_NT] + 1;
		if (c + 0 < p->cost[_reg_NT]) {  /* reg : MULF(reg,reg) */
			p->cost[_reg_NT] = c + 0;
			p->rule._reg = 85;
			_closure_reg(a, c + 0);
		}
		break;
	case 469:  /* MULI */
		_label(LEFT_CHILD(a));
		_label(RIGHT_CHILD(a));
		c = ((struct _state*)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + ((struct _state*)(RIGHT_CHILD(a)->x.state))->cost[_reg_NT] + 2;
		if (c + 0 < p->cost[_reg_NT]) {  /* reg : MULI(reg,reg) */
			p->cost[_reg_NT] = c + 0;
			p->rule._reg = 78;
			_closure_reg(a, c + 0);
		}
		break;
	case 470:  /* MULU */
		_label(LEFT_CHILD(a));
		_label(RIGHT_CHILD(a));
		c = ((struct _state*)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + ((struct _state*)(RIGHT_CHILD(a)->x.state))->cost[_reg_NT] + 2;
		if (c + 0 < p->cost[_reg_NT]) {  /* reg : MULU(reg,reg) */
			p->cost[_reg_NT] = c + 0;
			p->rule._reg = 79;
			_closure_reg(a, c + 0);
		}
		break;
	case 562:  /* NED */
		_label(LEFT_CHILD(a));
		_label(RIGHT_CHILD(a));
		c = ((struct _state*)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + ((struct _state*)(RIGHT_CHILD(a)->x.state))->cost[_reg_NT] + 4;
		if (c + 0 < p->cost[_stmt_NT]) {  /* stmt : NED(reg,reg) */
			p->cost[_stmt_NT] = c + 0;
			p->rule._stmt = 53;
		}
		break;
	case 561:  /* NEF */
		_label(LEFT_CHILD(a));
		_label(RIGHT_CHILD(a));
		c = ((struct _state*)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + ((struct _state*)(RIGHT_CHILD(a)->x.state))->cost[_reg_NT] + 4;
		if (c + 0 < p->cost[_stmt_NT]) {  /* stmt : NEF(reg,reg) */
			p->cost[_stmt_NT] = c + 0;
			p->rule._stmt = 54;
		}
		break;
	case 194:  /* NEGD */
		_label(LEFT_CHILD(a));
		c = ((struct _state*)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + 2;
		if (c + 0 < p->cost[_reg_NT]) {  /* reg : NEGD(reg) */
			p->cost[_reg_NT] = c + 0;
			p->rule._reg = 95;
			_closure_reg(a, c + 0);
		}
		break;
	case 193:  /* NEGF */
		_label(LEFT_CHILD(a));
		c = ((struct _state*)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + 1;
		if (c + 0 < p->cost[_reg_NT]) {  /* reg : NEGF(reg) */
			p->cost[_reg_NT] = c + 0;
			p->rule._reg = 88;
			_closure_reg(a, c + 0);
		}
		break;
	case 197:  /* NEGI */
		_label(LEFT_CHILD(a));
		c = ((struct _state*)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + 1;
		if (c + 0 < p->cost[_reg_NT]) {  /* reg : NEGI(reg) */
			p->cost[_reg_NT] = c + 0;
			p->rule._reg = 65;
			_closure_reg(a, c + 0);
		}
		break;
	case 565:  /* NEI */
		_label(LEFT_CHILD(a));
		_label(RIGHT_CHILD(a));
		c = ((struct _state*)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + ((struct _state*)(RIGHT_CHILD(a)->x.state))->cost[_rc_NT] + 3;
		if (c + 0 < p->cost[_stmt_NT]) {  /* stmt : NEI(reg,rc) */
			p->cost[_stmt_NT] = c + 0;
			p->rule._stmt = 33;
		}
		break;
	case 242:  /* RETD */
		_label(LEFT_CHILD(a));
		c = ((struct _state*)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + 1;
		if (c + 0 < p->cost[_stmt_NT]) {  /* stmt : RETD(reg) */
			p->cost[_stmt_NT] = c + 0;
			p->rule._stmt = 36;
		}
		break;
	case 241:  /* RETF */
		_label(LEFT_CHILD(a));
		c = ((struct _state*)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + 1;
		if (c + 0 < p->cost[_stmt_NT]) {  /* stmt : RETF(reg) */
			p->cost[_stmt_NT] = c + 0;
			p->rule._stmt = 37;
		}
		break;
	case 245:  /* RETI */
		_label(LEFT_CHILD(a));
		c = ((struct _state*)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + 1;
		if (c + 0 < p->cost[_stmt_NT]) {  /* stmt : RETI(reg) */
			p->cost[_stmt_NT] = c + 0;
			p->rule._stmt = 38;
		}
		break;
	case 373:  /* RSHI */
		_label(LEFT_CHILD(a));
		_label(RIGHT_CHILD(a));
		c = ((struct _state*)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + ((struct _state*)(RIGHT_CHILD(a)->x.state))->cost[_rc5_NT] + 1;
		if (c + 0 < p->cost[_reg_NT]) {  /* reg : RSHI(reg,rc5) */
			p->cost[_reg_NT] = c + 0;
			p->rule._reg = 60;
			_closure_reg(a, c + 0);
		}
		break;
	case 374:  /* RSHU */
		_label(LEFT_CHILD(a));
		_label(RIGHT_CHILD(a));
		c = ((struct _state*)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + ((struct _state*)(RIGHT_CHILD(a)->x.state))->cost[_rc5_NT] + 1;
		if (c + 0 < p->cost[_reg_NT]) {  /* reg : RSHU(reg,rc5) */
			p->cost[_reg_NT] = c + 0;
			p->rule._reg = 61;
			_closure_reg(a, c + 0);
		}
		break;
	case 322:  /* SUBD */
		_label(LEFT_CHILD(a));
		_label(RIGHT_CHILD(a));
		c = ((struct _state*)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + ((struct _state*)(RIGHT_CHILD(a)->x.state))->cost[_reg_NT] + 1;
		if (c + 0 < p->cost[_reg_NT]) {  /* reg : SUBD(reg,reg) */
			p->cost[_reg_NT] = c + 0;
			p->rule._reg = 86;
			_closure_reg(a, c + 0);
		}
		break;
	case 321:  /* SUBF */
		_label(LEFT_CHILD(a));
		_label(RIGHT_CHILD(a));
		c = ((struct _state*)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + ((struct _state*)(RIGHT_CHILD(a)->x.state))->cost[_reg_NT] + 1;
		if (c + 0 < p->cost[_reg_NT]) {  /* reg : SUBF(reg,reg) */
			p->cost[_reg_NT] = c + 0;
			p->rule._reg = 87;
			_closure_reg(a, c + 0);
		}
		break;
	case 325:  /* SUBI */
		_label(LEFT_CHILD(a));
		_label(RIGHT_CHILD(a));
		c = ((struct _state*)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + ((struct _state*)(RIGHT_CHILD(a)->x.state))->cost[_rc_NT] + 1;
		if (c + 0 < p->cost[_reg_NT]) {  /* reg : SUBI(reg,rc) */
			p->cost[_reg_NT] = c + 0;
			p->rule._reg = 55;
			_closure_reg(a, c + 0);
		}
		break;
	case 327:  /* SUBP */
		_label(LEFT_CHILD(a));
		_label(RIGHT_CHILD(a));
		c = ((struct _state*)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + ((struct _state*)(RIGHT_CHILD(a)->x.state))->cost[_rc_NT] + 1;
		if (c + 0 < p->cost[_reg_NT]) {  /* reg : SUBP(reg,rc) */
			p->cost[_reg_NT] = c + 0;
			p->rule._reg = 56;
			_closure_reg(a, c + 0);
		}
		break;
	case 326:  /* SUBU */
		_label(LEFT_CHILD(a));
		_label(RIGHT_CHILD(a));
		c = ((struct _state*)(LEFT_CHILD(a)->x.state))->cost[_reg_NT] + ((struct _state*)(RIGHT_CHILD(a)->x.state))->cost[_rc_NT] + 1;
		if (c + 0 < p->cost[_reg_NT]) {  /* reg : SUBU(reg,rc) */
			p->cost[_reg_NT] = c + 0;
			p->rule._reg = 57;
			_closure_reg(a, c + 0);
		}
		break;
	case 615:  /* VREGP */
		break;
	default:
		fatal("_label", "Bad terminal %d\n", OP_LABEL(a));
	}
}

static void _kids(p, eruleno, kids) NODEPTR_TYPE p, kids[]; {
	if (!p)
		fatal("_kids", "Null tree\n", 0);
	switch (eruleno) {
	case 1:  /* reg: INDIRC(VREGP) */
	case 2:  /* reg: INDIRD(VREGP) */
	case 3:  /* reg: INDIRF(VREGP) */
	case 4:  /* reg: INDIRI(VREGP) */
	case 5:  /* reg: INDIRP(VREGP) */
	case 6:  /* reg: INDIRS(VREGP) */
	case 13:  /* con: CNSTC */
	case 14:  /* con: CNSTI */
	case 15:  /* con: CNSTP */
	case 16:  /* con: CNSTS */
	case 17:  /* con: CNSTU */
	case 23:  /* reg: ADDRGP */
	case 24:  /* stk13: ADDRFP */
	case 25:  /* stk13: ADDRLP */
	case 27:  /* stk: ADDRFP */
	case 28:  /* stk: ADDRLP */
	case 29:  /* reg: ADDRFP */
	case 30:  /* reg: ADDRLP */
	case 31:  /* con13: CNSTC */
	case 32:  /* con13: CNSTI */
	case 33:  /* con13: CNSTP */
	case 34:  /* con13: CNSTS */
	case 35:  /* con13: CNSTU */
	case 57:  /* addrl: ADDRLP */
	case 62:  /* spill: ADDRLP */
	case 90:  /* reg: CNSTC */
	case 91:  /* reg: CNSTI */
	case 92:  /* reg: CNSTP */
	case 93:  /* reg: CNSTS */
	case 94:  /* reg: CNSTU */
	case 107:  /* rc5: CNSTI */
	case 122:  /* addrg: ADDRGP */
	case 125:  /* stmt: LABELV */
	case 136:  /* call: ADDRGP */
		break;
	case 69:  /* reg: CVCI(INDIRC(addr)) */
	case 70:  /* reg: CVSI(INDIRS(addr)) */
	case 71:  /* reg: CVCU(INDIRC(addr)) */
	case 72:  /* reg: CVSU(INDIRS(addr)) */
		kids[0] = LEFT_CHILD(LEFT_CHILD(p));
		break;
	case 19:  /* reg: CVIU(reg) */
	case 20:  /* reg: CVPU(reg) */
	case 21:  /* reg: CVUI(reg) */
	case 22:  /* reg: CVUP(reg) */
	case 47:  /* reg: INDIRC(addr) */
	case 48:  /* reg: INDIRS(addr) */
	case 49:  /* reg: INDIRI(addr) */
	case 50:  /* reg: INDIRP(addr) */
	case 51:  /* reg: INDIRF(addr) */
	case 58:  /* reg: INDIRD(addrl) */
	case 60:  /* reg: INDIRD(base) */
	case 73:  /* reg: CVIC(reg) */
	case 74:  /* reg: CVIS(reg) */
	case 75:  /* reg: CVIU(reg) */
	case 76:  /* reg: CVPU(reg) */
	case 77:  /* reg: CVUC(reg) */
	case 78:  /* reg: CVUI(reg) */
	case 79:  /* reg: CVUP(reg) */
	case 80:  /* reg: CVUS(reg) */
	case 81:  /* reg: CVIC(reg) */
	case 82:  /* reg: CVIS(reg) */
	case 83:  /* reg: CVUC(reg) */
	case 84:  /* reg: CVUS(reg) */
	case 85:  /* reg: LOADC(reg) */
	case 86:  /* reg: LOADI(reg) */
	case 87:  /* reg: LOADP(reg) */
	case 88:  /* reg: LOADS(reg) */
	case 89:  /* reg: LOADU(reg) */
	case 116:  /* reg: NEGI(reg) */
	case 117:  /* reg: BCOMU(reg) */
	case 118:  /* reg: CVCI(reg) */
	case 119:  /* reg: CVSI(reg) */
	case 120:  /* reg: CVCU(reg) */
	case 121:  /* reg: CVSU(reg) */
	case 123:  /* stmt: JUMPV(addrg) */
	case 124:  /* stmt: JUMPV(addr) */
	case 138:  /* reg: CALLD(call) */
	case 139:  /* reg: CALLF(call) */
	case 140:  /* reg: CALLI(call) */
	case 141:  /* stmt: CALLV(call) */
	case 143:  /* stmt: RETD(reg) */
	case 144:  /* stmt: RETF(reg) */
	case 145:  /* stmt: RETI(reg) */
	case 146:  /* stmt: ARGI(reg) */
	case 147:  /* stmt: ARGP(reg) */
	case 148:  /* stmt: ARGD(reg) */
	case 149:  /* stmt: ARGF(reg) */
	case 164:  /* reg: NEGF(reg) */
	case 165:  /* reg: LOADF(reg) */
	case 166:  /* reg: CVDF(reg) */
	case 167:  /* reg: CVFD(reg) */
	case 168:  /* reg: CVDI(reg) */
	case 169:  /* reg: CVID(reg) */
	case 182:  /* reg: LOADD(reg) */
	case 183:  /* reg: NEGD(reg) */
		kids[0] = LEFT_CHILD(p);
		break;
	case 113:  /* reg: BANDU(reg,BCOMU(rc)) */
	case 114:  /* reg: BORU(reg,BCOMU(rc)) */
	case 115:  /* reg: BXORU(reg,BCOMU(rc)) */
	case 184:  /* stmt: ASGNB(reg,INDIRB(reg)) */
		kids[0] = LEFT_CHILD(p);
		kids[1] = LEFT_CHILD(RIGHT_CHILD(p));
		break;
	case 36:  /* base: ADDI(reg,con13) */
	case 37:  /* base: ADDP(reg,con13) */
	case 38:  /* base: ADDU(reg,con13) */
	case 43:  /* addr: ADDI(reg,reg) */
	case 44:  /* addr: ADDP(reg,reg) */
	case 45:  /* addr: ADDU(reg,reg) */
	case 52:  /* stmt: ASGNC(addr,reg) */
	case 53:  /* stmt: ASGNS(addr,reg) */
	case 54:  /* stmt: ASGNI(addr,reg) */
	case 55:  /* stmt: ASGNP(addr,reg) */
	case 56:  /* stmt: ASGNF(addr,reg) */
	case 59:  /* stmt: ASGND(addrl,reg) */
	case 61:  /* stmt: ASGND(base,reg) */
	case 63:  /* stmt: ASGNC(spill,reg) */
	case 64:  /* stmt: ASGNS(spill,reg) */
	case 65:  /* stmt: ASGNI(spill,reg) */
	case 66:  /* stmt: ASGNP(spill,reg) */
	case 67:  /* stmt: ASGNF(spill,reg) */
	case 68:  /* stmt: ASGND(spill,reg) */
	case 98:  /* reg: ADDI(reg,rc) */
	case 99:  /* reg: ADDP(reg,rc) */
	case 100:  /* reg: ADDU(reg,rc) */
	case 101:  /* reg: BANDU(reg,rc) */
	case 102:  /* reg: BORU(reg,rc) */
	case 103:  /* reg: BXORU(reg,rc) */
	case 104:  /* reg: SUBI(reg,rc) */
	case 105:  /* reg: SUBP(reg,rc) */
	case 106:  /* reg: SUBU(reg,rc) */
	case 109:  /* reg: LSHI(reg,rc5) */
	case 110:  /* reg: LSHU(reg,rc5) */
	case 111:  /* reg: RSHI(reg,rc5) */
	case 112:  /* reg: RSHU(reg,rc5) */
	case 126:  /* stmt: EQI(reg,rc) */
	case 127:  /* stmt: GEI(reg,rc) */
	case 128:  /* stmt: GEU(reg,rc) */
	case 129:  /* stmt: GTI(reg,rc) */
	case 130:  /* stmt: GTU(reg,rc) */
	case 131:  /* stmt: LEI(reg,rc) */
	case 132:  /* stmt: LEU(reg,rc) */
	case 133:  /* stmt: LTI(reg,rc) */
	case 134:  /* stmt: LTU(reg,rc) */
	case 135:  /* stmt: NEI(reg,rc) */
	case 142:  /* stmt: CALLB(call,reg) */
	case 150:  /* reg: DIVI(reg,reg) */
	case 151:  /* reg: DIVU(reg,reg) */
	case 152:  /* reg: MODI(reg,reg) */
	case 153:  /* reg: MODU(reg,reg) */
	case 154:  /* reg: MULI(reg,reg) */
	case 155:  /* reg: MULU(reg,reg) */
	case 156:  /* reg: ADDD(reg,reg) */
	case 157:  /* reg: ADDF(reg,reg) */
	case 158:  /* reg: DIVD(reg,reg) */
	case 159:  /* reg: DIVF(reg,reg) */
	case 160:  /* reg: MULD(reg,reg) */
	case 161:  /* reg: MULF(reg,reg) */
	case 162:  /* reg: SUBD(reg,reg) */
	case 163:  /* reg: SUBF(reg,reg) */
	case 170:  /* stmt: EQD(reg,reg) */
	case 171:  /* stmt: EQF(reg,reg) */
	case 172:  /* stmt: GED(reg,reg) */
	case 173:  /* stmt: GEF(reg,reg) */
	case 174:  /* stmt: GTD(reg,reg) */
	case 175:  /* stmt: GTF(reg,reg) */
	case 176:  /* stmt: LED(reg,reg) */
	case 177:  /* stmt: LEF(reg,reg) */
	case 178:  /* stmt: LTD(reg,reg) */
	case 179:  /* stmt: LTF(reg,reg) */
	case 180:  /* stmt: NED(reg,reg) */
	case 181:  /* stmt: NEF(reg,reg) */
		kids[0] = LEFT_CHILD(p);
		kids[1] = RIGHT_CHILD(p);
		break;
	case 7:  /* stmt: ASGNC(VREGP,reg) */
	case 8:  /* stmt: ASGND(VREGP,reg) */
	case 9:  /* stmt: ASGNF(VREGP,reg) */
	case 10:  /* stmt: ASGNI(VREGP,reg) */
	case 11:  /* stmt: ASGNP(VREGP,reg) */
	case 12:  /* stmt: ASGNS(VREGP,reg) */
		kids[0] = RIGHT_CHILD(p);
		break;
	case 18:  /* stmt: reg */
	case 26:  /* reg: stk13 */
	case 39:  /* base: reg */
	case 40:  /* base: con13 */
	case 41:  /* base: stk13 */
	case 42:  /* addr: base */
	case 46:  /* addr: stk */
	case 95:  /* reg: con */
	case 96:  /* rc: con13 */
	case 97:  /* rc: reg */
	case 108:  /* rc5: reg */
	case 137:  /* call: addr */
		kids[0] = p;
		break;
	default:
		fatal("_kids", "Bad rule number %d\n", eruleno);
	}
}
static void progend(){}
static void progbeg(argc, argv) char *argv[]; {
	int i;

	{
		union {
			char c;
			int i;
		} u;
		u.i = 0;
		u.c = 1;
		swap = (u.i == 1) != IR->little_endian;
	}
	parseflags(argc, argv);
	for (i = 0; i < argc; i++)
		if (strcmp(argv[i], "-p") == 0 || strcmp(argv[i], "-pg") == 0)
			pflag = 1;
	for (i = 0; i < 8; i++) {
		greg[i +  0] = mkreg(stringf("g%d", i), i +  0, 1, IREG);
		greg[i +  8] = mkreg(stringf("o%d", i), i +  8, 1, IREG);
		greg[i + 16] = mkreg(stringf("l%d", i), i + 16, 1, IREG);
		greg[i + 24] = mkreg(stringf("i%d", i), i + 24, 1, IREG);
	}
	for (i = 0; i < 32; i++)
		freg[i]  = mkreg("%d", i, 1, FREG);
	for (i = 0; i < 31; i += 2)
		freg2[i] = mkreg("%d", i, 3, FREG);
	rmap[C] = rmap[S] = rmap[P] = rmap[B] = rmap[U] = rmap[I] =
		mkwildcard(greg);
	rmap[F] = mkwildcard(freg);
	rmap[D] = mkwildcard(freg2);
	tmask[IREG] = 0x3fff3e00;
	vmask[IREG] = 0x3ff00000;
	tmask[FREG]  = ~(unsigned)0;
	vmask[FREG]  =  0;
}
static void target(p) Node p; {
	assert(p);
	switch (p->op) {
	case CNSTC: case CNSTI: case CNSTS: case CNSTU: case CNSTP:
		if (range(p, 0, 0) == 0) {
			setreg(p, greg[0]);
			p->x.registered = 1;
		}
		break;
	case CALLD:     setreg(p, freg2[0]);     break;
	case CALLF:     setreg(p, freg[0]);      break;
	case CALLI:
	case CALLV:     setreg(p, oreg[0]);      break;
	case RETD:      rtarget(p, 0, freg2[0]); break;
	case RETF:      rtarget(p, 0, freg[0]);  break;
	case RETI:
		rtarget(p, 0, ireg[0]);
		p->kids[0]->x.registered = 1;
		break;
	case ARGI: case ARGP:
		if (p->syms[RX]->u.c.v.i < 6) {
			rtarget(p, 0, oreg[p->syms[RX]->u.c.v.i]);
			p->op = LOAD+optype(p->op);
			setreg(p, oreg[p->syms[RX]->u.c.v.i]);
		}
		break;
	case DIVI: case MODI: case MULI:
	case DIVU: case MODU: case MULU:
		setreg(p, oreg[0]);
		rtarget(p, 0, oreg[0]);
		rtarget(p, 1, oreg[1]);
		break;
	}
}
static void clobber(p) Node p; {
	assert(p);
	switch (p->op) {
	case CALLB: case CALLD: case CALLF: case CALLI:
		spill(~(unsigned)3, FREG, p);
		break;
	case CALLV:
		spill(oreg[0]->x.regnode->mask, IREG, p);
		spill(~(unsigned)3, FREG, p);
		break;
	case ARGF:
		if (p->syms[2]->u.c.v.i <= 6)
			spill((1 << (p->syms[2]->u.c.v.i + 8)), IREG, p);
		break;
	case ARGD:
		if (p->syms[2]->u.c.v.i <= 5)
			spill((3 << (p->syms[2]->u.c.v.i + 8))&0xff00, IREG, p);
		break;
	case DIVI: case MODI: case MULI:
	case DIVU: case MODU: case MULU:
		spill(0x00003e00, IREG, p); break;
	}
}
static int imm(p) Node p; {
	return range(p, -4096, 4095);
}
static void doarg(p) Node p; {
	assert(p && p->syms[0] && p->op != ARG+B);
	p->syms[RX] = intconst(mkactual(4, p->syms[0]->u.c.v.i)/4);
}
static void emit2(p) Node p; {
	switch (p->op) {
	case ARGF: {
		int n = p->syms[RX]->u.c.v.i;
		print("st %%f%d,[%%sp+4*%d+68]\n", getregnum(p->x.kids[0]), n);
		if (n <= 5)
			print("ld [%%sp+4*%d+68],%%o%d\n", n, n);
		break;
	}
	case ARGD: {
		int n = p->syms[RX]->u.c.v.i;
		int src = getregnum(p->x.kids[0]);
		print("st %%f%d,[%%sp+4*%d+68]\n", src, n);
		print("st %%f%d,[%%sp+4*%d+68]\n", src+1, n+1);
		if (n <= 5)
			print("ld [%%sp+4*%d+68],%%o%d\n", n, n);
		if (n <= 4)
			print("ld [%%sp+4*%d+68],%%o%d\n", n+1, n+1);
		break;
	}
	case LOADD: {
		int dst = getregnum(p);
		int src = getregnum(p->x.kids[0]);
		print("fmovs %%f%d,%%f%d; ", src,   dst);
		print("fmovs %%f%d,%%f%d\n", src+1, dst+1);
		break;
	}
	case NEGD: {
		int dst = getregnum(p);
		int src = getregnum(p->x.kids[0]);
		print("fnegs %%f%d,%%f%d; ", src,   dst);
		print("fmovs %%f%d,%%f%d\n", src+1, dst+1);
		break;
	}
	case ASGNB: {
		static int tmpregs[] = { 1, 2, 3 };
		dalign = salign = p->syms[1]->u.c.v.i;
		blkcopy(getregnum(p->x.kids[0]), 0,
			getregnum(p->x.kids[1]), 0,
			p->syms[0]->u.c.v.i, tmpregs);
		break;
	}
	}
}
static void local(p) Symbol p; {
	if (retstruct) {
		p->x.name = stringd(4*16);
		p->x.offset = 4*16;
		retstruct = 0;
		return;
	}
	if (isscalar(p->type) && !p->addressed && !isfloat(p->type))
		p->sclass = REGISTER;
	if (glevel && glevel != 3) p->sclass = AUTO;	/* glevel!=3 is for Norman's debugger */
	if (askregvar(p, rmap[ttob(p->type)]) == 0)
		mkauto(p);
}
static void function(f, caller, callee, ncalls)
Symbol f, callee[], caller[]; {
	int autos = 0, i, leaf, reg, varargs;

	for (i = 0; callee[i]; i++)
		;
	varargs = variadic(f->type)
		|| i > 0 && strcmp(callee[i-1]->name,
			"__builtin_va_alist") == 0;
	usedmask[0] = usedmask[1] = 0;
	freemask[0] = freemask[1] = ~(unsigned)0;
	for (i = 0; i < 8; i++)
		ireg[i]->x.regnode->vbl = NULL;
	offset = 68;
	maxargoffset = 24;
	reg = 0;
	for (i = 0; callee[i]; i++) {
		Symbol p = callee[i], q = caller[i];
		int size = roundup(q->type->size, 4);
		assert(q);
		if (isfloat(p->type) || reg >= 6) {
			p->x.offset = q->x.offset = offset;
			p->x.name = q->x.name = stringd(offset);
			p->sclass = q->sclass = AUTO;
			autos++;
		}
		else if (p->addressed || varargs)
			{
				p->x.offset = offset;
				p->x.name = stringd(p->x.offset);
				p->sclass = AUTO;
				q->sclass = REGISTER;
				askregvar(q, ireg[reg]);
				assert(q->x.regnode);
				autos++;
			}
		else if (glevel && glevel != 3) {
							p->x.offset = offset;
							p->x.name = stringd(p->x.offset);
							p->sclass = AUTO;
							q->sclass = REGISTER;
							askregvar(q, ireg[reg]);
							assert(q->x.regnode);
							autos++;
						}

		else {
			p->sclass = q->sclass = REGISTER;
			askregvar(p, ireg[reg]);
			assert(p->x.regnode);
			q->x.name = p->x.name;
		}
		offset += size;
		reg += isstruct(p->type) ? 1 : size/4;
	}
	assert(caller[i] == 0);
	offset = maxoffset = 0;
	retstruct = isstruct(freturn(f->type));
	gencode(caller, callee);
	maxargoffset = roundup(maxargoffset, 4);
	framesize = roundup(maxoffset + maxargoffset + 4*(16 + 1), 8);
	assert(!varargs || autos);
	leaf = (!ncalls
		&& !maxoffset && !autos
		&& !isstruct(freturn(f->type))
		&& !(usedmask[IREG]&0x00ffff01) && !(usedmask[FREG]&~(unsigned)3)
		&& !pflag && !glevel);
	print(".align 4\n.proc 4\n%s:\n", f->x.name);
	if (leaf) {
		for (i = 0; caller[i] && callee[i]; i++) {
			Symbol p = caller[i], q = callee[i];
			if (p->sclass == REGISTER && q->sclass == REGISTER)
				assert(q->x.regnode),
				assert(q->x.regnode->set == IREG),
				assert(q->x.regnode->number >= 24),
				assert(q->x.regnode->number <= 31),
				p->x.name = greg[q->x.regnode->number - 16]->x.name;
			}
		rename();
	} else if (framesize <= 4095)
		print("save %%sp,%d,%%sp\n", -framesize);
	else
		print("set %d,%%g1; save %%sp,%%g1,%%sp\n", -framesize);
	if (varargs)
		for (; reg < 6; reg++)
			print("st %%i%d,[%%fp+%d]\n", reg, 4*reg + 68);
	else
		offset = 4*(16 + 1);
		reg = 0;
		for (i = 0; caller[i]; i++) {
			Symbol p = caller[i];
			if (isdouble(p->type) && reg <= 4) {
				print("st %%r%d,[%%fp+%d]\n",
					ireg[reg++]->x.regnode->number, offset);
				print("st %%r%d,[%%fp+%d]\n",
					ireg[reg++]->x.regnode->number, offset + 4);
			} else if (isfloat(p->type) && reg <= 5)
				print("st %%r%d,[%%fp+%d]\n",
					ireg[reg++]->x.regnode->number, offset);
			else
				reg++;
			offset += roundup(p->type->size, 4);
		}
	if (pflag) {
		int lab = genlabel(1);
		print("set L%d,%%o0; call mcount; nop\n", lab);
		print(".seg \"data\"\n.align 4; L%d:.word 0\n.seg \"text\"\n", lab);
	}
	emitcode();
	if (!leaf)
		print("ret; restore\n");
	else {
		rename();
		print("retl; nop\n");
	}
}
#define exch(x, y, t) (((t) = x), ((x) = (y)), ((y) = (t)))

static void rename() {
	int i;

	for (i = 0; i < 8; i++) {
		char *ptmp;
		int itmp;
		if (ireg[i]->x.regnode->vbl)
			ireg[i]->x.regnode->vbl->x.name = oreg[i]->x.name;
		exch(ireg[i]->x.name, oreg[i]->x.name, ptmp);
		exch(ireg[i]->x.regnode->number, oreg[i]->x.regnode->number, itmp);
	}
}
static void defconst(ty, v) Value v; {
	switch (ty) {
	case C: print(".byte %d\n",   v.uc); return;
	case S: print(".half %d\n",   v.ss); return;
	case I: print(".word %d\n",   v.i ); return;
	case U: print(".word 0x%x\n", v.u ); return;
	case P: print(".word 0x%x\n", v.p ); return;
	case F:
		print(".word 0x%x\n", *(unsigned *)&v.f);
		return;
case D: {
	unsigned *p = (unsigned *)&v.d;
	print(".word 0x%x\n.word 0x%x\n", p[swap], p[!swap]);
	return;
	}
	}
	assert(0);
}

static void defaddress(p) Symbol p; {
	print(".word %s\n", p->x.name);
}

static void defstring(n, str) char *str; {
	char *s;

	for (s = str; s < str + n; s++)
		print(".byte %d\n", *s);
}

static void address(q, p, n) Symbol q, p; int n; {
	q->x.offset = p->x.offset + n;
	if (p->scope == GLOBAL || p->sclass == STATIC || p->sclass == EXTERN)
		q->x.name = stringf("%s%s%d", p->x.name, n >= 0 ? "+" : "", n);
	else
		q->x.name = stringd(q->x.offset);
}
static void export(p) Symbol p; {
	print(".global %s\n", p->x.name);
}
static void import(p) Symbol p; {}
static void defsymbol(p) Symbol p; {
	if (p->scope >= LOCAL && p->sclass == STATIC)
		p->x.name = stringf("%d", genlabel(1));
	else
		assert(p->scope != CONSTANTS || isint(p->type) || isptr(p->type)),
		p->x.name = p->name;
	if (p->scope >= LABELS)
		p->x.name = stringf(p->generated ? "L%s" : "_%s",
			p->x.name);
}
static void segment(n) {
	cseg = n;
	switch (n) {
	case CODE:	print(".seg \"text\"\n"); break;
	case BSS:	print(".seg \"bss\"\n");  break;
	case DATA:	print(".seg \"data\"\n"); break;
	case LIT:	print(".seg \"text\"\n"); break;
	}
}
static void space(n) {
	if (cseg != BSS)
		print(".skip %d\n", n);
}
static void global(p) Symbol p; {
	print(".align %d\n", p->type->align);
	assert(p->u.seg);
	if (p->u.seg == BSS && (p->sclass == STATIC || Aflag >= 2))
		print(".reserve %s,%d\n", p->x.name, p->type->size);
	else if (p->u.seg == BSS)
		print(".common %s,%d\n",  p->x.name, p->type->size);
	else
		print("%s:\n", p->x.name);
}
static void blkfetch(k, off, reg, tmp) {
	assert(k == 1 || k == 2 || k == 4);
	assert(salign >= k);
	if (k == 1)
		print("ldub [%%r%d+%d],%%r%d\n", reg, off, tmp);
	else if (k == 2)
		print("lduh [%%r%d+%d],%%r%d\n", reg, off, tmp);
	else
		print("ld [%%r%d+%d],%%r%d\n",	 reg, off, tmp);
}
static void blkstore(k, off, reg, tmp) {
	assert(k == 1 || k == 2 || k == 4);
	assert(dalign >= k);
	if (k == 1)
		print("stb %%r%d,[%%r%d+%d]\n", tmp, reg, off);
	else if (k == 2)
		print("sth %%r%d,[%%r%d+%d]\n", tmp, reg, off);
	else
		print("st %%r%d,[%%r%d+%d]\n",	tmp, reg, off);
}
static void blkloop(dreg, doff, sreg, soff, size, tmps)
int tmps[]; {
	if ((size&~7) < 4096) {
		print("add %%r%d,%d,%%r%d\n", sreg, size&~7, sreg);
		print("add %%r%d,%d,%%r%d\n", dreg, size&~7, tmps[2]);
	} else {
		print("set %d,%%r%d\n", size&~7, tmps[2]);
		print("add %%r%d,%%r%d,%%r%d\n", sreg, tmps[2], sreg);
		print("add %%r%d,%%r%d,%%r%d\n", dreg, tmps[2], tmps[2]);
	}
	blkcopy(tmps[2], doff, sreg, soff, size&7, tmps);
	print("1: dec 8,%%r%d\n", tmps[2]);
	blkcopy(tmps[2], doff, sreg, soff - 8, 8, tmps);
	print("cmp %%r%d,%%r%d; ", tmps[2], dreg);
	print("bgt 1b; ");
	print("dec 8,%%r%d\n", sreg);
}
static void defsymbol2(p) Symbol p; {
	if (p->scope >= LOCAL && p->sclass == STATIC)
		p->x.name = stringf(".%d", genlabel(1));
	else
		assert(p->scope != CONSTANTS || isint(p->type) || isptr(p->type)),
		p->x.name = p->name;
	if (p->scope >= LABELS)
		p->x.name = stringf(p->generated ? ".L%s" : "%s",
			p->x.name);
}

static void global2(p) Symbol p; {
	assert(p->u.seg);
	if (p->sclass != STATIC && !p->generated)
		print(".type %s,#%s\n", p->x.name,
			isfunc(p->type) ? "function" : "object");
	if (p->u.seg == BSS && p->sclass == STATIC)
		print(".local %s\n.common %s,%d,%d\n", p->x.name, p->x.name,
			p->type->size, p->type->align);
	else if (p->u.seg == BSS && Aflag >= 2)
		print(".align %d\n%s:.skip %d\n", p->type->align, p->x.name,
			p->type->size);
	else if (p->u.seg == BSS)
		print(".common %s,%d,%d\n", p->x.name, p->type->size, p->type->align);
	else
		print(".align %d\n%s:\n", p->type->align, p->x.name);
}

static void segment2(n) {
	cseg = n;
	switch (n) {
	case CODE:	print(".section \".text\"\n"); break;
	case BSS:	print(".section \".bss\"\n");  break;
	case DATA:	print(".section \".data\"\n"); break;
	case LIT:	print(".section \".rodata\"\n"); break;
	}
}
#ifdef sparc
#include <stab.h>
static char *currentfile;       /* current file name */
static int ntypes;

static void stabblock ARGS((int, int, Symbol*));
static void stabfend ARGS((Symbol, int));
static void stabinit ARGS((char *, int, char *[]));
static void stabline ARGS((Coordinate *));
static void stabsym ARGS((Symbol));
static void stabtype ARGS((Symbol));

static void asgncode ARGS((Type, int));
static void dbxout ARGS((Type));
static int dbxtype ARGS((Type));
static int emittype ARGS((Type, int, int));

/* asgncode - assign type code to ty */
static void asgncode(ty, lev) Type ty; {
	if (ty->x.marked || ty->x.typeno)
		return;
	ty->x.marked = 1;
	switch (ty->op) {
	case VOLATILE: case CONST: case VOLATILE+CONST:
		asgncode(ty->type, lev);
		ty->x.typeno = ty->type->x.typeno;
		break;
	case POINTER: case FUNCTION: case ARRAY:
		asgncode(ty->type, lev + 1);
		/* fall thru */
	case VOID: case CHAR: case SHORT: case INT: case UNSIGNED:
	case FLOAT: case DOUBLE:
		break;
	case STRUCT: case UNION: {
		Field p;
		for (p = fieldlist(ty); p; p = p->link)
			asgncode(p->type, lev + 1);
		/* fall thru */
	case ENUM:
		if (ty->x.typeno == 0)
			ty->x.typeno = ++ntypes;
		if (lev > 0 && (*ty->u.sym->name < '0' || *ty->u.sym->name > '9'))
			dbxout(ty);
		break;
		}
	default:
		assert(0);
	}
}

/* dbxout - output .stabs entry for type ty */
static void dbxout(ty) Type ty; {
	ty = unqual(ty);
	if (!ty->x.printed) {
		int col = 0;
		print(".stabs \""), col += 8;
		if (ty->u.sym && !(isfunc(ty) || isarray(ty) || isptr(ty)))
			print("%s", ty->u.sym->name), col += strlen(ty->u.sym->name);
		print(":%c", isstruct(ty) || isenum(ty) ? 'T' : 't'), col += 2;
		emittype(ty, 0, col);
		print("\",%d,0,0,0\n", N_LSYM);
	}
}

/* dbxtype - emit a stabs entry for type ty, return type code */
static int dbxtype(ty) Type ty; {
	asgncode(ty, 0);
	dbxout(ty);
	return ty->x.typeno;
}

/*
 * emittype - emit ty's type number, emitting its definition if necessary.
 * Returns the output column number after emission; col is the approximate
 * output column before emission and is used to emit continuation lines for long
 * struct, union, and enum types. Continuations are not emitted for other types,
 * even if the definition is long. lev is the depth of calls to emittype.
 */
static int emittype(ty, lev, col) Type ty; {
	int tc = ty->x.typeno;

	if (isconst(ty) || isvolatile(ty)) {
		col = emittype(ty->type, lev, col);
		ty->x.typeno = ty->type->x.typeno;
		ty->x.printed = 1;
		return col;
	}
	if (tc == 0) {
		ty->x.typeno = tc = ++ntypes;
/*              fprint(2,"`%t'=%d\n", ty, tc); */
	}
	print("%d", tc), col += 3;
	if (ty->x.printed)
		return col;
	ty->x.printed = 1;
	switch (ty->op) {
	case VOID:	/* void is defined as itself */
		print("=%d", tc), col += 1+3;
		break;
	case CHAR:	/* unsigned char is a subrange of int */
		if (ty == unsignedchar)
			print("=r1;0;255;"), col += 10;
		else	/* following pcc, char is a subrange of itself */
			print("=r%d;-128;127;", tc), col += 2+3+10;
		break;
	case SHORT:	/* short is a subrange of int */
		if (ty == unsignedshort)
			print("=r1;0;65535;"), col += 12;
		else	/* signed */
			print("=r1;-32768;32767;"), col += 17;
		break;
	case INT:	/* int is a subrange of itself */
		print("=r1;%d;%d;", INT_MIN, INT_MAX), col += 4+11+1+10+1;
		break;
	case UNSIGNED:	/* unsigned is a subrange of int */
		print("=r1;0;-1;"), col += 9;
		break;
	case FLOAT: case DOUBLE:	/* float, double get sizes instead of ranges */
		print("=r1;%d;0;", ty->size), col += 4+1+3;
		break;
	case POINTER:
		print("=*"), col += 2;
		col = emittype(ty->type, lev + 1, col);
		break;
	case FUNCTION:
		print("=f"), col += 2;
		col = emittype(ty->type, lev + 1, col);
		break;
	case ARRAY:	/* array includes subscript as an int range */
		if (ty->size && ty->type->size)
			print("=ar1;0;%d;", ty->size/ty->type->size - 1), col += 7+3+1;
		else
			print("=ar1;0;-1;"), col += 10;
		col = emittype(ty->type, lev + 1, col);
		break;
	case STRUCT: case UNION: {
		Field p;
		if (!ty->u.sym->defined) {
			print("=x%c%s:", ty->op == STRUCT ? 's' : 'u', ty->u.sym->name);
			col += 2+1+strlen(ty->u.sym->name)+1;
			break;
		}
		if (lev > 0 && (*ty->u.sym->name < '0' || *ty->u.sym->name > '9')) {
			ty->x.printed = 0;
			break;
		}
		print("=%c%d", ty->op == STRUCT ? 's' : 'u', ty->size), col += 1+1+3;
		for (p = fieldlist(ty); p; p = p->link) {
			if (p->name)
				print("%s:", p->name), col += strlen(p->name)+1;
			else
				print(":"), col += 1;
			col = emittype(p->type, lev + 1, col);
			if (p->lsb)
				print(",%d,%d;", 8*p->offset +
					(IR->little_endian ? fieldright(p) : fieldleft(p)),
					fieldsize(p));
			else
				print(",%d,%d;", 8*p->offset, 8*p->type->size);
			col += 1+3+1+3+1;	/* accounts for ,%d,%d; */
			if (col >= 80 && p->link) {
				print("\\\\\",%d,0,0,0\n.stabs \"", N_LSYM);
				col = 8;
			}
		}
		print(";"), col += 1;
		break;
		}
	case ENUM: {
		Symbol *p;
		if (lev > 0 && (*ty->u.sym->name < '0' || *ty->u.sym->name > '9')) {
			ty->x.printed = 0;
			break;
		}
		print("=e"), col += 2;
		for (p = ty->u.sym->u.idlist; *p; p++) {
			print("%s:%d,", (*p)->name, (*p)->u.value), col += strlen((*p)->name)+3;
			if (col >= 80 && p[1]) {
				print("\\\\\",%d,0,0,0\n.stabs \"", N_LSYM);
				col = 8;
			}
		}
		print(";"), col += 1;
		break;
		}
	default:
		assert(0);
	}
	return col;
}

/* stabblock - output a stab entry for '{' or '}' at level lev */
static void stabblock(brace, lev, p) Symbol *p; {
	if (brace == '{')
		while (*p)
			stabsym(*p++);
	print(".stabd 0x%x,0,%d\n", brace == '{' ? N_LBRAC : N_RBRAC, lev);
}

/* stabfend - end of function p */
static void stabfend(p, line) Symbol p; {}

/* stabinit - initialize stab output */
static void stabinit(file, argc, argv) char *file, *argv[]; {
	typedef void (*Closure) ARGS((Symbol, void *));

	if (file && *file) {
		(*IR->segment)(CODE);
		print("Ltext:.stabs \"%s\",0x%x,0,0,Ltext\n", file, N_SO);
		currentfile = file;
	}
	dbxtype(inttype);
	dbxtype(chartype);
	dbxtype(doubletype);
	dbxtype(floattype);
	dbxtype(longdouble);
	dbxtype(longtype);
	dbxtype(shorttype);
	dbxtype(signedchar);
	dbxtype(unsignedchar);
	dbxtype(unsignedlong);
	dbxtype(unsignedshort);
	dbxtype(unsignedtype);
	dbxtype(voidtype);
	foreach(types, GLOBAL, (Closure)stabtype, NULL);
}

/* stabline - emit stab entry for source coordinate *cp */
static void stabline(cp) Coordinate *cp; {
	if (cp->file && cp->file != currentfile) {
		int lab = genlabel(1);
		print("L%d: .stabs \"%s\",0x%x,0,0,L%d\n", lab,
				cp->file, N_SOL, lab);
		currentfile = cp->file;
	}
	print(".stabd 0x%x,0,%d\n", N_SLINE, cp->y);
}

/* stabsym - output a stab entry for symbol p */
static void stabsym(p) Symbol p; {
	int code, tc, sz = p->type->size;

	if (p->generated || p->computed)
		return;
	if (isfunc(p->type)) {
		print(".stabs \"%s:%c%d\",%d,0,0,%s\n", p->name,
			p->sclass == STATIC ? 'f' : 'F', dbxtype(freturn(p->type)),
			N_FUN, p->x.name);
		return;
	}
	if (!IR->wants_argb && p->scope == PARAM && p->structarg) {
		assert(isptr(p->type) && isstruct(p->type->type));
		tc = dbxtype(p->type->type);
		sz = p->type->type->size;
	} else
		tc = dbxtype(p->type);
	if (p->sclass == AUTO && p->scope == GLOBAL || p->sclass == EXTERN) {
		print(".stabs \"%s:G", p->name);
		code = N_GSYM;
	} else if (p->sclass == STATIC) {
		print(".stabs \"%s:%c%d\",%d,0,0,%s\n", p->name, p->scope == GLOBAL ? 'S' : 'V',
			tc, p->u.seg == BSS ? N_LCSYM : N_STSYM, p->x.name);
		return;
	} else if (p->sclass == REGISTER) {
		if (p->scope > PARAM) {
			int r = p->x.regnode->number;
			if (p->x.regnode->set == FREG)
				r += 32;	/* floating point */
			print(".stabs \"%s:r%d\",%d,0,", p->name, tc, N_RSYM);
			print("%d,%d\n", sz, r);
		}
		return;
	} else if (p->scope == PARAM) {
		print(".stabs \"%s:p", p->name);
		code = N_PSYM;
	} else if (p->scope >= LOCAL) {
		print(".stabs \"%s:", p->name);
		code = N_LSYM;
	} else
		assert(0);
	print("%d\",%d,0,0,%s\n", tc, code,
		p->scope >= PARAM && p->sclass != EXTERN ? p->x.name : "0");
}

/* stabtype - output a stab entry for type *p */
static void stabtype(p) Symbol p; {
	if (p->type) {
		if (p->sclass == 0)
			dbxtype(p->type);
		else if (p->sclass == TYPEDEF)
			print(".stabs \"%s:t%d\",%d,0,0,0\n", p->name, dbxtype(p->type), N_LSYM);
	}
}
#else
#define stabblock 0
#define stabinit 0
#define stabline 0
#define stabsym 0
#define stabtype 0
#endif
Interface sparcInterface = {
	1, 1, 0,  /* char */
	2, 2, 0,  /* short */
	4, 4, 0,  /* int */
	4, 4, 1,  /* float */
	8, 8, 1,  /* double */
	4, 4, 0,  /* T * */
	0, 1, 0,  /* struct */
	0,  /* little_endian */
	1,  /* mulops_calls */
	1,  /* wants_callb */
	0,  /* wants_argb */
	1,  /* left_to_right */
	0,  /* wants_dag */
	address,
	blockbeg,
	blockend,
	defaddress,
	defconst,
	defstring,
	defsymbol,
	emit,
	export,
	function,
	gen,
	global,
	import,
	local,
	progbeg,
	progend,
	segment,
	space,
	stabblock, 0, 0, stabinit, stabline, stabsym, stabtype,
	{
		1,  /* max_unaligned_load */
		blkfetch, blkstore, blkloop,
		_label,
		_rule,
		_nts,
		_kids,
		_opname,
		_arity,
		_string,
		_templates,
		_isinstruction,
		_ntname,
		emit2,
		doarg,
		target,
		clobber,

	}
};

Interface solarisInterface = {
	1, 1, 0,  /* char */
	2, 2, 0,  /* short */
	4, 4, 0,  /* int */
	4, 4, 1,  /* float */
	8, 8, 1,  /* double */
	4, 4, 0,  /* T * */
	0, 1, 0,  /* struct */
	0,	/* little_endian */
	1,	/* mulops_calls */
	1,	/* wants_callb */
	0,	/* wants_argb */
	1,	/* left_to_right */
	0,	/* wants_dag */
	address,
	blockbeg,
	blockend,
	defaddress,
	defconst,
	defstring,
	defsymbol2,
	emit,
	export,
	function,
	gen,
	global2,
	import,
	local,
	progbeg,
	progend,
	segment2,
	space,
	stabblock, 0, 0, stabinit, stabline, stabsym, stabtype,
	{
		1,	/* max_unaligned_load */
		blkfetch, blkstore, blkloop,
		_label,
		_rule,
		_nts,
		_kids,
		_opname,
		_arity,
		_string,
		_templates,
		_isinstruction,
		_ntname,
		emit2,
		doarg,
		target,
		clobber,

	}
};
